/*
 * Keyup Validation in Product Settings
 */
jQuery(function () {

    jQuery('body').on('blur', rewardsystem.field_ids, function () {
        jQuery('.wc_error_tip').fadeOut('100', function () {
            jQuery(this).remove();
        });

        return this;
    });

    jQuery('body').on('keyup change', rewardsystem.field_ids, function () {
        var value = jQuery(this).val();
        console.log(woocommerce_admin.i18n_mon_decimal_error);
        var regex = new RegExp("[^\+0-9\%.\\" + woocommerce_admin.mon_decimal_point + "]+", "gi");
        var newvalue = value.replace(regex, '');

        if (value !== newvalue) {
            jQuery(this).val(newvalue);
            if (jQuery(this).parent().find('.wc_error_tip').size() == 0) {
                jQuery(this).after('<div class="wc_error_tip">' + woocommerce_admin.i18n_mon_decimal_error + " Negative Values are not allowed" + '</div>');
                jQuery('.wc_error_tip')
                        .css('left', offset.left + jQuery(this).width() - (jQuery(this).width() / 2) - (jQuery('.wc_error_tip').width() / 2))
                        .css('top', offset.top + jQuery(this).height())
                        .fadeIn('100');
            }
        }
        return this;
    });



    jQuery("body").click(function () {
        jQuery('.wc_error_tip').fadeOut('100', function () {
            jQuery(this).remove();
        });

    });

    /*Show/Hide Setting for General Tab - Start*/

    /*Show or Hide Roundup/Round Off - Start*/
    if (jQuery('#rs_round_off_type').val() == 1) {
        jQuery('#rs_round_up_down').parent().parent().hide();
        jQuery('#rs_decimal_seperator_check').closest('tr').show();
    } else {
        jQuery('#rs_round_up_down').parent().parent().show();
        jQuery('#rs_decimal_seperator_check').closest('tr').hide();
    }

    jQuery('#rs_round_off_type').change(function () {
        if (jQuery('#rs_round_off_type').val() == 1) {
            jQuery('#rs_round_up_down').parent().parent().hide();
            jQuery('#rs_decimal_seperator_check').closest('tr').show();
        } else {
            jQuery('#rs_round_up_down').parent().parent().show();
            jQuery('#rs_decimal_seperator_check').closest('tr').hide();
        }
    });
    /*Show or Hide Roundup/Round Off - End*/

    /*Show or Hide Maximum Earning Point for each User - Start*/
    if (jQuery('#rs_enable_disable_max_earning_points_for_user').is(":checked") == false) {
        jQuery('#rs_max_earning_points_for_user').parent().parent().hide();
    } else {
        jQuery('#rs_max_earning_points_for_user').parent().parent().show();
    }

    jQuery('#rs_enable_disable_max_earning_points_for_user').change(function () {
        if (jQuery('#rs_enable_disable_max_earning_points_for_user').is(":checked") == false) {
            jQuery('#rs_max_earning_points_for_user').parent().parent().hide();
        } else {
            jQuery('#rs_max_earning_points_for_user').parent().parent().show();
        }
    });
    /*Show or Hide Maximum Earning Point for each User - Ends*/

    /*Show or hide Settings for Member Level - Start*/
    //Show/Hide for User Role
    if (jQuery('#rs_enable_user_role_based_reward_points').is(':checked')) {
        jQuery('.rewardpoints_userrole').parent().parent().show();
    } else {
        jQuery('.rewardpoints_userrole').parent().parent().hide();
    }

    jQuery(document).on('click', '#rs_enable_user_role_based_reward_points', function () {
        if (jQuery(this).is(":checked")) {
            jQuery('.rewardpoints_userrole').parent().parent().show();
        } else {
            jQuery('.rewardpoints_userrole').parent().parent().hide();
        }

    });

    //Show/Hide for Membership
    if (jQuery('#rs_enable_membership_plan_based_reward_points').is(':checked')) {
        jQuery('.rewardpoints_membership_plan').parent().parent().show();
    } else {
        jQuery('.rewardpoints_membership_plan').parent().parent().hide();
    }

    jQuery(document).on('click', '#rs_enable_membership_plan_based_reward_points', function () {
        if (jQuery(this).is(":checked")) {
            jQuery('.rewardpoints_membership_plan').parent().parent().show();
        } else {
            jQuery('.rewardpoints_membership_plan').parent().parent().hide();
        }

    });

    //Show/Hide for Earned Level
    if (jQuery('#rs_enable_earned_level_based_reward_points').is(':checked')) {
        jQuery('.rsdynamicrulecreation').parent().show();
        jQuery('#rs_select_earn_points_based_on').parent().parent().show();
        jQuery('#rs_free_product_range').closest('tr').show();
        jQuery('#rs_free_product_add_by_user_or_admin').closest('tr').show();
        if (jQuery('#rs_free_product_add_by_user_or_admin').val() == '1') {
            jQuery('#rs_order_status_control_to_automatic_order').closest('tr').hide();
            jQuery('#rs_subject_for_free_product_mail').closest('tr').hide();
            jQuery('#rs_content_for_free_product_mail').closest('tr').hide();
            jQuery('#rs_free_product_add_quantity').closest('tr').show();
            if (jQuery('#rs_free_product_add_quantity').val() == '2') {
                jQuery('#rs_free_product_quantity').parent().parent().show();
            } else {
                jQuery('#rs_free_product_quantity').parent().parent().hide();
            }
            jQuery('#rs_free_product_add_quantity').change(function () {
                if (jQuery('#rs_free_product_add_quantity').val() == '2') {
                    jQuery('#rs_free_product_quantity').parent().parent().show();
                } else {
                    jQuery('#rs_free_product_quantity').parent().parent().hide();
                }
            });
        } else {
            jQuery('#rs_order_status_control_to_automatic_order').closest('tr').show();
            jQuery('#rs_subject_for_free_product_mail').closest('tr').show();
            jQuery('#rs_content_for_free_product_mail').closest('tr').show();
            jQuery('#rs_free_product_add_quantity').closest('tr').hide();
            jQuery('#rs_free_product_quantity').parent().parent().hide();
        }

        jQuery('#rs_free_product_add_by_user_or_admin').change(function () {
            if (jQuery('#rs_free_product_add_by_user_or_admin').val() == '1') {
                jQuery('#rs_order_status_control_to_automatic_order').closest('tr').hide();
                jQuery('#rs_subject_for_free_product_mail').closest('tr').hide();
                jQuery('#rs_content_for_free_product_mail').closest('tr').hide();
                jQuery('#rs_free_product_add_quantity').closest('tr').show();
                if (jQuery('#rs_free_product_add_quantity').val() == '2') {
                    jQuery('#rs_free_product_quantity').parent().parent().show();
                } else {
                    jQuery('#rs_free_product_quantity').parent().parent().hide();
                }
                jQuery('#rs_free_product_add_quantity').change(function () {
                    if (jQuery('#rs_free_product_add_quantity').val() == '2') {
                        jQuery('#rs_free_product_quantity').parent().parent().show();
                    } else {
                        jQuery('#rs_free_product_quantity').parent().parent().hide();
                    }
                });
            } else {
                jQuery('#rs_order_status_control_to_automatic_order').closest('tr').show();
                jQuery('#rs_subject_for_free_product_mail').closest('tr').show();
                jQuery('#rs_content_for_free_product_mail').closest('tr').show();
                jQuery('#rs_free_product_add_quantity').closest('tr').hide();
                jQuery('#rs_free_product_quantity').closest('tr').hide();
            }
        });
    } else {
        jQuery('.rsdynamicrulecreation').parent().hide();
        jQuery('#rs_select_earn_points_based_on').parent().parent().hide();
        jQuery('#rs_free_product_range').closest('tr').hide();
        jQuery('#rs_free_product_add_by_user_or_admin').closest('tr').hide();
        jQuery('#rs_subject_for_free_product_mail').closest('tr').hide();
        jQuery('#rs_content_for_free_product_mail').closest('tr').hide();
        jQuery('#rs_order_status_control_to_automatic_order').closest('tr').hide();
        jQuery('#rs_free_product_add_quantity').closest('tr').hide();
        jQuery('#rs_free_product_quantity').parent().parent().hide();
    }

    jQuery(document).on('change', '#rs_enable_earned_level_based_reward_points', function () {
        if (jQuery('#rs_enable_earned_level_based_reward_points').is(':checked')) {
            jQuery('.rsdynamicrulecreation').parent().show();
            jQuery('#rs_select_earn_points_based_on').parent().parent().show();
            jQuery('#rs_free_product_range').closest('tr').show();
            jQuery('#rs_free_product_add_by_user_or_admin').closest('tr').show();
            if (jQuery('#rs_free_product_add_by_user_or_admin').val() == '1') {
                jQuery('#rs_order_status_control_to_automatic_order').closest('tr').hide();
                jQuery('#rs_subject_for_free_product_mail').closest('tr').hide();
                jQuery('#rs_content_for_free_product_mail').closest('tr').hide();
                jQuery('#rs_free_product_add_quantity').closest('tr').show();
                if (jQuery('#rs_free_product_add_quantity').val() == '2') {
                    jQuery('#rs_free_product_quantity').parent().parent().show();
                } else {
                    jQuery('#rs_free_product_quantity').parent().parent().hide();
                }
                jQuery('#rs_free_product_add_quantity').change(function () {
                    if (jQuery('#rs_free_product_add_quantity').val() == '2') {
                        jQuery('#rs_free_product_quantity').parent().parent().show();
                    } else {
                        jQuery('#rs_free_product_quantity').parent().parent().hide();
                    }
                });
            } else {
                jQuery('#rs_order_status_control_to_automatic_order').closest('tr').show();
                jQuery('#rs_subject_for_free_product_mail').closest('tr').show();
                jQuery('#rs_content_for_free_product_mail').closest('tr').show();
                jQuery('#rs_free_product_add_quantity').closest('tr').hide();
                jQuery('#rs_free_product_quantity').parent().parent().hide();
            }

            jQuery('#rs_free_product_add_by_user_or_admin').change(function () {
                if (jQuery('#rs_free_product_add_by_user_or_admin').val() == '1') {
                    jQuery('#rs_order_status_control_to_automatic_order').closest('tr').hide();
                    jQuery('#rs_subject_for_free_product_mail').closest('tr').hide();
                    jQuery('#rs_content_for_free_product_mail').closest('tr').hide();
                    jQuery('#rs_free_product_add_quantity').closest('tr').show();
                    if (jQuery('#rs_free_product_add_quantity').val() == '2') {
                        jQuery('#rs_free_product_quantity').parent().parent().show();
                    } else {
                        jQuery('#rs_free_product_quantity').parent().parent().hide();
                    }
                    jQuery('#rs_free_product_add_quantity').change(function () {
                        if (jQuery('#rs_free_product_add_quantity').val() == '2') {
                            jQuery('#rs_free_product_quantity').parent().parent().show();
                        } else {
                            jQuery('#rs_free_product_quantity').parent().parent().hide();
                        }
                    });
                } else {
                    jQuery('#rs_order_status_control_to_automatic_order').closest('tr').show();
                    jQuery('#rs_subject_for_free_product_mail').closest('tr').show();
                    jQuery('#rs_content_for_free_product_mail').closest('tr').show();
                    jQuery('#rs_free_product_add_quantity').closest('tr').hide();
                    jQuery('#rs_free_product_quantity').parent().parent().hide();
                }
            });
        } else {
            jQuery('.rsdynamicrulecreation').parent().hide();
            jQuery('#rs_select_earn_points_based_on').parent().parent().hide();
            jQuery('#rs_free_product_range').closest('tr').hide();
            jQuery('#rs_free_product_add_by_user_or_admin').closest('tr').hide();
            jQuery('#rs_subject_for_free_product_mail').closest('tr').hide();
            jQuery('#rs_content_for_free_product_mail').closest('tr').hide();
            jQuery('#rs_order_status_control_to_automatic_order').closest('tr').hide();
            jQuery('#rs_free_product_add_quantity').closest('tr').hide();
            jQuery('#rs_free_product_quantity').parent().parent().hide();
        }
    });

    //Show/Hide for Purchase History
    if (jQuery('#rs_enable_user_purchase_history_based_reward_points').is(':checked')) {
        jQuery('.rsdynamicrulecreationsforuserpurchasehistory').show();
        jQuery('#rs_earning_percentage_order_status_control').closest('tr').show();
    } else {
        jQuery('.rsdynamicrulecreationsforuserpurchasehistory').hide();
        jQuery('#rs_earning_percentage_order_status_control').closest('tr').hide();
    }

    jQuery(document).on('click', '#rs_enable_user_purchase_history_based_reward_points', function () {
        if (jQuery(this).is(":checked")) {
            jQuery('.rsdynamicrulecreationsforuserpurchasehistory').show();
            jQuery('#rs_earning_percentage_order_status_control').closest('tr').show();
        } else {
            jQuery('.rsdynamicrulecreationsforuserpurchasehistory').hide();
            jQuery('#rs_earning_percentage_order_status_control').closest('tr').hide();
        }
    });

    if (jQuery('#rs_enable_user_role_based_reward_points_for_redeem').is(':checked')) {
        jQuery('.rewardpoints_userrole_for_redeem').parent().parent().show();
    } else {
        jQuery('.rewardpoints_userrole_for_redeem').parent().parent().hide();
    }

    jQuery(document).on('click', '#rs_enable_user_role_based_reward_points_for_redeem', function () {
        if (jQuery(this).is(":checked")) {
            jQuery('.rewardpoints_userrole_for_redeem').parent().parent().show();
        } else {
            jQuery('.rewardpoints_userrole_for_redeem').parent().parent().hide();
        }

    });

    if (jQuery('#rs_enable_user_purchase_history_based_reward_points_redeem').is(':checked')) {
        jQuery('.rsdynamicrulecreationsforuserpurchasehistory_redeeming').show();

    } else {
        jQuery('.rsdynamicrulecreationsforuserpurchasehistory_redeeming').hide();
    }

    jQuery(document).on('click', '#rs_enable_user_purchase_history_based_reward_points_redeem', function () {
        if (jQuery(this).is(":checked")) {
            jQuery('.rsdynamicrulecreationsforuserpurchasehistory_redeeming').show();
        } else {
            jQuery('.rsdynamicrulecreationsforuserpurchasehistory_redeeming').hide();
        }
    });

    if (jQuery('#rs_enable_redeem_level_based_reward_points').is(':checked')) {
        jQuery('.rsdynamicrulecreation_for_redeem').parent().show();
        jQuery('#rs_select_redeem_points_based_on').parent().parent().show();
    } else {
        jQuery('.rsdynamicrulecreation_for_redeem').parent().hide();
        jQuery('#rs_select_redeem_points_based_on').parent().parent().hide();
    }

    jQuery(document).on('click', '#rs_enable_redeem_level_based_reward_points', function () {
        if (jQuery(this).is(":checked")) {
            jQuery('.rsdynamicrulecreation_for_redeem').parent().show();
            jQuery('#rs_select_redeem_points_based_on').parent().parent().show();
        } else {
            jQuery('.rsdynamicrulecreation_for_redeem').parent().hide();
            jQuery('#rs_select_redeem_points_based_on').parent().parent().hide();
        }
    });
    /*Show or hide Settings for Member Level - End*/

    /*Show/Hide Setting for General Tab - Ends*/

    /*Show/Hide Setting for Add/Remove Point Tab - Starts*/

    if (jQuery('#rs_select_user_type').val() == '1') {
        jQuery('#rs_select_to_include_customers').parent().parent().hide();
        jQuery('#rs_select_to_exclude_customers').parent().parent().hide();
    } else if (jQuery('#rs_select_user_type').val() == '2') {
        jQuery('#rs_select_to_include_customers').parent().parent().show();
        jQuery('#rs_select_to_exclude_customers').parent().parent().hide();
    } else {
        jQuery('#rs_select_to_include_customers').parent().parent().hide();
        jQuery('#rs_select_to_exclude_customers').parent().parent().show();
    }
    jQuery('#rs_select_user_type').change(function () {
        if (jQuery('#rs_select_user_type').val() == '1') {
            jQuery('#rs_select_to_include_customers').parent().parent().hide();
            jQuery('#rs_select_to_exclude_customers').parent().parent().hide();
            jQuery('#rs_reward_addremove_points').val("");
            jQuery('#rs_reward_addremove_reason').val("");
        } else if (jQuery('#rs_select_user_type').val() == '2') {
            jQuery('#rs_select_to_include_customers').parent().parent().show();
            jQuery('#rs_select_to_exclude_customers').parent().parent().hide();
            jQuery('#rs_reward_addremove_points').val("");
            jQuery('#rs_reward_addremove_reason').val("");
        } else {
            jQuery('#rs_select_to_include_customers').parent().parent().hide();
            jQuery('#rs_select_to_exclude_customers').parent().parent().show();
            jQuery('#rs_reward_addremove_points').val("");
            jQuery('#rs_reward_addremove_reason').val("");
        }
    });

    if (jQuery('#rs_reward_select_type').val() == '2') {
        jQuery('#rs_remove_points').show();
        jQuery('#rs_add_points').hide();
        jQuery('#rs_expired_date').parent().parent().hide();
        jQuery('#send_mail_add_remove_settings').closest('tr').hide();
        jQuery('#rs_email_subject_message').closest('tr').hide();
        jQuery('#rs_email_message').closest('tr').hide();

    } else {
        jQuery('#rs_remove_points').hide();
        jQuery('#rs_add_points').show();
        jQuery('#rs_expired_date').parent().parent().show();
        jQuery('#send_mail_add_remove_settings').closest('tr').show();
        if (jQuery('#send_mail_add_remove_settings').is(':checked'))
        {
            jQuery('#rs_email_subject_message').closest('tr').show();
            jQuery('#rs_email_message').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_message').closest('tr').hide();
            jQuery('#rs_email_message').closest('tr').hide();
        }

    }
    jQuery('#rs_reward_select_type').change(function () {
        if (jQuery('#rs_reward_select_type').val() == '2') {
            jQuery('#rs_remove_points').show();
            jQuery('#rs_add_points').hide();
            jQuery('#rs_expired_date').parent().parent().hide();
            jQuery('#send_mail_add_remove_settings').closest('tr').hide();
            jQuery('#rs_email_subject_message').closest('tr').hide();
            jQuery('#rs_email_message').closest('tr').hide();

        } else {
            jQuery('#rs_remove_points').hide();
            jQuery('#rs_add_points').show();
            jQuery('#rs_expired_date').parent().parent().show();
            jQuery('#send_mail_add_remove_settings').closest('tr').show();
            if (jQuery('#send_mail_add_remove_settings').is(':checked'))
            {
                jQuery('#rs_email_subject_message').closest('tr').show();
                jQuery('#rs_email_message').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_message').closest('tr').hide();
                jQuery('#rs_email_message').closest('tr').hide();
            }


        }
    });
    /*Show/Hide Setting for Add/Remove Point Tab - Ends*/

    if (jQuery('#rs_mail_enable_threshold_points').is(':checked') == true) {
        jQuery('#rs_mail_threshold_points').closest('tr').show();
        jQuery('#rs_email_subject_threshold_points').closest('tr').show();
        jQuery('#rs_email_message_threshold_points').closest('tr').show();
    } else {
        jQuery('#rs_mail_threshold_points').closest('tr').hide();
        jQuery('#rs_email_subject_threshold_points').closest('tr').hide();
        jQuery('#rs_email_message_threshold_points').closest('tr').hide();
    }

    jQuery('#rs_mail_enable_threshold_points').change(function () {
        if (jQuery('#rs_mail_enable_threshold_points').is(':checked') == true) {
            jQuery('#rs_mail_threshold_points').closest('tr').show();
            jQuery('#rs_email_subject_threshold_points').closest('tr').show();
            jQuery('#rs_email_message_threshold_points').closest('tr').show();
        } else {
            jQuery('#rs_mail_threshold_points').closest('tr').hide();
            jQuery('#rs_email_subject_threshold_points').closest('tr').hide();
            jQuery('#rs_email_message_threshold_points').closest('tr').hide();
        }
    });

    /*Account Signup Enable/Disable - Start*/
    if (jQuery('#_rs_enable_signup').is(':checked') == true) {
        jQuery('#rs_select_account_signup_points_award').closest('tr').show();
        jQuery('#rs_reward_signup').closest('tr').show();
        jQuery('#rs_reward_signup_after_first_purchase').closest('tr').show();
        if (jQuery('#rs_reward_signup_after_first_purchase').is(':checked') == true) {
            jQuery('#rs_signup_points_with_purchase_points').closest('tr').show();
        } else {
            jQuery('#rs_signup_points_with_purchase_points').closest('tr').hide();
        }

        jQuery('#rs_reward_signup_after_first_purchase').change(function () {
            if (jQuery('#rs_reward_signup_after_first_purchase').is(':checked') == true) {
                jQuery('#rs_signup_points_with_purchase_points').closest('tr').show();
            } else {
                jQuery('#rs_signup_points_with_purchase_points').closest('tr').hide();
            }
        });

        jQuery('#rs_send_mail_account_signup').closest('tr').show();
        if (jQuery('#rs_send_mail_account_signup').is(':checked') == true) {
            jQuery('#rs_email_subject_account_signup').closest('tr').show();
            jQuery('#rs_email_message_account_signup').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_account_signup').closest('tr').hide();
            jQuery('#rs_email_message_account_signup').closest('tr').hide();
        }

        jQuery('#rs_send_mail_account_signup').change(function () {
            if (jQuery('#rs_send_mail_account_signup').is(':checked') == true) {
                jQuery('#rs_email_subject_account_signup').closest('tr').show();
                jQuery('#rs_email_message_account_signup').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_account_signup').closest('tr').hide();
                jQuery('#rs_email_message_account_signup').closest('tr').hide();
            }
        });
    } else {
        jQuery('#rs_select_account_signup_points_award').closest('tr').hide();
        jQuery('#rs_reward_signup').closest('tr').hide();
        jQuery('#rs_reward_signup_after_first_purchase').closest('tr').hide();
        jQuery('#rs_signup_points_with_purchase_points').closest('tr').hide();
        jQuery('#rs_send_mail_account_signup').closest('tr').hide();
        jQuery('#rs_email_subject_account_signup').closest('tr').hide();
        jQuery('#rs_email_message_account_signup').closest('tr').hide();
    }

    jQuery('#_rs_enable_signup').change(function () {
        if (jQuery('#_rs_enable_signup').is(':checked') == true) {
            jQuery('#rs_select_account_signup_points_award').closest('tr').show();
            jQuery('#rs_reward_signup').closest('tr').show();
            jQuery('#rs_reward_signup_after_first_purchase').closest('tr').show();
            if (jQuery('#rs_reward_signup_after_first_purchase').is(':checked') == true) {
                jQuery('#rs_signup_points_with_purchase_points').closest('tr').show();
            } else {
                jQuery('#rs_signup_points_with_purchase_points').closest('tr').hide();
            }

            jQuery('#rs_reward_signup_after_first_purchase').change(function () {
                if (jQuery('#rs_reward_signup_after_first_purchase').is(':checked') == true) {
                    jQuery('#rs_signup_points_with_purchase_points').closest('tr').show();
                } else {
                    jQuery('#rs_signup_points_with_purchase_points').closest('tr').hide();
                }
            });

            jQuery('#rs_send_mail_account_signup').closest('tr').show();
            if (jQuery('#rs_send_mail_account_signup').is(':checked') == true) {
                jQuery('#rs_email_subject_account_signup').closest('tr').show();
                jQuery('#rs_email_message_account_signup').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_account_signup').closest('tr').hide();
                jQuery('#rs_email_message_account_signup').closest('tr').hide();
            }

            jQuery('#rs_send_mail_account_signup').change(function () {
                if (jQuery('#rs_send_mail_account_signup').is(':checked') == true) {
                    jQuery('#rs_email_subject_account_signup').closest('tr').show();
                    jQuery('#rs_email_message_account_signup').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_account_signup').closest('tr').hide();
                    jQuery('#rs_email_message_account_signup').closest('tr').hide();
                }
            });
        } else {
            jQuery('#rs_select_account_signup_points_award').closest('tr').hide();
            jQuery('#rs_reward_signup').closest('tr').hide();
            jQuery('#rs_reward_signup_after_first_purchase').closest('tr').hide();
            jQuery('#rs_signup_points_with_purchase_points').closest('tr').hide();
            jQuery('#rs_send_mail_account_signup').closest('tr').hide();
            jQuery('#rs_email_subject_account_signup').closest('tr').hide();
            jQuery('#rs_email_message_account_signup').closest('tr').hide();
        }
    });

    /*Account Signup Enable/Disable - End*/

    /*Custom Field Registration Show/Hide - Start*/
    if (jQuery('#rs_enable_points_for_cus_field_reg').is(':checked') == true) {
        jQuery('.rs_rule_creation_for_custom_reg_field').parent().show();
        jQuery('#rs_send_mail_cus_field_reg').closest('tr').show();
        if (jQuery('#rs_send_mail_cus_field_reg').is(':checked') == true) {
            jQuery('#rs_email_subject_cus_field_reg').closest('tr').show();
            jQuery('#rs_email_message_cus_field_reg').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_cus_field_reg').closest('tr').hide();
            jQuery('#rs_email_message_cus_field_reg').closest('tr').hide();
        }

        jQuery('#rs_send_mail_cus_field_reg').change(function () {
            if (jQuery('#rs_send_mail_cus_field_reg').is(':checked') == true) {
                jQuery('#rs_email_subject_cus_field_reg').closest('tr').show();
                jQuery('#rs_email_message_cus_field_reg').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_cus_field_reg').closest('tr').hide();
                jQuery('#rs_email_message_cus_field_reg').closest('tr').hide();
            }
        });
    } else {
        jQuery('.rs_rule_creation_for_custom_reg_field').parent().hide();
        jQuery('#rs_send_mail_cus_field_reg').closest('tr').hide();
        jQuery('#rs_email_subject_cus_field_reg').closest('tr').hide();
        jQuery('#rs_email_message_cus_field_reg').closest('tr').hide();
    }

    jQuery('#rs_enable_points_for_cus_field_reg').change(function () {
        if (jQuery('#rs_enable_points_for_cus_field_reg').is(':checked') == true) {
            jQuery('.rs_rule_creation_for_custom_reg_field').parent().show();
            jQuery('#rs_send_mail_cus_field_reg').closest('tr').show();
            if (jQuery('#rs_send_mail_cus_field_reg').is(':checked') == true) {
                jQuery('#rs_email_subject_cus_field_reg').closest('tr').show();
                jQuery('#rs_email_message_cus_field_reg').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_cus_field_reg').closest('tr').hide();
                jQuery('#rs_email_message_cus_field_reg').closest('tr').hide();
            }

            jQuery('#rs_send_mail_cus_field_reg').change(function () {
                if (jQuery('#rs_send_mail_cus_field_reg').is(':checked') == true) {
                    jQuery('#rs_email_subject_cus_field_reg').closest('tr').show();
                    jQuery('#rs_email_message_cus_field_reg').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_cus_field_reg').closest('tr').hide();
                    jQuery('#rs_email_message_cus_field_reg').closest('tr').hide();
                }
            });
        } else {
            jQuery('.rs_rule_creation_for_custom_reg_field').parent().hide();
            jQuery('#rs_send_mail_cus_field_reg').closest('tr').hide();
            jQuery('#rs_email_subject_cus_field_reg').closest('tr').hide();
            jQuery('#rs_email_message_cus_field_reg').closest('tr').hide();
        }
    });
    /*Custom Field Registration Show/Hide - End*/

    if (jQuery('#rs_enable_product_review_points').is(':checked') == true) {
        jQuery('.rs_review_reward_status').closest('tr').show();
        jQuery('#rs_reward_product_review').closest('tr').show();
        jQuery('#rs_restrict_reward_product_review').closest('tr').show();
        jQuery('#rs_reward_for_comment_product_review').closest('tr').show();
        jQuery('#rs_send_mail_product_review').closest('tr').show();
        if (jQuery('#rs_send_mail_product_review').is(':checked') == true) {
            jQuery('#rs_email_subject_product_review').closest('tr').show();
            jQuery('#rs_email_message_product_review').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_product_review').closest('tr').hide();
            jQuery('#rs_email_message_product_review').closest('tr').hide();
        }

        jQuery('#rs_send_mail_product_review').change(function () {
            if (jQuery('#rs_send_mail_product_review').is(':checked') == true) {
                jQuery('#rs_email_subject_product_review').closest('tr').show();
                jQuery('#rs_email_message_product_review').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_product_review').closest('tr').hide();
                jQuery('#rs_email_message_product_review').closest('tr').hide();
            }
        });
    } else {
        jQuery('.rs_review_reward_status').closest('tr').hide();
        jQuery('#rs_reward_product_review').closest('tr').hide();
        jQuery('#rs_restrict_reward_product_review').closest('tr').hide();
        jQuery('#rs_reward_for_comment_product_review').closest('tr').hide();
        jQuery('#rs_send_mail_product_review').closest('tr').hide();
        jQuery('#rs_email_subject_product_review').closest('tr').hide();
        jQuery('#rs_email_message_product_review').closest('tr').hide();
    }

    jQuery('#rs_enable_product_review_points').change(function () {
        if (jQuery('#rs_enable_product_review_points').is(':checked') == true) {
            jQuery('.rs_review_reward_status').closest('tr').show();
            jQuery('#rs_reward_product_review').closest('tr').show();
            jQuery('#rs_restrict_reward_product_review').closest('tr').show();
            jQuery('#rs_reward_for_comment_product_review').closest('tr').show();
            jQuery('#rs_send_mail_product_review').closest('tr').show();
            if (jQuery('#rs_send_mail_product_review').is(':checked') == true) {
                jQuery('#rs_email_subject_product_review').closest('tr').show();
                jQuery('#rs_email_message_product_review').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_product_review').closest('tr').hide();
                jQuery('#rs_email_message_product_review').closest('tr').hide();
            }

            jQuery('#rs_send_mail_product_review').change(function () {
                if (jQuery('#rs_send_mail_product_review').is(':checked') == true) {
                    jQuery('#rs_email_subject_product_review').closest('tr').show();
                    jQuery('#rs_email_message_product_review').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_product_review').closest('tr').hide();
                    jQuery('#rs_email_message_product_review').closest('tr').hide();
                }
            });
        } else {
            jQuery('.rs_review_reward_status').closest('tr').hide();
            jQuery('#rs_reward_product_review').closest('tr').hide();
            jQuery('#rs_restrict_reward_product_review').closest('tr').hide();
            jQuery('#rs_reward_for_comment_product_review').closest('tr').hide();
            jQuery('#rs_send_mail_product_review').closest('tr').hide();
            jQuery('#rs_email_subject_product_review').closest('tr').hide();
            jQuery('#rs_email_message_product_review').closest('tr').hide();
        }
    });


    if (jQuery('#rs_send_mail_payment_gateway').is(':checked') == true) {
        jQuery('#rs_email_subject_payment_gateway').closest('tr').show();
        jQuery('#rs_email_message_payment_gateway').closest('tr').show();
    } else {
        jQuery('#rs_email_subject_payment_gateway').closest('tr').hide();
        jQuery('#rs_email_message_payment_gateway').closest('tr').hide();
    }

    jQuery('#rs_send_mail_payment_gateway').change(function () {
        if (jQuery('#rs_send_mail_payment_gateway').is(':checked') == true) {
            jQuery('#rs_email_subject_payment_gateway').closest('tr').show();
            jQuery('#rs_email_message_payment_gateway').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_payment_gateway').closest('tr').hide();
            jQuery('#rs_email_message_payment_gateway').closest('tr').hide();
        }
    });


    if (jQuery('#rs_send_mail_gift_voucher').is(':checked') == true) {
        jQuery('#rs_email_subject_gift_voucher').closest('tr').show();
        jQuery('#rs_email_message_gift_voucher').closest('tr').show();
    } else {
        jQuery('#rs_email_subject_gift_voucher').closest('tr').hide();
        jQuery('#rs_email_message_gift_voucher').closest('tr').hide();
    }

    jQuery('#rs_send_mail_gift_voucher').change(function () {
        if (jQuery('#rs_send_mail_gift_voucher').is(':checked') == true) {
            jQuery('#rs_email_subject_gift_voucher').closest('tr').show();
            jQuery('#rs_email_message_gift_voucher').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_gift_voucher').closest('tr').hide();
            jQuery('#rs_email_message_gift_voucher').closest('tr').hide();
        }
    });

    if (jQuery('#rs_send_mail_point_url').is(':checked') == true) {
        jQuery('#rs_email_subject_point_url').closest('tr').show();
        jQuery('#rs_email_message_point_url').closest('tr').show();
    } else {
        jQuery('#rs_email_subject_point_url').closest('tr').hide();
        jQuery('#rs_email_message_point_url').closest('tr').hide();
    }

    jQuery('#rs_send_mail_point_url').change(function () {
        if (jQuery('#rs_send_mail_point_url').is(':checked') == true) {
            jQuery('#rs_email_subject_point_url').closest('tr').show();
            jQuery('#rs_email_message_point_url').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_point_url').closest('tr').hide();
            jQuery('#rs_email_message_point_url').closest('tr').hide();
        }
    });

    if (jQuery('#rs_send_mail_coupon_reward').is(':checked') == true) {
        jQuery('#rs_email_subject_coupon_reward').closest('tr').show();
        jQuery('#rs_email_message_coupon_reward').closest('tr').show();
    } else {
        jQuery('#rs_email_subject_coupon_reward').closest('tr').hide();
        jQuery('#rs_email_message_coupon_reward').closest('tr').hide();
    }

    jQuery('#rs_send_mail_coupon_reward').change(function () {
        if (jQuery('#rs_send_mail_coupon_reward').is(':checked') == true) {
            jQuery('#rs_email_subject_coupon_reward').closest('tr').show();
            jQuery('#rs_email_message_coupon_reward').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_coupon_reward').closest('tr').hide();
            jQuery('#rs_email_message_coupon_reward').closest('tr').hide();
        }
    });
    if (jQuery('#rs_enable_coupon_reward_success_msg').is(':checked')) {
        jQuery('#rs_coupon_applied_reward_success').closest('tr').show();
    } else {
        jQuery('#rs_coupon_applied_reward_success').closest('tr').hide();
    }
    jQuery('#rs_enable_coupon_reward_success_msg').change(function () {
        if (jQuery('#rs_enable_coupon_reward_success_msg').is(':checked')) {
            jQuery('#rs_coupon_applied_reward_success').closest('tr').show();
        } else {
            jQuery('#rs_coupon_applied_reward_success').closest('tr').hide();
        }
    });


    /* Show/Hide Product Fields - Start */

    jQuery('#_rewardsystem__points_based_on_conversion').attr('readonly', 'true');
    if (jQuery('#_rewardsystemcheckboxvalue').val() == 'no') {
        jQuery('.show_if_enable').parent().hide();
    } else {
        jQuery('.show_if_enable').parent().show();
        if (jQuery('.rewardsystem_options').val() === '') {
            jQuery('._rewardsystempercent_field').css('display', 'none');
            jQuery('._rewardsystempoints_field').css('display', 'none');
        } else if (jQuery('.rewardsystem_options').val() === '1') {
            jQuery('._rewardsystempercent_field').css('display', 'none');
            jQuery('._rewardsystempoints_field').css('display', 'block');
        } else {
            jQuery('._rewardsystempercent_field').css('display', 'block');
            jQuery('._rewardsystempoints_field').css('display', 'none');
        }

        jQuery('.rewardsystem_options').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._rewardsystempercent_field').css('display', 'none');
                jQuery('._rewardsystempoints_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._rewardsystempercent_field').css('display', 'none');
                jQuery('._rewardsystempoints_field').css('display', 'block');
            } else {
                jQuery('._rewardsystempercent_field').css('display', 'block');
                jQuery('._rewardsystempoints_field').css('display', 'none');
            }

        });
    }

    jQuery('#_rewardsystemcheckboxvalue').change(function () {
        if (jQuery(this).val() == 'no') {
            jQuery('.show_if_enable').parent().hide();
        } else {
            jQuery('.show_if_enable').parent().show();
            if (jQuery('.rewardsystem_options').val() === '') {
                jQuery('._rewardsystempercent_field').css('display', 'none');
                jQuery('._rewardsystempoints_field').css('display', 'none');
            } else if (jQuery('.rewardsystem_options').val() === '1') {
                jQuery('._rewardsystempercent_field').css('display', 'none');
                jQuery('._rewardsystempoints_field').css('display', 'block');
            } else {
                jQuery('._rewardsystempercent_field').css('display', 'block');
                jQuery('._rewardsystempoints_field').css('display', 'none');
            }


            jQuery('.rewardsystem_options').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._rewardsystempercent_field').css('display', 'none');
                    jQuery('._rewardsystempoints_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._rewardsystempercent_field').css('display', 'none');
                    jQuery('._rewardsystempoints_field').css('display', 'block');
                } else {
                    jQuery('._rewardsystempercent_field').css('display', 'block');
                    jQuery('._rewardsystempoints_field').css('display', 'none');
                }

            });
        }
    });

    if (jQuery('#_rewardsystemreferralcheckboxvalue').val() == 'no') {
        jQuery('.show_if_referral_enable').parent().hide();
    } else {
        jQuery('.show_if_referral_enable').parent().show();
        if (jQuery('.referral_rewardsystem_options_get').val() === '') {
            jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'none');
            jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'none');
        } else if (jQuery('.referral_rewardsystem_options_get').val() === '1') {
            jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'block');
            jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'none');
        } else {
            jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'none');
            jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'block');
        }

        if (jQuery('.referral_rewardsystem_options').val() === '') {
            jQuery('._referralrewardsystempercent_field').css('display', 'none');
            jQuery('._referralrewardsystempoints_field').css('display', 'none');
        } else if (jQuery('.referral_rewardsystem_options').val() === '1') {
            jQuery('._referralrewardsystempercent_field').css('display', 'none');
            jQuery('._referralrewardsystempoints_field').css('display', 'block');
        } else {
            jQuery('._referralrewardsystempercent_field').css('display', 'block');
            jQuery('._referralrewardsystempoints_field').css('display', 'none');
        }


        jQuery('.referral_rewardsystem_options').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._referralrewardsystempercent_field').css('display', 'none');
                jQuery('._referralrewardsystempoints_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._referralrewardsystempercent_field').css('display', 'none');
                jQuery('._referralrewardsystempoints_field').css('display', 'block');
            } else {
                jQuery('._referralrewardsystempercent_field').css('display', 'block');
                jQuery('._referralrewardsystempoints_field').css('display', 'none');
            }


        });
        jQuery('.referral_rewardsystem_options_get').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'none');
                jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'block');
                jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'none');
            } else {
                jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'none');
                jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'block');

            }
        });
    }

    jQuery('#_rewardsystemreferralcheckboxvalue').change(function () {
        if (jQuery(this).val() == 'no') {
            jQuery('.show_if_referral_enable').parent().hide();
        } else {
            jQuery('.show_if_referral_enable').parent().show();
            if (jQuery('.referral_rewardsystem_options_get').val() === '') {
                jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'none');
                jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'none');
            } else if (jQuery('.referral_rewardsystem_options_get').val() === '1') {
                jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'block');
                jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'none');
            } else {
                jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'none');
                jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'block');
            }

            if (jQuery('.referral_rewardsystem_options').val() === '') {
                jQuery('._referralrewardsystempercent_field').css('display', 'none');
                jQuery('._referralrewardsystempoints_field').css('display', 'none');
            } else if (jQuery('.referral_rewardsystem_options').val() === '1') {
                jQuery('._referralrewardsystempercent_field').css('display', 'none');
                jQuery('._referralrewardsystempoints_field').css('display', 'block');
            } else {
                jQuery('._referralrewardsystempercent_field').css('display', 'block');
                jQuery('._referralrewardsystempoints_field').css('display', 'none');
            }


            jQuery('.referral_rewardsystem_options').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._referralrewardsystempercent_field').css('display', 'none');
                    jQuery('._referralrewardsystempoints_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._referralrewardsystempercent_field').css('display', 'none');
                    jQuery('._referralrewardsystempoints_field').css('display', 'block');
                } else {
                    jQuery('._referralrewardsystempercent_field').css('display', 'block');
                    jQuery('._referralrewardsystempoints_field').css('display', 'none');
                }


            });
            jQuery('.referral_rewardsystem_options_get').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'none');
                    jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'block');
                    jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'none');
                } else {
                    jQuery('._referralrewardsystempoints_for_getting_referred_field').css('display', 'none');
                    jQuery('._referralrewardsystempercent_for_getting_referred_field').css('display', 'block');

                }
            });
        }
    });

    /* Show/Hide Product Fields - End */

    /*Social Reward Points Show/Hide - Start*/

    if (jQuery('#_socialrewardsystemcheckboxvalue').val() === 'no') {
        jQuery('.show_if_social_enable').closest('p').hide();
    } else {
        jQuery('.show_if_social_enable').parent().show();

        /* Social Reward System for facebook */
        if (jQuery('.social_rewardsystem_options_facebook').val() === '') {
            jQuery('._socialrewardsystempoints_facebook_field').css('display', 'none');
            jQuery('._socialrewardsystempercent_facebook_field').css('display', 'none');
        } else if (jQuery('.social_rewardsystem_options_facebook').val() === '1') {
            jQuery('._socialrewardsystempercent_facebook_field').css('display', 'none');
            jQuery('._socialrewardsystempoints_facebook_field').css('display', 'block');
        } else {
            jQuery('._socialrewardsystempercent_facebook_field').css('display', 'block');
            jQuery('._socialrewardsystempoints_facebook_field').css('display', 'none');
        }

        /* On Change Event Triggering for Social Rewards Facebook */
        jQuery('.social_rewardsystem_options_facebook').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._socialrewardsystempoints_facebook_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_facebook_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._socialrewardsystempercent_facebook_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_facebook_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_facebook_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_facebook_field').css('display', 'none');
            }
        });


        /* Social Reward System for facebook */
        if (jQuery('._social_rewardsystem_options_facebook_share').val() === '') {
            jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'none');
            jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'none');
        } else if (jQuery('._social_rewardsystem_options_facebook_share').val() === '1') {
            jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'none');
            jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'block');
        } else {
            jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'block');
            jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'none');
        }

        /* On Change Event Triggering for Social Rewards Facebook */
        jQuery('._social_rewardsystem_options_facebook_share').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'none');
            }
        });


        /* Social Reward System for twitter */
        if (jQuery('.social_rewardsystem_options_twitter').val() === '') {
            jQuery('._socialrewardsystempoints_twitter_field').css('display', 'none');
            jQuery('._socialrewardsystempercent_twitter_field').css('display', 'none');
        } else if (jQuery('.social_rewardsystem_options_twitter').val() === '1') {
            jQuery('._socialrewardsystempercent_twitter_field').css('display', 'none');
            jQuery('._socialrewardsystempoints_twitter_field').css('display', 'block');
        } else {
            jQuery('._socialrewardsystempercent_twitter_field').css('display', 'block');
            jQuery('._socialrewardsystempoints_twitter_field').css('display', 'none');
        }

        /* On Change Event Triggering for Social Rewards twitter */
        jQuery('.social_rewardsystem_options_twitter').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._socialrewardsystempoints_twitter_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_twitter_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._socialrewardsystempercent_twitter_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_twitter_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_twitter_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_twitter_field').css('display', 'none');
            }
        });

        /* Social Reward System for Google+ */
        if (jQuery('.social_rewardsystem_options_google').val() === '') {
            jQuery('._socialrewardsystempoints_google_field').css('display', 'none');
            jQuery('._socialrewardsystempercent_google_field').css('display', 'none');
        } else if (jQuery('.social_rewardsystem_options_google').val() === '1') {
            jQuery('._socialrewardsystempercent_google_field').css('display', 'none');
            jQuery('._socialrewardsystempoints_google_field').css('display', 'block');
        } else {
            jQuery('._socialrewardsystempercent_google_field').css('display', 'block');
            jQuery('._socialrewardsystempoints_google_field').css('display', 'none');
        }

        /* On Change Event Triggering for Social Rewards Google+ */
        jQuery('.social_rewardsystem_options_google').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._socialrewardsystempoints_google_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_google_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._socialrewardsystempercent_google_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_google_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_google_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_google_field').css('display', 'none');
            }
        });

        /* Social Reward System for VK */
        if (jQuery('.social_rewardsystem_options_vk').val() === '') {
            jQuery('._socialrewardsystempoints_vk_field').css('display', 'none');
            jQuery('._socialrewardsystempercent_vk_field').css('display', 'none');
        } else if (jQuery('.social_rewardsystem_options_vk').val() === '1') {
            jQuery('._socialrewardsystempercent_vk_field').css('display', 'none');
            jQuery('._socialrewardsystempoints_vk_field').css('display', 'block');
        } else {
            jQuery('._socialrewardsystempercent_vk_field').css('display', 'block');
            jQuery('._socialrewardsystempoints_vk_field').css('display', 'none');
        }

        /* On Change Event Triggering for Social Rewards VK */
        jQuery('.social_rewardsystem_options_vk').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._socialrewardsystempoints_vk_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_vk_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._socialrewardsystempercent_vk_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_vk_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_vk_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_vk_field').css('display', 'none');
            }
        });
        if (jQuery('._social_rewardsystem_options_instagram').val() === '') {
            jQuery('._socialrewardsystempoints_instagram_field').css('display', 'none');
            jQuery('._socialrewardsystempercent_instagram_field').css('display', 'none');
        } else if (jQuery('._social_rewardsystem_options_instagram').val() === '1') {
            jQuery('._socialrewardsystempercent_instagram_field').css('display', 'none');
            jQuery('._socialrewardsystempoints_instagram_field').css('display', 'block');
        } else {
            jQuery('._socialrewardsystempercent_instagram_field').css('display', 'block');
            jQuery('._socialrewardsystempoints_instagram_field').css('display', 'none');
        }

        /* On Change Event Triggering for Social Rewards VK */
        jQuery('._social_rewardsystem_options_instagram').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._socialrewardsystempoints_instagram_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_instagram_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._socialrewardsystempercent_instagram_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_instagram_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_instagram_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_instagram_field').css('display', 'none');
            }
        });

        if (jQuery('._social_rewardsystem_options_ok_follow').val() === '') {
            jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'none');
            jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'none');
        } else if (jQuery('._social_rewardsystem_options_ok_follow').val() === '1') {
            jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'none');
            jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'block');
        } else {
            jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'block');
            jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'none');
        }

        /* On Change Event Triggering for Social Rewards VK */
        jQuery('._social_rewardsystem_options_ok_follow').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'none');
            }
        });

        if (jQuery('._social_rewardsystem_options_twitter_follow').val() === '') {
            jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'none');
            jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'none');
        } else if (jQuery('._social_rewardsystem_options_twitter_follow').val() === '1') {
            jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'none');
            jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'block');
        } else if (jQuery('._social_rewardsystem_options_twitter_follow').val() === '2') {
            jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'block');
            jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'none');
        }

        /* On Change Event Triggering for Social Rewards twitter */
        jQuery('._social_rewardsystem_options_twitter_follow').change(function () {
            if (jQuery(this).val() === '') {
                jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'none');
            } else if (jQuery(this).val() === '1') {
                jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'block');
            } else if (jQuery(this).val() === '2') {
                jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'none');
            }
        });

    }

    jQuery('#_socialrewardsystemcheckboxvalue').change(function () {
        if (jQuery(this).val() == 'no') {
            jQuery('.show_if_social_enable').parent().hide();
        } else {
            jQuery('.show_if_social_enable').parent().show();

            /* Social Reward System for facebook */
            if (jQuery('.social_rewardsystem_options_facebook').val() === '') {
                jQuery('._socialrewardsystempoints_facebook_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_facebook_field').css('display', 'none');
            } else if (jQuery('.social_rewardsystem_options_facebook').val() === '1') {
                jQuery('._socialrewardsystempercent_facebook_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_facebook_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_facebook_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_facebook_field').css('display', 'none');
            }

            /* On Change Event Triggering for Social Rewards Facebook */
            jQuery('.social_rewardsystem_options_facebook').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._socialrewardsystempoints_facebook_field').css('display', 'none');
                    jQuery('._socialrewardsystempercent_facebook_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._socialrewardsystempercent_facebook_field').css('display', 'none');
                    jQuery('._socialrewardsystempoints_facebook_field').css('display', 'block');
                } else {
                    jQuery('._socialrewardsystempercent_facebook_field').css('display', 'block');
                    jQuery('._socialrewardsystempoints_facebook_field').css('display', 'none');
                }
            });

            if (jQuery('._social_rewardsystem_options_facebook_share').val() === '') {

                jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'none');
            } else if (jQuery('._social_rewardsystem_options_facebook_share').val() === '1') {
                jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'none');
            }

            /* On Change Event Triggering for Social Rewards Facebook */
            jQuery('._social_rewardsystem_options_facebook_share').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'none');
                    jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'none');
                    jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'block');
                } else {
                    jQuery('._socialrewardsystempercent_facebook_share_field').css('display', 'block');
                    jQuery('._socialrewardsystempoints_facebook_share_field').css('display', 'none');
                }
            });

            /* Social Reward System for twitter */
            if (jQuery('.social_rewardsystem_options_twitter').val() === '') {
                jQuery('._socialrewardsystempoints_twitter_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_twitter_field').css('display', 'none');
            } else if (jQuery('.social_rewardsystem_options_twitter').val() === '1') {
                jQuery('._socialrewardsystempercent_twitter_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_twitter_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_twitter_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_twitter_field').css('display', 'none');
            }

            /* On Change Event Triggering for Social Rewards twitter */
            jQuery('.social_rewardsystem_options_twitter').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._socialrewardsystempoints_twitter_field').css('display', 'none');
                    jQuery('._socialrewardsystempercent_twitter_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._socialrewardsystempercent_twitter_field').css('display', 'none');
                    jQuery('._socialrewardsystempoints_twitter_field').css('display', 'block');
                } else {
                    jQuery('._socialrewardsystempercent_twitter_field').css('display', 'block');
                    jQuery('._socialrewardsystempoints_twitter_field').css('display', 'none');
                }
            });

            if (jQuery('._social_rewardsystem_options_twitter_follow').val() === '') {
                jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'none');
            } else if (jQuery('._social_rewardsystem_options_twitter_follow').val() === '1') {
                jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'block');
            } else if (jQuery('._social_rewardsystem_options_twitter_follow').val() === '2') {
                jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'none');
            }

            /* On Change Event Triggering for Social Rewards twitter */
            jQuery('._social_rewardsystem_options_twitter_follow').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'none');
                    jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'none');
                    jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'block');
                } else if (jQuery(this).val() === '2') {
                    jQuery('._socialrewardsystempercent_twitter_follow_field').css('display', 'block');
                    jQuery('._socialrewardsystempoints_twitter_follow_field').css('display', 'none');
                }
            });


            if (jQuery('._social_rewardsystem_options_ok_follow').val() === '') {
                jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'none');
            } else if (jQuery('._social_rewardsystem_options_ok_follow').val() === '1') {
                jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'none');
            }


            /* On Change Event Triggering for Social Rewards ok.ru */
            jQuery('._social_rewardsystem_options_ok_follow').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'none');
                    jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'none');
                    jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'block');
                } else if (jQuery(this).val() === '2') {
                    jQuery('._socialrewardsystempercent_ok_follow_field').css('display', 'block');
                    jQuery('._socialrewardsystempoints_ok_follow_field').css('display', 'none');
                }
            });

            /* Social Reward System for Google+ */
            if (jQuery('.social_rewardsystem_options_google').val() === '') {
                jQuery('._socialrewardsystempoints_google_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_google_field').css('display', 'none');
            } else if (jQuery('.social_rewardsystem_options_google').val() === '1') {
                jQuery('._socialrewardsystempercent_google_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_google_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_google_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_google_field').css('display', 'none');
            }

            /* On Change Event Triggering for Social Rewards Google+ */
            jQuery('.social_rewardsystem_options_google').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._socialrewardsystempoints_google_field').css('display', 'none');
                    jQuery('._socialrewardsystempercent_google_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._socialrewardsystempercent_google_field').css('display', 'none');
                    jQuery('._socialrewardsystempoints_google_field').css('display', 'block');
                } else {
                    jQuery('._socialrewardsystempercent_google_field').css('display', 'block');
                    jQuery('._socialrewardsystempoints_google_field').css('display', 'none');
                }
            });

            /* Social Reward System for VK */
            if (jQuery('.social_rewardsystem_options_vk').val() === '') {
                jQuery('._socialrewardsystempoints_vk_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_vk_field').css('display', 'none');
            } else if (jQuery('.social_rewardsystem_options_vk').val() === '1') {
                jQuery('._socialrewardsystempercent_vk_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_vk_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_vk_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_vk_field').css('display', 'none');
            }

            /* On Change Event Triggering for Social Rewards VK */
            jQuery('.social_rewardsystem_options_vk').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._socialrewardsystempoints_vk_field').css('display', 'none');
                    jQuery('._socialrewardsystempercent_vk_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._socialrewardsystempercent_vk_field').css('display', 'none');
                    jQuery('._socialrewardsystempoints_vk_field').css('display', 'block');
                } else {
                    jQuery('._socialrewardsystempercent_vk_field').css('display', 'block');
                    jQuery('._socialrewardsystempoints_vk_field').css('display', 'none');
                }
            });
            if (jQuery('._social_rewardsystem_options_instagram').val() === '') {
                jQuery('._socialrewardsystempoints_instagram_field').css('display', 'none');
                jQuery('._socialrewardsystempercent_instagram_field').css('display', 'none');
            } else if (jQuery('.social_rewardsystem_options_instagram').val() === '1') {
                jQuery('._socialrewardsystempercent_instagram_field').css('display', 'none');
                jQuery('._socialrewardsystempoints_instagram_field').css('display', 'block');
            } else {
                jQuery('._socialrewardsystempercent_instagram_field').css('display', 'block');
                jQuery('._socialrewardsystempoints_instagram_field').css('display', 'none');
            }

            /* On Change Event Triggering for Social Rewards VK */
            jQuery('._social_rewardsystem_options_instagram').change(function () {
                if (jQuery(this).val() === '') {
                    jQuery('._socialrewardsystempoints_instagram_field').css('display', 'none');
                    jQuery('._socialrewardsystempercent_instagram_field').css('display', 'none');
                } else if (jQuery(this).val() === '1') {
                    jQuery('._socialrewardsystempercent_instagram_field').css('display', 'none');
                    jQuery('._socialrewardsystempoints_instagram_field').css('display', 'block');
                } else {
                    jQuery('._socialrewardsystempercent_instagram_field').css('display', 'block');
                    jQuery('._socialrewardsystempoints_instagram_field').css('display', 'none');
                }
            });
        }
    });

    /* Social Reward Points Show/Hide - End*/

    // Confirm Dialog for Resetting the Tab

    jQuery('#resettab').click(function (e) {
        var status = confirm(rewardsystem.reset_confirm_msg);
        if (status === true) {
        } else {
            e.preventDefault();
        }
    });

    /*Show or Hide settings for General Tab - Start*/
    if (jQuery('#rs_enable_disable_point_priceing').val() == '2') {
        jQuery('#rs_sufix_prefix_point_price_label').parent().parent().hide();
        jQuery('#rs_local_price_points_for_product').parent().parent().hide();
        jQuery('#rs_label_for_point_value').parent().parent().hide();
        jQuery('#rs_local_enable_disable_point_price_for_product').parent().parent().hide();
        jQuery('#rs_global_point_price_type').parent().parent().hide();
        jQuery('#rs_pixel_val').closest('tr').hide();
    } else {
        jQuery('#rs_label_for_point_value').parent().parent().show();
        jQuery('#rs_sufix_prefix_point_price_label').parent().parent().show();
        jQuery('#rs_pixel_val').closest('tr').show();
        jQuery('#rs_local_enable_disable_point_price_for_product').parent().parent().show();
        if (jQuery('#rs_local_enable_disable_point_price_for_product').val() == '2') {
            jQuery('#rs_global_point_price_type').parent().parent().hide();
            jQuery('#rs_local_price_points_for_product').parent().parent().hide();
        } else {
            jQuery('#rs_global_point_price_type').parent().parent().show();
            if (jQuery('#rs_global_point_price_type').val() == '2') {
                jQuery('#rs_local_price_points_for_product').parent().parent().hide();
            } else {
                jQuery('#rs_local_price_points_for_product').parent().parent().show();
            }
            jQuery('#rs_global_point_price_type').change(function () {
                if (jQuery('#rs_global_point_price_type').val() == '2') {
                    jQuery('#rs_local_price_points_for_product').parent().parent().hide();
                } else {
                    jQuery('#rs_local_price_points_for_product').parent().parent().show();
                }
            });
        }
        jQuery('#rs_local_enable_disable_point_price_for_product').change(function () {
            if (jQuery('#rs_local_enable_disable_point_price_for_product').val() == '2') {
                jQuery('#rs_global_point_price_type').parent().parent().hide();
                jQuery('#rs_local_price_points_for_product').parent().parent().hide();
            } else {
                jQuery('#rs_global_point_price_type').parent().parent().show();
                if (jQuery('#rs_global_point_price_type').val() == '2') {
                    jQuery('#rs_local_price_points_for_product').parent().parent().hide();
                } else {
                    jQuery('#rs_local_price_points_for_product').parent().parent().show();
                }
                jQuery('#rs_global_point_price_type').change(function () {
                    if (jQuery('#rs_global_point_price_type').val() == '2') {
                        jQuery('#rs_local_price_points_for_product').parent().parent().hide();
                    } else {
                        jQuery('#rs_local_price_points_for_product').parent().parent().show();
                    }
                });
            }
        });
    }

    jQuery('#rs_enable_disable_point_priceing').change(function () {
        if (jQuery('#rs_enable_disable_point_priceing').val() == '2') {
            jQuery('#rs_sufix_prefix_point_price_label').parent().parent().hide();
            jQuery('#rs_local_price_points_for_product').parent().parent().hide();
            jQuery('#rs_label_for_point_value').parent().parent().hide();
            jQuery('#rs_local_enable_disable_point_price_for_product').parent().parent().hide();
            jQuery('#rs_global_point_price_type').parent().parent().hide();
            jQuery('#rs_pixel_val').closest('tr').hide();
        } else {
            jQuery('#rs_label_for_point_value').parent().parent().show();
            jQuery('#rs_pixel_val').closest('tr').show();
            jQuery('#rs_sufix_prefix_point_price_label').parent().parent().show();
            jQuery('#rs_local_enable_disable_point_price_for_product').parent().parent().show();
            if (jQuery('#rs_local_enable_disable_point_price_for_product').val() == '2') {
                jQuery('#rs_global_point_price_type').parent().parent().hide();
                jQuery('#rs_local_price_points_for_product').parent().parent().hide();
            } else {
                jQuery('#rs_global_point_price_type').parent().parent().show();
                if (jQuery('#rs_global_point_price_type').val() == '2') {
                    jQuery('#rs_local_price_points_for_product').parent().parent().hide();
                } else {
                    jQuery('#rs_local_price_points_for_product').parent().parent().show();
                }
                jQuery('#rs_global_point_price_type').change(function () {
                    if (jQuery('#rs_global_point_price_type').val() == '2') {
                        jQuery('#rs_local_price_points_for_product').parent().parent().hide();
                    } else {
                        jQuery('#rs_local_price_points_for_product').parent().parent().show();
                    }
                });
            }
            jQuery('#rs_local_enable_disable_point_price_for_product').change(function () {
                if (jQuery('#rs_local_enable_disable_point_price_for_product').val() == '2') {
                    jQuery('#rs_global_point_price_type').parent().parent().hide();
                    jQuery('#rs_local_price_points_for_product').parent().parent().hide();
                } else {
                    jQuery('#rs_global_point_price_type').parent().parent().show();
                    if (jQuery('#rs_global_point_price_type').val() == '2') {
                        jQuery('#rs_local_price_points_for_product').parent().parent().hide();
                    } else {
                        jQuery('#rs_local_price_points_for_product').parent().parent().show();
                    }
                    jQuery('#rs_global_point_price_type').change(function () {
                        if (jQuery('#rs_global_point_price_type').val() == '2') {
                            jQuery('#rs_local_price_points_for_product').parent().parent().hide();
                        } else {
                            jQuery('#rs_local_price_points_for_product').parent().parent().show();
                        }
                    });
                }
            });
        }
    });

    if (jQuery('#rs_global_enable_disable_sumo_reward').val() == '2') {
        jQuery('.show_if_enable_in_general').parent().parent().hide();
    } else {
        jQuery('.show_if_enable_in_general').parent().parent().show();

        if (jQuery('#rs_global_reward_type').val() == '1') {
            jQuery('#rs_global_reward_points').parent().parent().show();
            jQuery('#rs_global_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_reward_points').parent().parent().hide();
            jQuery('#rs_global_reward_percent').parent().parent().show();
        }

        jQuery('#rs_global_reward_type').change(function () {
            if (jQuery('#rs_global_reward_type').val() == '1') {
                jQuery('#rs_global_reward_points').parent().parent().show();
                jQuery('#rs_global_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_reward_points').parent().parent().hide();
                jQuery('#rs_global_reward_percent').parent().parent().show();
            }
        });
    }


    jQuery('#rs_global_enable_disable_sumo_reward').change(function () {
        if (jQuery(this).val() == '2') {
            jQuery('.show_if_enable_in_general').parent().parent().hide();
        } else {
            jQuery('.show_if_enable_in_general').parent().parent().show();

            if (jQuery('#rs_global_reward_type').val() == '1') {
                jQuery('#rs_global_reward_points').parent().parent().show();
                jQuery('#rs_global_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_reward_points').parent().parent().hide();
                jQuery('#rs_global_reward_percent').parent().parent().show();
            }

            jQuery('#rs_global_reward_type').change(function () {
                if (jQuery('#rs_global_reward_type').val() == '1') {
                    jQuery('#rs_global_reward_points').parent().parent().show();
                    jQuery('#rs_global_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_reward_points').parent().parent().hide();
                    jQuery('#rs_global_reward_percent').parent().parent().show();
                }
            });
        }
    });

    if (jQuery('#rs_global_enable_disable_sumo_referral_reward').val() == '2') {
        jQuery('.show_if_enable_in_referral').closest('tr').hide();
    } else {
        jQuery('.show_if_enable_in_referral').parent().parent().show();

        //To Show or hide Referral Points or Percentage for SUMO Reward.
        if (jQuery('#rs_global_referral_reward_type').val() == '1') {
            jQuery('#rs_global_referral_reward_point').parent().parent().show();
            jQuery('#rs_global_referral_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_referral_reward_point').parent().parent().hide();
            jQuery('#rs_global_referral_reward_percent').parent().parent().show();
        }

        jQuery('#rs_global_referral_reward_type').change(function () {
            if (jQuery('#rs_global_referral_reward_type').val() == '1') {
                jQuery('#rs_global_referral_reward_point').parent().parent().show();
                jQuery('#rs_global_referral_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_referral_reward_point').parent().parent().hide();
                jQuery('#rs_global_referral_reward_percent').parent().parent().show();
            }
        });

        if (jQuery('#rs_global_referral_reward_type_refer').val() == '1') {
            jQuery('#rs_global_referral_reward_point_get_refer').parent().parent().show();
            jQuery('#rs_global_referral_reward_percent_get_refer').parent().parent().hide();
        } else {
            jQuery('#rs_global_referral_reward_percent_get_refer').parent().parent().show();
            jQuery('#rs_global_referral_reward_point_get_refer').parent().parent().hide();
        }

        jQuery('#rs_global_referral_reward_type_refer').change(function () {
            if (jQuery('#rs_global_referral_reward_type_refer').val() == '1') {
                jQuery('#rs_global_referral_reward_point_get_refer').parent().parent().show();
                jQuery('#rs_global_referral_reward_percent_get_refer').parent().parent().hide();
            } else {
                jQuery('#rs_global_referral_reward_point_get_refer').parent().parent().hide();
                jQuery('#rs_global_referral_reward_percent_get_refer').parent().parent().show();
            }
        });
    }


    jQuery('#rs_global_enable_disable_sumo_referral_reward').change(function () {
        if (jQuery(this).val() == '2') {
            jQuery('.show_if_enable_in_referral').parent().parent().hide();
        } else {
            jQuery('.show_if_enable_in_referral').parent().parent().show();

            //To Show or hide Referral Points or Percentage for SUMO Reward.
            if (jQuery('#rs_global_referral_reward_type').val() == '1') {
                jQuery('#rs_global_referral_reward_point').parent().parent().show();
                jQuery('#rs_global_referral_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_referral_reward_point').parent().parent().hide();
                jQuery('#rs_global_referral_reward_percent').parent().parent().show();
            }

            jQuery('#rs_global_referral_reward_type').change(function () {
                if (jQuery('#rs_global_referral_reward_type').val() == '1') {
                    jQuery('#rs_global_referral_reward_point').parent().parent().show();
                    jQuery('#rs_global_referral_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_referral_reward_point').parent().parent().hide();
                    jQuery('#rs_global_referral_reward_percent').parent().parent().show();
                }
            });

            if (jQuery('#rs_global_referral_reward_type_refer').val() == '1') {
                jQuery('#rs_global_referral_reward_point_get_refer').parent().parent().show();
                jQuery('#rs_global_referral_reward_percent_get_refer').parent().parent().hide();
            } else {
                jQuery('#rs_global_referral_reward_percent_get_refer').parent().parent().show();
                jQuery('#rs_global_referral_reward_point_get_refer').parent().parent().hide();
            }

            jQuery('#rs_global_referral_reward_type_refer').change(function () {
                if (jQuery('#rs_global_referral_reward_type_refer').val() == '1') {
                    jQuery('#rs_global_referral_reward_point_get_refer').parent().parent().show();
                    jQuery('#rs_global_referral_reward_percent_get_refer').parent().parent().hide();
                } else {
                    jQuery('#rs_global_referral_reward_point_get_refer').parent().parent().hide();
                    jQuery('#rs_global_referral_reward_percent_get_refer').parent().parent().show();
                }
            });
        }
    });

    //To Show or hide Maximum Discount Type as Fixed Value or Percentage.
    if (jQuery('#rs_max_redeem_discount').val() == '1') {
        jQuery('#rs_fixed_max_redeem_discount').parent().parent().show();
        jQuery('#rs_percent_max_redeem_discount').parent().parent().hide();
    } else {
        jQuery('#rs_fixed_max_redeem_discount').parent().parent().hide();
        jQuery('#rs_percent_max_redeem_discount').parent().parent().show();
    }

    jQuery('#rs_max_redeem_discount').change(function () {
        if (jQuery('#rs_max_redeem_discount').val() == '1') {
            jQuery('#rs_fixed_max_redeem_discount').parent().parent().show();
            jQuery('#rs_percent_max_redeem_discount').parent().parent().hide();
        } else {
            jQuery('#rs_fixed_max_redeem_discount').parent().parent().hide();
            jQuery('#rs_percent_max_redeem_discount').parent().parent().show();
        }
    });

    //To Show or hide Referral Cookie Expiry as Minutes,Hours or Days.
    if (jQuery('#rs_referral_cookies_expiry').val() == '1') {
        jQuery('#rs_referral_cookies_expiry_in_min').parent().parent().show();
        jQuery('#rs_referral_cookies_expiry_in_hours').parent().parent().hide();
        jQuery('#rs_referral_cookies_expiry_in_days').parent().parent().hide();
    } else if (jQuery('#rs_referral_cookies_expiry').val() == '2') {
        jQuery('#rs_referral_cookies_expiry_in_min').parent().parent().hide();
        jQuery('#rs_referral_cookies_expiry_in_hours').parent().parent().show();
        jQuery('#rs_referral_cookies_expiry_in_days').parent().parent().hide();
    } else {
        jQuery('#rs_referral_cookies_expiry_in_min').parent().parent().hide();
        jQuery('#rs_referral_cookies_expiry_in_hours').parent().parent().hide();
        jQuery('#rs_referral_cookies_expiry_in_days').parent().parent().show();
    }

    jQuery('#rs_referral_cookies_expiry').change(function () {
        if (jQuery('#rs_referral_cookies_expiry').val() == '1') {
            jQuery('#rs_referral_cookies_expiry_in_min').parent().parent().show();
            jQuery('#rs_referral_cookies_expiry_in_hours').parent().parent().hide();
            jQuery('#rs_referral_cookies_expiry_in_days').parent().parent().hide();
        } else if (jQuery('#rs_referral_cookies_expiry').val() == '2') {
            jQuery('#rs_referral_cookies_expiry_in_min').parent().parent().hide();
            jQuery('#rs_referral_cookies_expiry_in_hours').parent().parent().show();
            jQuery('#rs_referral_cookies_expiry_in_days').parent().parent().hide();
        } else {
            jQuery('#rs_referral_cookies_expiry_in_min').parent().parent().hide();
            jQuery('#rs_referral_cookies_expiry_in_hours').parent().parent().hide();
            jQuery('#rs_referral_cookies_expiry_in_days').parent().parent().show();
        }
    });

    //To Show or hide Referral Should be applied for Unlimited or Limited.
    if (jQuery('#_rs_select_referral_points_referee_time').val() == '2') {
        jQuery('#_rs_select_referral_points_referee_time_content').parent().parent().show();
    } else {
        jQuery('#_rs_select_referral_points_referee_time_content').parent().parent().hide();
    }

    jQuery('#_rs_select_referral_points_referee_time').change(function () {
        if (jQuery('#_rs_select_referral_points_referee_time').val() == '2') {
            jQuery('#_rs_select_referral_points_referee_time_content').parent().parent().show();
        } else {
            jQuery('#_rs_select_referral_points_referee_time_content').parent().parent().hide();
        }
    });

    //Revise Referral Points Enable/Disable
    if (jQuery('#_rs_reward_referal_point_user_deleted').val() == '1') {
        jQuery('#_rs_time_validity_to_redeem').closest('tr').show();
        if (jQuery('#_rs_time_validity_to_redeem').val() == '2') {
            jQuery('#_rs_days_for_redeeming_points').closest('tr').show();
        } else {
            jQuery('#_rs_days_for_redeeming_points').closest('tr').hide();
        }

        jQuery('#_rs_time_validity_to_redeem').change(function () {
            if (jQuery('#_rs_time_validity_to_redeem').val() == '2') {
                jQuery('#_rs_days_for_redeeming_points').closest('tr').show();
            } else {
                jQuery('#_rs_days_for_redeeming_points').closest('tr').hide();
            }
        });
    } else {
        jQuery('#_rs_time_validity_to_redeem').closest('tr').hide();
        jQuery('#_rs_days_for_redeeming_points').closest('tr').hide();
    }

    jQuery('#_rs_reward_referal_point_user_deleted').change(function () {
        if (jQuery('#_rs_reward_referal_point_user_deleted').val() == '1') {
            jQuery('#_rs_time_validity_to_redeem').closest('tr').show();
            if (jQuery('#_rs_time_validity_to_redeem').val() == '2') {
                jQuery('#_rs_days_for_redeeming_points').closest('tr').show();
            } else {
                jQuery('#_rs_days_for_redeeming_points').closest('tr').hide();
            }

            jQuery('#_rs_time_validity_to_redeem').change(function () {
                if (jQuery('#_rs_time_validity_to_redeem').val() == '2') {
                    jQuery('#_rs_days_for_redeeming_points').closest('tr').show();
                } else {
                    jQuery('#_rs_days_for_redeeming_points').closest('tr').hide();
                }
            });
        } else {
            jQuery('#_rs_time_validity_to_redeem').closest('tr').hide();
            jQuery('#_rs_days_for_redeeming_points').closest('tr').hide();
        }
    });

    jQuery('.button-primary').click(function (e) {
        if (jQuery('#_rs_select_referral_points_referee_time_content').val() != '' && jQuery('#_rs_days_for_redeeming_points').val() != '') {
            var referral_points_referee_time_content = Number(jQuery('#_rs_select_referral_points_referee_time_content').val());
            var days_for_redeeming_points = Number(jQuery('#_rs_days_for_redeeming_points').val());
            if (referral_points_referee_time_content > days_for_redeeming_points) {
                e.preventDefault();
                jQuery('#_rs_days_for_redeeming_points').focus();
                jQuery("#_rs_days_for_redeeming_points").after("<div class='validation' style='color:red;margin-bottom: 20px;'>Please enter</div>");
            }
        }
    });

    //To Show or Hide No of Purchase Field
    if (jQuery('#rs_enable_delete_referral_cookie_after_first_purchase').is(":checked") == false) {
        jQuery('#rs_no_of_purchase').parent().parent().hide();
    } else {
        jQuery('#rs_no_of_purchase').parent().parent().show();
    }

    jQuery('#rs_enable_delete_referral_cookie_after_first_purchase').change(function () {
        if (jQuery('#rs_enable_delete_referral_cookie_after_first_purchase').is(":checked") == false) {
            jQuery('#rs_no_of_purchase').parent().parent().hide();
        } else {
            jQuery('#rs_no_of_purchase').parent().parent().show();
        }
    });



    //To show or hide gift icon
    if (jQuery('#_rs_enable_disable_gift_icon').val() == '2') {
        jQuery('#rs_image_url_upload').parent().parent().hide();
    } else {
        jQuery('#rs_image_url_upload').parent().parent().show();
    }

    jQuery('#_rs_enable_disable_gift_icon').change(function () {
        if (jQuery('#_rs_enable_disable_gift_icon').val() == '2') {
            jQuery('#rs_image_url_upload').parent().parent().hide();
        } else {
            jQuery('#rs_image_url_upload').parent().parent().show();
        }
    });

    /*Show or hide Settings for General Tab - End*/

    /*Show or hide Settings for Reward Points for Action Tab - Start*/

    if (jQuery('#_rs_referral_enable_signups').is(':checked') == true) {
        jQuery('#rs_select_referral_points_award').closest('tr').show();
        jQuery('#rs_referral_reward_signup').closest('tr').show();
        if (jQuery('#rs_select_referral_points_award').val() == '1') {
            jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
            jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
            jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').show();
        } else if (jQuery('#rs_select_referral_points_award').val() == '2') {
            jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
            jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
            jQuery('#rs_number_of_order_for_referral_points').closest('tr').show();
        } else if (jQuery('#rs_select_referral_points_award').val() == '3') {
            jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
            jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
            jQuery('#rs_amount_of_order_for_referral_points').closest('tr').show();
        }

        jQuery('#rs_select_referral_points_award').change(function () {
            if (jQuery('#rs_select_referral_points_award').val() == '1') {
                jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
                jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
                jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').show();
            } else if (jQuery('#rs_select_referral_points_award').val() == '2') {
                jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
                jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
                jQuery('#rs_number_of_order_for_referral_points').closest('tr').show();
            } else if (jQuery('#rs_select_referral_points_award').val() == '3') {
                jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
                jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
                jQuery('#rs_amount_of_order_for_referral_points').closest('tr').show();
            }
        });

        if (jQuery('#rs_referral_reward_signup_getting_refer').val() == '1') {
            jQuery('#rs_referral_reward_getting_refer').closest('tr').show();
            jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').show();
            jQuery('#rs_send_mail_getting_referred').closest('tr').show();
            if (jQuery('#rs_send_mail_getting_referred').is(':checked') == true) {
                jQuery('#rs_email_subject_getting_referred').closest('tr').show();
                jQuery('#rs_email_message_getting_referred').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                jQuery('#rs_email_message_getting_referred').closest('tr').hide();
            }

            jQuery('#rs_send_mail_getting_referred').change(function () {
                if (jQuery('#rs_send_mail_getting_referred').is(':checked') == true) {
                    jQuery('#rs_email_subject_getting_referred').closest('tr').show();
                    jQuery('#rs_email_message_getting_referred').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                    jQuery('#rs_email_message_getting_referred').closest('tr').hide();
                }
            });
        } else if (jQuery('#rs_referral_reward_signup_getting_refer').val() == '2') {
            jQuery('#rs_referral_reward_getting_refer').closest('tr').hide();
            jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').hide();
            jQuery('#rs_send_mail_getting_referred').closest('tr').hide();
            jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
            jQuery('#rs_email_message_getting_referred').closest('tr').hide();
        }

        jQuery('#rs_referral_reward_signup_getting_refer').change(function () {
            if (jQuery('#rs_referral_reward_signup_getting_refer').val() == '1') {
                jQuery('#rs_referral_reward_getting_refer').closest('tr').show();
                jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').show();
                jQuery('#rs_send_mail_getting_referred').closest('tr').show();
                if (jQuery('#rs_send_mail_getting_referred').is(':checked') == true) {
                    jQuery('#rs_email_subject_getting_referred').closest('tr').show();
                    jQuery('#rs_email_message_getting_referred').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                    jQuery('#rs_email_message_getting_referred').closest('tr').hide();
                }

                jQuery('#rs_send_mail_getting_referred').change(function () {
                    if (jQuery('#rs_send_mail_getting_referred').is(':checked') == true) {
                        jQuery('#rs_email_subject_getting_referred').closest('tr').show();
                        jQuery('#rs_email_message_getting_referred').closest('tr').show();
                    } else {
                        jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                        jQuery('#rs_email_message_getting_referred').closest('tr').hide();
                    }
                });
            } else if (jQuery('#rs_referral_reward_signup_getting_refer').val() == '2') {
                jQuery('#rs_referral_reward_getting_refer').closest('tr').hide();
                jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').hide();
                jQuery('#rs_send_mail_getting_referred').closest('tr').hide();
                jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                jQuery('#rs_email_message_getting_referred').closest('tr').hide();
            }
        });
        jQuery('#rs_send_mail_referral_signup').closest('tr').show();
        if (jQuery('#rs_send_mail_referral_signup').is(':checked') == true) {
            jQuery('#rs_email_subject_referral_signup').closest('tr').show();
            jQuery('#rs_email_message_referral_signup').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_referral_signup').closest('tr').hide();
            jQuery('#rs_email_message_referral_signup').closest('tr').hide();
        }

        jQuery('#rs_send_mail_referral_signup').change(function () {
            if (jQuery('#rs_send_mail_referral_signup').is(':checked') == true) {
                jQuery('#rs_email_subject_referral_signup').closest('tr').show();
                jQuery('#rs_email_message_referral_signup').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_referral_signup').closest('tr').hide();
                jQuery('#rs_email_message_referral_signup').closest('tr').hide();
            }
        });
    } else {
        jQuery('#rs_select_referral_points_award').closest('tr').hide();
        jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
        jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
        jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
        jQuery('#rs_referral_reward_getting_refer').closest('tr').hide();
        jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').hide();
        jQuery('#rs_send_mail_getting_referred').closest('tr').hide();
        jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
        jQuery('#rs_email_message_getting_referred').closest('tr').hide();
        jQuery('#rs_referral_reward_signup_getting_refer').closest('tr').hide();
        jQuery('#rs_referral_reward_signup').closest('tr').hide();
        jQuery('#rs_email_subject_referral_signup').closest('tr').hide();
        jQuery('#rs_email_message_referral_signup').closest('tr').hide();
        jQuery('#rs_send_mail_referral_signup').closest('tr').hide();
    }

    jQuery('#_rs_referral_enable_signups').change(function () {
        if (jQuery('#_rs_referral_enable_signups').is(':checked') == true) {
            jQuery('#rs_select_referral_points_award').closest('tr').show();
            jQuery('#rs_referral_reward_signup').closest('tr').show();
            if (jQuery('#rs_select_referral_points_award').val() == '1') {
                jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
                jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
                jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').show();
            } else if (jQuery('#rs_select_referral_points_award').val() == '2') {
                jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
                jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
                jQuery('#rs_number_of_order_for_referral_points').closest('tr').show();
            } else if (jQuery('#rs_select_referral_points_award').val() == '3') {
                jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
                jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
                jQuery('#rs_amount_of_order_for_referral_points').closest('tr').show();
            }

            jQuery('#rs_select_referral_points_award').change(function () {
                if (jQuery('#rs_select_referral_points_award').val() == '1') {
                    jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
                    jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
                    jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').show();
                } else if (jQuery('#rs_select_referral_points_award').val() == '2') {
                    jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
                    jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
                    jQuery('#rs_number_of_order_for_referral_points').closest('tr').show();
                } else if (jQuery('#rs_select_referral_points_award').val() == '3') {
                    jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
                    jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
                    jQuery('#rs_amount_of_order_for_referral_points').closest('tr').show();
                }
            });

            if (jQuery('#rs_referral_reward_signup_getting_refer').val() == '1') {
                jQuery('#rs_referral_reward_getting_refer').closest('tr').show();
                jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').show();
                jQuery('#rs_send_mail_getting_referred').closest('tr').show();
                if (jQuery('#rs_send_mail_getting_referred').is(':checked') == true) {
                    jQuery('#rs_email_subject_getting_referred').closest('tr').show();
                    jQuery('#rs_email_message_getting_referred').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                    jQuery('#rs_email_message_getting_referred').closest('tr').hide();
                }

                jQuery('#rs_send_mail_getting_referred').change(function () {
                    if (jQuery('#rs_send_mail_getting_referred').is(':checked') == true) {
                        jQuery('#rs_email_subject_getting_referred').closest('tr').show();
                        jQuery('#rs_email_message_getting_referred').closest('tr').show();
                    } else {
                        jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                        jQuery('#rs_email_message_getting_referred').closest('tr').hide();
                    }
                });
            } else if (jQuery('#rs_referral_reward_signup_getting_refer').val() == '2') {
                jQuery('#rs_referral_reward_getting_refer').closest('tr').hide();
                jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').hide();
                jQuery('#rs_send_mail_getting_referred').closest('tr').hide();
                jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                jQuery('#rs_email_message_getting_referred').closest('tr').hide();
            }

            jQuery('#rs_referral_reward_signup_getting_refer').change(function () {
                if (jQuery('#rs_referral_reward_signup_getting_refer').val() == '1') {
                    jQuery('#rs_referral_reward_getting_refer').closest('tr').show();
                    jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').show();
                    jQuery('#rs_send_mail_getting_referred').closest('tr').show();
                    if (jQuery('#rs_send_mail_getting_referred').is(':checked') == true) {
                        jQuery('#rs_email_subject_getting_referred').closest('tr').show();
                        jQuery('#rs_email_message_getting_referred').closest('tr').show();
                    } else {
                        jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                        jQuery('#rs_email_message_getting_referred').closest('tr').hide();
                    }

                    jQuery('#rs_send_mail_getting_referred').change(function () {
                        if (jQuery('#rs_send_mail_getting_referred').is(':checked') == true) {
                            jQuery('#rs_email_subject_getting_referred').closest('tr').show();
                            jQuery('#rs_email_message_getting_referred').closest('tr').show();
                        } else {
                            jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                            jQuery('#rs_email_message_getting_referred').closest('tr').hide();
                        }
                    });
                } else if (jQuery('#rs_referral_reward_signup_getting_refer').val() == '2') {
                    jQuery('#rs_referral_reward_getting_refer').closest('tr').hide();
                    jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').hide();
                    jQuery('#rs_send_mail_getting_referred').closest('tr').hide();
                    jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
                    jQuery('#rs_email_message_getting_referred').closest('tr').hide();
                }
            });
            jQuery('#rs_send_mail_referral_signup').closest('tr').show();
            if (jQuery('#rs_send_mail_referral_signup').is(':checked') == true) {
                jQuery('#rs_email_subject_referral_signup').closest('tr').show();
                jQuery('#rs_email_message_referral_signup').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_referral_signup').closest('tr').hide();
                jQuery('#rs_email_message_referral_signup').closest('tr').hide();
            }

            jQuery('#rs_send_mail_referral_signup').change(function () {
                if (jQuery('#rs_send_mail_referral_signup').is(':checked') == true) {
                    jQuery('#rs_email_subject_referral_signup').closest('tr').show();
                    jQuery('#rs_email_message_referral_signup').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_referral_signup').closest('tr').hide();
                    jQuery('#rs_email_message_referral_signup').closest('tr').hide();
                }
            });
        } else {
            jQuery('#rs_select_referral_points_award').closest('tr').hide();
            jQuery('#rs_number_of_order_for_referral_points').closest('tr').hide();
            jQuery('#rs_amount_of_order_for_referral_points').closest('tr').hide();
            jQuery('#rs_referral_reward_signup_after_first_purchase').closest('tr').hide();
            jQuery('#rs_referral_reward_getting_refer').closest('tr').hide();
            jQuery('#rs_referral_reward_getting_refer_after_first_purchase').closest('tr').hide();
            jQuery('#rs_send_mail_getting_referred').closest('tr').hide();
            jQuery('#rs_email_subject_getting_referred').closest('tr').hide();
            jQuery('#rs_email_message_getting_referred').closest('tr').hide();
            jQuery('#rs_referral_reward_signup_getting_refer').closest('tr').hide();
            jQuery('#rs_referral_reward_signup').closest('tr').hide();
            jQuery('#rs_email_subject_referral_signup').closest('tr').hide();
            jQuery('#rs_email_message_referral_signup').closest('tr').hide();
            jQuery('#rs_send_mail_referral_signup').closest('tr').hide();
        }
    });

    /*Show or Hide for bbPress - Start*/
    if (jQuery('#rs_enable_reward_points_for_create_topic').is(":checked") == false) {
        jQuery('#rs_reward_points_for_creatic_topic').parent().parent().hide();
    } else {
        jQuery('#rs_reward_points_for_creatic_topic').parent().parent().show();
    }

    jQuery('#rs_enable_reward_points_for_create_topic').change(function () {
        if (jQuery('#rs_enable_reward_points_for_create_topic').is(":checked") == false) {
            jQuery('#rs_reward_points_for_creatic_topic').parent().parent().hide();
        } else {
            jQuery('#rs_reward_points_for_creatic_topic').parent().parent().show();
        }
    });

    if (jQuery('#rs_enable_reward_points_for_reply_topic').is(":checked") == false) {
        jQuery('#rs_reward_points_for_reply_topic').parent().parent().hide();
    } else {
        jQuery('#rs_reward_points_for_reply_topic').parent().parent().show();
    }

    jQuery('#rs_enable_reward_points_for_reply_topic').change(function () {
        if (jQuery('#rs_enable_reward_points_for_reply_topic').is(":checked") == false) {
            jQuery('#rs_reward_points_for_reply_topic').parent().parent().hide();
        } else {
            jQuery('#rs_reward_points_for_reply_topic').parent().parent().show();
        }
    });
    /*Show or Hide bbPress - End*/

    /*Show or Hide for Social Login - Start*/
    if (jQuery('#rs_enable_for_social_account_linking').is(":checked") == false) {
        jQuery('#rs_reward_for_social_account_linking').parent().parent().hide();
        jQuery('#rs_send_mail_for_social_account_linking').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_for_social_account_linking').parent().parent().hide();
        jQuery('#rs_email_message_for_social_account_linking').parent().parent().hide();
    } else {
        jQuery('#rs_reward_for_social_account_linking').parent().parent().show();
        jQuery('#rs_send_mail_for_social_account_linking').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_for_social_account_linking').is(':checked') == true) {
            jQuery('#rs_email_subject_for_social_account_linking').parent().parent().show();
            jQuery('#rs_email_message_for_social_account_linking').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_for_social_account_linking').parent().parent().hide();
            jQuery('#rs_email_message_for_social_account_linking').parent().parent().hide();
        }

        jQuery('#rs_send_mail_for_social_account_linking').change(function () {
            if (jQuery('#rs_send_mail_for_social_account_linking').is(':checked') == true) {
                jQuery('#rs_email_subject_for_social_account_linking').parent().parent().show();
                jQuery('#rs_email_message_for_social_account_linking').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_for_social_account_linking').parent().parent().hide();
                jQuery('#rs_email_message_for_social_account_linking').parent().parent().hide();
            }
        });
    }

    jQuery('#rs_enable_for_social_account_linking').change(function () {
        if (jQuery('#rs_enable_for_social_account_linking').is(":checked") == false) {
            jQuery('#rs_reward_for_social_account_linking').parent().parent().hide();
            jQuery('#rs_send_mail_for_social_account_linking').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_for_social_account_linking').parent().parent().hide();
            jQuery('#rs_email_message_for_social_account_linking').parent().parent().hide();
        } else {
            jQuery('#rs_reward_for_social_account_linking').parent().parent().show();
            jQuery('#rs_send_mail_for_social_account_linking').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_for_social_account_linking').is(':checked') == true) {
                jQuery('#rs_email_subject_for_social_account_linking').parent().parent().show();
                jQuery('#rs_email_message_for_social_account_linking').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_for_social_account_linking').parent().parent().hide();
                jQuery('#rs_email_message_for_social_account_linking').parent().parent().hide();
            }

            jQuery('#rs_send_mail_for_social_account_linking').change(function () {
                if (jQuery('#rs_send_mail_for_social_account_linking').is(':checked') == true) {
                    jQuery('#rs_email_subject_for_social_account_linking').parent().parent().show();
                    jQuery('#rs_email_message_for_social_account_linking').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_for_social_account_linking').parent().parent().hide();
                    jQuery('#rs_email_message_for_social_account_linking').parent().parent().hide();
                }
            });
        }
    });
    /*Show or Hide for Social Login - End*/

    /*Show or Hide Reward Points for Waiting List - Start*/
    if (jQuery('#rs_enable_for_waitlist_subscribing').is(":checked") == false) {
        jQuery('#rs_reward_for_waitlist_subscribing').parent().parent().hide();
        jQuery('#rs_send_mail_for_waitlist_subscribing').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().hide();
        jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().hide();
    } else {
        jQuery('#rs_reward_for_waitlist_subscribing').parent().parent().show();
        jQuery('#rs_send_mail_for_waitlist_subscribing').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_for_waitlist_subscribing').is(':checked') == true) {
            jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().show();
            jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().hide();
            jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().hide();
        }

        jQuery('#rs_send_mail_for_waitlist_subscribing').change(function () {
            if (jQuery('#rs_send_mail_for_waitlist_subscribing').is(':checked') == true) {
                jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().show();
                jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().hide();
                jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().hide();
            }
        });
    }

    jQuery('#rs_enable_for_waitlist_subscribing').change(function () {
        if (jQuery('#rs_enable_for_waitlist_subscribing').is(":checked") == false) {
            jQuery('#rs_reward_for_waitlist_subscribing').parent().parent().hide();
            jQuery('#rs_send_mail_for_waitlist_subscribing').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().hide();
            jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().hide();
        } else {
            jQuery('#rs_reward_for_waitlist_subscribing').parent().parent().show();
            jQuery('#rs_send_mail_for_waitlist_subscribing').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_for_waitlist_subscribing').is(':checked') == true) {
                jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().show();
                jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().hide();
                jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().hide();
            }

            jQuery('#rs_send_mail_for_waitlist_subscribing').change(function () {
                if (jQuery('#rs_send_mail_for_waitlist_subscribing').is(':checked') == true) {
                    jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().show();
                    jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_for_waitlist_subscribing').parent().parent().hide();
                    jQuery('#rs_email_message_for_waitlist_subscribing').parent().parent().hide();
                }
            });
        }
    });

    if (jQuery('#rs_enable_for_waitlist_sale_conversion').is(":checked") == false) {
        jQuery('#rs_reward_for_waitlist_sale_conversion').parent().parent().hide();
        jQuery('#rs_send_mail_for_waitlist_sale_conversion').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().hide();
        jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().hide();
    } else {
        jQuery('#rs_reward_for_waitlist_sale_conversion').parent().parent().show();
        jQuery('#rs_send_mail_for_waitlist_sale_conversion').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_for_waitlist_sale_conversion').is(':checked') == true) {
            jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().show();
            jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().hide();
            jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().hide();
        }

        jQuery('#rs_send_mail_for_waitlist_sale_conversion').change(function () {
            if (jQuery('#rs_send_mail_for_waitlist_sale_conversion').is(':checked') == true) {
                jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().show();
                jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().hide();
                jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().hide();
            }
        });
    }

    jQuery('#rs_enable_for_waitlist_sale_conversion').change(function () {
        if (jQuery('#rs_enable_for_waitlist_sale_conversion').is(":checked") == false) {
            jQuery('#rs_reward_for_waitlist_sale_conversion').parent().parent().hide();
            jQuery('#rs_send_mail_for_waitlist_sale_conversion').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().hide();
            jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().hide();
        } else {
            jQuery('#rs_reward_for_waitlist_sale_conversion').parent().parent().show();
            jQuery('#rs_send_mail_for_waitlist_sale_conversion').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_for_waitlist_sale_conversion').is(':checked') == true) {
                jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().show();
                jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().hide();
                jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().hide();
            }

            jQuery('#rs_send_mail_for_waitlist_sale_conversion').change(function () {
                if (jQuery('#rs_send_mail_for_waitlist_sale_conversion').is(':checked') == true) {
                    jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().show();
                    jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_for_waitlist_sale_conversion').parent().parent().hide();
                    jQuery('#rs_email_message_for_waitlist_sale_conversion').parent().parent().hide();
                }
            });
        }
    });
    /*Show or Hide Reward Points for Waiting List - End*/

    /*Show or Hide Reward Points for Blog Post - Start*/
    if (jQuery('#rs_reward_for_Creating_Post').is(":checked") == false) {
        jQuery('#rs_reward_post').parent().parent().hide();
        jQuery('#rs_reward_post_review').parent().parent().hide();
        jQuery('#rs_send_mail_blog_post_create').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_blog_post_create').parent().parent().hide();
        jQuery('#rs_email_message_blog_post_create').parent().parent().hide();
    } else {
        jQuery('#rs_reward_post').parent().parent().show();
        jQuery('#rs_send_mail_blog_post_create').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_blog_post_create').is(':checked') == true) {
            jQuery('#rs_email_subject_blog_post_create').parent().parent().show();
            jQuery('#rs_email_message_blog_post_create').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_blog_post_create').parent().parent().hide();
            jQuery('#rs_email_message_blog_post_create').parent().parent().hide();
        }

        jQuery('#rs_send_mail_blog_post_create').change(function () {
            if (jQuery('#rs_send_mail_blog_post_create').is(':checked') == true) {
                jQuery('#rs_email_subject_blog_post_create').parent().parent().show();
                jQuery('#rs_email_message_blog_post_create').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_blog_post_create').parent().parent().hide();
                jQuery('#rs_email_message_blog_post_create').parent().parent().hide();
            }
        });
    }

    jQuery('#rs_reward_for_Creating_Post').change(function () {

        if (jQuery('#rs_reward_for_Creating_Post').is(":checked") == false) {
            jQuery('#rs_reward_post').parent().parent().hide();
            jQuery('#rs_reward_post_review').parent().parent().hide();
            jQuery('#rs_send_mail_blog_post_create').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_blog_post_create').parent().parent().hide();
            jQuery('#rs_email_message_blog_post_create').parent().parent().hide();
        } else {
            jQuery('#rs_reward_post').parent().parent().show();
            jQuery('#rs_send_mail_blog_post_create').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_blog_post_create').is(':checked') == true) {
                jQuery('#rs_email_subject_blog_post_create').parent().parent().show();
                jQuery('#rs_email_message_blog_post_create').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_blog_post_create').parent().parent().hide();
                jQuery('#rs_email_message_blog_post_create').parent().parent().hide();
            }

            jQuery('#rs_send_mail_blog_post_create').change(function () {
                if (jQuery('#rs_send_mail_blog_post_create').is(':checked') == true) {
                    jQuery('#rs_email_subject_blog_post_create').parent().parent().show();
                    jQuery('#rs_email_message_blog_post_create').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_blog_post_create').parent().parent().hide();
                    jQuery('#rs_email_message_blog_post_create').parent().parent().hide();
                }
            });
        }
    });

    if (jQuery('#rs_reward_for_comment_Post').is(":checked") == false) {
        jQuery('#rs_restrict_reward_post_comment').parent().parent().parent().parent().hide();
        jQuery('.rs_post_comment_reward_status').closest('tr').hide();
        jQuery('#rs_reward_post_review').parent().parent().hide();
        jQuery('#rs_send_mail_blog_post_comment').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_blog_post_comment').parent().parent().hide();
        jQuery('#rs_email_message_blog_post_comment').parent().parent().hide();
    } else {
        jQuery('#rs_reward_post_review').parent().parent().show();
        jQuery('.rs_post_comment_reward_status').closest('tr').show();
        jQuery('#rs_restrict_reward_post_comment').parent().parent().parent().parent().show();
        jQuery('#rs_send_mail_blog_post_comment').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_blog_post_comment').is(':checked') == true) {
            jQuery('#rs_email_subject_blog_post_comment').parent().parent().show();
            jQuery('#rs_email_message_blog_post_comment').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_blog_post_comment').parent().parent().hide();
            jQuery('#rs_email_message_blog_post_comment').parent().parent().hide();
        }

        jQuery('#rs_send_mail_blog_post_comment').change(function () {
            if (jQuery('#rs_send_mail_blog_post_comment').is(':checked') == true) {
                jQuery('#rs_email_subject_blog_post_comment').parent().parent().show();
                jQuery('#rs_email_message_blog_post_comment').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_blog_post_comment').parent().parent().hide();
                jQuery('#rs_email_message_blog_post_comment').parent().parent().hide();
            }
        });
    }

    jQuery('#rs_reward_for_comment_Post').change(function () {
        if (jQuery('#rs_reward_for_comment_Post').is(":checked") == false) {
            jQuery('#rs_reward_post_review').parent().parent().hide();
            jQuery('.rs_post_comment_reward_status').closest('tr').hide();
            jQuery('#rs_restrict_reward_post_comment').parent().parent().parent().parent().hide();
            jQuery('#rs_send_mail_blog_post_comment').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_blog_post_comment').parent().parent().hide();
            jQuery('#rs_email_message_blog_post_comment').parent().parent().hide();
        } else {
            jQuery('#rs_reward_post_review').parent().parent().show();
            jQuery('.rs_post_comment_reward_status').closest('tr').show();
            jQuery('#rs_restrict_reward_post_comment').parent().parent().parent().parent().show();
            jQuery('#rs_send_mail_blog_post_comment').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_blog_post_comment').is(':checked') == true) {
                jQuery('#rs_email_subject_blog_post_comment').parent().parent().show();
                jQuery('#rs_email_message_blog_post_comment').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_blog_post_comment').parent().parent().hide();
                jQuery('#rs_email_message_blog_post_comment').parent().parent().hide();
            }

            jQuery('#rs_send_mail_blog_post_comment').change(function () {
                if (jQuery('#rs_send_mail_blog_post_comment').is(':checked') == true) {
                    jQuery('#rs_email_subject_blog_post_comment').parent().parent().show();
                    jQuery('#rs_email_message_blog_post_comment').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_blog_post_comment').parent().parent().hide();
                    jQuery('#rs_email_message_blog_post_comment').parent().parent().hide();
                }
            });
        }
    });
    /*Show or Hide Reward Points for Blog Post - End*/

    /*Show or Hide Reward Points for Product Creation - Start*/
    if (jQuery('#rs_reward_for_enable_product_create').is(":checked") == false) {
        jQuery('#rs_reward_Product_create').parent().parent().hide();
        jQuery('#rs_send_mail_product_create').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_product_create').parent().parent().hide();
        jQuery('#rs_email_message_product_create').parent().parent().hide();
    } else {
        jQuery('#rs_reward_Product_create').parent().parent().show();
        jQuery('#rs_send_mail_product_create').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_product_create').is(':checked') == true) {
            jQuery('#rs_email_subject_product_create').parent().parent().show();
            jQuery('#rs_email_message_product_create').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_product_create').parent().parent().hide();
            jQuery('#rs_email_message_product_create').parent().parent().hide();
        }

        jQuery('#rs_send_mail_product_create').change(function () {
            if (jQuery('#rs_send_mail_product_create').is(':checked') == true) {
                jQuery('#rs_email_subject_product_create').parent().parent().show();
                jQuery('#rs_email_message_product_create').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_product_create').parent().parent().hide();
                jQuery('#rs_email_message_product_create').parent().parent().hide();
            }
        });
    }

    jQuery('#rs_reward_for_enable_product_create').change(function () {
        if (jQuery('#rs_reward_for_enable_product_create').is(":checked") == false) {
            jQuery('#rs_reward_Product_create').parent().parent().hide();
            jQuery('#rs_send_mail_product_create').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_product_create').parent().parent().hide();
            jQuery('#rs_email_message_product_create').parent().parent().hide();
        } else {
            jQuery('#rs_reward_Product_create').parent().parent().show();
            jQuery('#rs_send_mail_product_create').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_product_create').is(':checked') == true) {
                jQuery('#rs_email_subject_product_create').parent().parent().show();
                jQuery('#rs_email_message_product_create').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_product_create').parent().parent().hide();
                jQuery('#rs_email_message_product_create').parent().parent().hide();
            }

            jQuery('#rs_send_mail_product_create').change(function () {
                if (jQuery('#rs_send_mail_product_create').is(':checked') == true) {
                    jQuery('#rs_email_subject_product_create').parent().parent().show();
                    jQuery('#rs_email_message_product_create').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_product_create').parent().parent().hide();
                    jQuery('#rs_email_message_product_create').parent().parent().hide();
                }
            });
        }
    });
    /*Show or Hide Reward Points for Product Creation - End*/

    /*Show or Hide Reward Points for Page Comment - Start*/
    if (jQuery('#rs_reward_for_comment_Page').is(":checked") == false) {
        jQuery('#rs_reward_page_review').parent().parent().hide();
        jQuery('.rs_page_comment_reward_status').closest('tr').hide();
        jQuery('#rs_restrict_reward_page_comment').parent().parent().parent().parent().hide();
        jQuery('#rs_send_mail_page_comment').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_page_comment').parent().parent().hide();
        jQuery('#rs_email_message_page_comment').parent().parent().hide();
    } else {
        jQuery('#rs_reward_page_review').parent().parent().show();
        jQuery('.rs_page_comment_reward_status').closest('tr').show();
        jQuery('#rs_restrict_reward_page_comment').parent().parent().parent().parent().show();
        jQuery('#rs_send_mail_page_comment').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_page_comment').is(':checked') == true) {
            jQuery('#rs_email_subject_page_comment').parent().parent().show();
            jQuery('#rs_email_message_page_comment').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_page_comment').parent().parent().hide();
            jQuery('#rs_email_message_page_comment').parent().parent().hide();
        }

        jQuery('#rs_send_mail_page_comment').change(function () {
            if (jQuery('#rs_send_mail_page_comment').is(':checked') == true) {
                jQuery('#rs_email_subject_page_comment').parent().parent().show();
                jQuery('#rs_email_message_page_comment').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_page_comment').parent().parent().hide();
                jQuery('#rs_email_message_page_comment').parent().parent().hide();
            }
        });
    }

    jQuery('#rs_reward_for_comment_Page').change(function () {
        if (jQuery('#rs_reward_for_comment_Page').is(":checked") == false) {
            jQuery('#rs_reward_page_review').parent().parent().hide();
            jQuery('.rs_page_comment_reward_status').closest('tr').hide();
            jQuery('#rs_restrict_reward_page_comment').parent().parent().parent().parent().hide();
            jQuery('#rs_send_mail_page_comment').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_page_comment').parent().parent().hide();
            jQuery('#rs_email_message_page_comment').parent().parent().hide();
        } else {
            jQuery('#rs_reward_page_review').parent().parent().show();
            jQuery('.rs_page_comment_reward_status').closest('tr').show();
            jQuery('#rs_restrict_reward_page_comment').parent().parent().parent().parent().show();
            jQuery('#rs_send_mail_page_comment').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_page_comment').is(':checked') == true) {
                jQuery('#rs_email_subject_page_comment').parent().parent().show();
                jQuery('#rs_email_message_page_comment').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_page_comment').parent().parent().hide();
                jQuery('#rs_email_message_page_comment').parent().parent().hide();
            }

            jQuery('#rs_send_mail_page_comment').change(function () {
                if (jQuery('#rs_send_mail_page_comment').is(':checked') == true) {
                    jQuery('#rs_email_subject_page_comment').parent().parent().show();
                    jQuery('#rs_email_message_page_comment').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_page_comment').parent().parent().hide();
                    jQuery('#rs_email_message_page_comment').parent().parent().hide();
                }
            });
        }
    });
    /*Show or Hide Reward Points for Page Comment - End*/

    /*Show or Hide Reward Points for Daily Login - Start*/
    if (jQuery('#rs_enable_reward_points_for_login').is(':checked')) {
        jQuery('#rs_reward_points_for_login').closest('tr').show();
        jQuery('#rs_reward_for_social_network_login').closest('tr').show();
        jQuery('#rs_send_mail_login').closest('tr').show();
        jQuery('#rs_enable_for_social_network_login').closest('tr').show();
        if (jQuery('#rs_send_mail_login').is(':checked')) {
            jQuery('#rs_email_subject_login').closest('tr').show();
            jQuery('#rs_email_message_login').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_login').closest('tr').hide();
            jQuery('#rs_email_message_login').closest('tr').hide();
        }

        jQuery('#rs_send_mail_login').change(function () {
            if (jQuery('#rs_send_mail_login').is(':checked')) {
                jQuery('#rs_email_subject_login').closest('tr').show();
                jQuery('#rs_email_message_login').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_login').closest('tr').hide();
                jQuery('#rs_email_message_login').closest('tr').hide();
            }
        });
    } else {
        jQuery('#rs_reward_points_for_login').closest('tr').hide();
        jQuery('#rs_reward_for_social_network_login').closest('tr').hide();
        jQuery('#rs_send_mail_login').closest('tr').hide();
        jQuery('#rs_email_subject_login').closest('tr').hide();
        jQuery('#rs_email_message_login').closest('tr').hide();
        jQuery('#rs_enable_for_social_network_login').closest('tr').hide();
    }
    jQuery('#rs_enable_reward_points_for_login').change(function () {
        if (jQuery('#rs_enable_reward_points_for_login').is(':checked')) {
            jQuery('#rs_reward_points_for_login').closest('tr').show();
            jQuery('#rs_reward_for_social_network_login').closest('tr').show();
            jQuery('#rs_send_mail_login').closest('tr').show();
            jQuery('#rs_enable_for_social_network_login').closest('tr').show();
            if (jQuery('#rs_send_mail_login').is(':checked')) {
                jQuery('#rs_email_subject_login').closest('tr').show();
                jQuery('#rs_email_message_login').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_login').closest('tr').hide();
                jQuery('#rs_email_message_login').closest('tr').hide();
            }

            jQuery('#rs_send_mail_login').change(function () {
                if (jQuery('#rs_send_mail_login').is(':checked')) {
                    jQuery('#rs_email_subject_login').closest('tr').show();
                    jQuery('#rs_email_message_login').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_login').closest('tr').hide();
                    jQuery('#rs_email_message_login').closest('tr').hide();
                }
            });
        } else {
            jQuery('#rs_reward_points_for_login').closest('tr').hide();
            jQuery('#rs_reward_for_social_network_login').closest('tr').hide();
            jQuery('#rs_send_mail_login').closest('tr').hide();
            jQuery('#rs_email_subject_login').closest('tr').hide();
            jQuery('#rs_email_message_login').closest('tr').hide();
            jQuery('#rs_enable_for_social_network_login').closest('tr').hide();
        }
    });
    /*Show or Hide Reward Points for Daily Login - End*/

    /*Show or hide Settings for Reward Points for Action Tab - End*/

    /*Show or hide Settings for Message Tab - Start*/

    if (jQuery('#rs_show_hide_message_for_single_product').val() == '1') {
        jQuery('#rs_message_for_single_product_point_rule').parent().parent().show();
    } else {
        jQuery('#rs_message_for_single_product_point_rule').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_single_product').change(function () {
        if (jQuery('#rs_show_hide_message_for_single_product').val() == '1') {
            jQuery('#rs_message_for_single_product_point_rule').parent().parent().show();
        } else {
            jQuery('#rs_message_for_single_product_point_rule').parent().parent().hide();
        }
    });

    //Show or Hide Earn Point Message in Shop Page
    if (jQuery('#rs_show_hide_message_for_simple_in_shop').val() == '1') {
        jQuery('#rs_message_in_shop_page_for_simple').parent().parent().show();
        jQuery('#rs_message_position_for_simple_products_in_shop_page').parent().parent().show();
    } else {
        jQuery('#rs_message_in_shop_page_for_simple').parent().parent().hide();
        jQuery('#rs_message_position_for_simple_products_in_shop_page').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_simple_in_shop').change(function () {
        if (jQuery('#rs_show_hide_message_for_simple_in_shop').val() == '1') {
            jQuery('#rs_message_in_shop_page_for_simple').parent().parent().show();
            jQuery('#rs_message_position_for_simple_products_in_shop_page').parent().parent().show();
        } else {
            jQuery('#rs_message_in_shop_page_for_simple').parent().parent().hide();
            jQuery('#rs_message_position_for_simple_products_in_shop_page').parent().parent().hide();
        }
    });

    //Show or Hide Buying Point Message for simple product in Shop Page
    if (jQuery('#rs_show_hide_buy_points_message_for_simple_in_shop').val() == '1') {
        jQuery('#rs_buy_point_message_in_shop_page_for_simple').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_in_shop_page_for_simple').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_points_message_for_simple_in_shop').change(function () {
        if (jQuery('#rs_show_hide_buy_points_message_for_simple_in_shop').val() == '1') {
            jQuery('#rs_buy_point_message_in_shop_page_for_simple').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_in_shop_page_for_simple').parent().parent().hide();
        }
    });
    //Show or Hide Buying Point Message for variable product in Shop Page
    if (jQuery('#rs_show_hide_buy_points_message_for_variable_in_shop').val() == '1') {
        jQuery('#rs_buy_point_message_in_shop_page_for_variable').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_in_shop_page_for_variable').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_points_message_for_variable_in_shop').change(function () {
        if (jQuery('#rs_show_hide_buy_points_message_for_variable_in_shop').val() == '1') {
            jQuery('#rs_buy_point_message_in_shop_page_for_variable').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_in_shop_page_for_variable').parent().parent().hide();
        }
    });

    //Show or Hide Earn Point Message in Custom Page
    if (jQuery('#rs_show_hide_message_for_simple_in_custom_shop').val() == '1') {
        jQuery('#rs_message_in_custom_shop_page_for_simple').parent().parent().show();
        jQuery('#rs_message_position_for_simple_products_in_custom_shop_page').parent().parent().show();
    } else {
        jQuery('#rs_message_in_custom_shop_page_for_simple').parent().parent().hide();
        jQuery('#rs_message_position_for_simple_products_in_custom_shop_page').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_simple_in_custom_shop').change(function () {
        if (jQuery('#rs_show_hide_message_for_simple_in_custom_shop').val() == '1') {
            jQuery('#rs_message_in_custom_shop_page_for_simple').parent().parent().show();
            jQuery('#rs_message_position_for_simple_products_in_custom_shop_page').parent().parent().show();
        } else {
            jQuery('#rs_message_in_custom_shop_page_for_simple').parent().parent().hide();
            jQuery('#rs_message_position_for_simple_products_in_custom_shop_page').parent().parent().hide();
        }
    });

    //Show or Hide Buying Point Message for simple product in Custom Page
    if (jQuery('#rs_show_hide_buy_points_message_for_simple_in_custom').val() == '1') {
        jQuery('#rs_buy_point_message_in_custom_shop_page_for_simple').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_in_custom_shop_page_for_simple').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_points_message_for_simple_in_custom').change(function () {
        if (jQuery('#rs_show_hide_buy_points_message_for_simple_in_custom').val() == '1') {
            jQuery('#rs_buy_point_message_in_custom_shop_page_for_simple').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_in_custom_shop_page_for_simple').parent().parent().hide();
        }
    });
    //Show or Hide Buying Point Message for variable product in Custom Page
    if (jQuery('#rs_enable_display_earn_message_for_variation_custom_shop').val() == '1') {
        jQuery('#rs_message_for_custom_shop_variation').parent().parent().show();
    } else {
        jQuery('#rs_message_for_custom_shop_variation').parent().parent().hide();
    }

    jQuery('#rs_enable_display_earn_message_for_variation_custom_shop').change(function () {
        if (jQuery('#rs_enable_display_earn_message_for_variation_custom_shop').val() == '1') {
            jQuery('#rs_message_for_custom_shop_variation').parent().parent().show();
        } else {
            jQuery('#rs_message_for_custom_shop_variation').parent().parent().hide();
        }
    });
    //Show or Hide Buying Point Message for variable product in Custom Page
    if (jQuery('#rs_show_hide_buy_points_message_for_variable_in_custom_shop').val() == '1') {
        jQuery('#rs_buy_point_message_in_custom_shop_page_for_variable').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_in_custom_shop_page_for_variable').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_points_message_for_variable_in_custom_shop').change(function () {
        if (jQuery('#rs_show_hide_buy_points_message_for_variable_in_custom_shop').val() == '1') {
            jQuery('#rs_buy_point_message_in_custom_shop_page_for_variable').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_in_custom_shop_page_for_variable').parent().parent().hide();
        }
    });


    //Show or Hide Buying Point Message for simple product in product Page
    if (jQuery('#rs_show_hide_buy_points_message_for_simple_in_product').val() == '1') {
        jQuery('#rs_buy_point_message_in_product_page_for_simple').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_in_product_page_for_simple').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_points_message_for_simple_in_product').change(function () {
        if (jQuery('#rs_show_hide_buy_points_message_for_simple_in_product').val() == '1') {
            jQuery('#rs_buy_point_message_in_product_page_for_simple').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_in_product_page_for_simple').parent().parent().hide();
        }
    });

    //Show or Hide Buying Point Message for variable product in product Page
    if (jQuery('#rs_show_hide_buy_points_message_for_variable_in_product').val() == '1') {
        jQuery('#rs_buy_point_message_in_product_page_for_variable').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_in_product_page_for_variable').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_points_message_for_variable_in_product').change(function () {
        if (jQuery('#rs_show_hide_buy_points_message_for_variable_in_product').val() == '1') {
            jQuery('#rs_buy_point_message_in_product_page_for_variable').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_in_product_page_for_variable').parent().parent().hide();
        }
    });

    //Show or Hide Message for booking product in product Page
    if (jQuery('#rs_show_hide_message_for_booking_product').val() == '1') {
        jQuery('#rs_message_for_booking_product').parent().parent().show();
    } else {
        jQuery('#rs_message_for_booking_product').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_booking_product').change(function () {
        if (jQuery('#rs_show_hide_message_for_booking_product').val() == '1') {
            jQuery('#rs_message_for_booking_product').parent().parent().show();
        } else {
            jQuery('#rs_message_for_booking_product').parent().parent().hide();
        }
    });

    //Show or Hide Message for product review in product Page
    if (jQuery('#rs_show_hide_message_for_product_review').val() == '1') {
        jQuery('#rs_message_for_product_review').parent().parent().show();
    } else {
        jQuery('#rs_message_for_product_review').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_product_review').change(function () {
        if (jQuery('#rs_show_hide_message_for_product_review').val() == '1') {
            jQuery('#rs_message_for_product_review').parent().parent().show();
        } else {
            jQuery('#rs_message_for_product_review').parent().parent().hide();
        }
    });

    //Show or Hide Message for Subscribing Product in product Page
    if (jQuery('#rs_show_hide_message_for_waitlist').val() == '1') {
        jQuery('#rs_message_for_subscribing_product').parent().parent().show();
    } else {
        jQuery('#rs_message_for_subscribing_product').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_waitlist').change(function () {
        if (jQuery('#rs_show_hide_message_for_waitlist').val() == '1') {
            jQuery('#rs_message_for_subscribing_product').parent().parent().show();
        } else {
            jQuery('#rs_message_for_subscribing_product').parent().parent().hide();
        }
    });

    //Show or Hide Message for Simple and Variable Product in Related product Page

    if (jQuery('#rs_show_hide_message_for_shop_archive_single_related_products').val() == '1') {
        jQuery('#rs_message_in_single_product_page_related_products').parent().parent().show();
    } else {
        jQuery('#rs_message_in_single_product_page_related_products').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_shop_archive_single_related_products').change(function () {
        if (jQuery('#rs_show_hide_message_for_shop_archive_single_related_products').val() == '1') {
            jQuery('#rs_message_in_single_product_page_related_products').parent().parent().show();
        } else {
            jQuery('#rs_message_in_single_product_page_related_products').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_message_for_shop_archive_variable_related_products').val() == '1') {
        jQuery('#rs_message_in_variable_related_products').parent().parent().show();
    } else {
        jQuery('#rs_message_in_variable_related_products').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_shop_archive_variable_related_products').change(function () {
        if (jQuery('#rs_show_hide_message_for_shop_archive_variable_related_products').val() == '1') {
            jQuery('#rs_message_in_variable_related_products').parent().parent().show();
        } else {
            jQuery('#rs_message_in_variable_related_products').parent().parent().hide();
        }
    });

    //Show or Hide Earn Point Message in Single Product Page
    if (jQuery('#rs_show_hide_message_for_shop_archive_single').val() == '1') {
        jQuery('#rs_message_in_single_product_page').parent().parent().show();
    } else {
        jQuery('#rs_message_in_single_product_page').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_shop_archive_single').change(function () {
        if (jQuery('#rs_show_hide_message_for_shop_archive_single').val() == '1') {
            jQuery('#rs_message_in_single_product_page').parent().parent().show();
        } else {
            jQuery('#rs_message_in_single_product_page').parent().parent().hide();
        }
    });

    //Show or Hide Earn Point Message in Single Product Page for Variable Products
    if (jQuery('#rs_show_hide_message_for_variable_in_single_product_page').val() == '1') {
        jQuery('#rs_message_for_single_product_variation').parent().parent().show();
        jQuery('#rs_message_position_in_single_product_page_for_simple_products').parent().parent().show();
    } else {
        jQuery('#rs_message_for_single_product_variation').parent().parent().hide();
        jQuery('#rs_message_position_in_single_product_page_for_simple_products').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_variable_in_single_product_page').change(function () {
        if (jQuery('#rs_show_hide_message_for_variable_in_single_product_page').val() == '1') {
            jQuery('#rs_message_for_single_product_variation').parent().parent().show();
            jQuery('#rs_message_position_in_single_product_page_for_simple_products').parent().parent().show();
        } else {
            jQuery('#rs_message_for_single_product_variation').parent().parent().hide();
            jQuery('#rs_message_position_in_single_product_page_for_simple_products').parent().parent().hide();
        }
    });

    //Show or Hide Message for each Variant (Variable Product) in Single Product Page
    if (jQuery('#rs_show_hide_message_for_variable_product').val() == '1') {
        jQuery('#rs_message_for_variation_products').parent().parent().show();
    } else {
        jQuery('#rs_message_for_variation_products').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_variable_product').change(function () {
        if (jQuery('#rs_show_hide_message_for_variable_product').val() == '1') {
            jQuery('#rs_message_for_variation_products').parent().parent().show();
        } else {
            jQuery('#rs_message_for_variation_products').parent().parent().hide();
        }
    });


    //Show or Hide Message in Cart Page for each Products
    if (jQuery('#rs_show_hide_message_for_each_products').val() == '1') {
        jQuery('#rs_message_product_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_message_product_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_each_products').change(function () {
        if (jQuery('#rs_show_hide_message_for_each_products').val() == '1') {
            jQuery('#rs_message_product_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_message_product_in_cart').parent().parent().hide();
        }
    });

    //Show or Hide Buying Message in Cart Page for each Products
    if (jQuery('#rs_show_hide_buy_point_message_for_each_products').val() == '1') {
        jQuery('#rs_buy_point_message_product_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_product_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_point_message_for_each_products').change(function () {
        if (jQuery('#rs_show_hide_buy_point_message_for_each_products').val() == '1') {
            jQuery('#rs_buy_point_message_product_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_product_in_cart').parent().parent().hide();
        }
    });

    //Show or Hide Message in Cart Page for Completing the Total Purchase
    if (jQuery('#rs_show_hide_message_for_total_points').val() == '1') {
        jQuery('#rs_message_total_price_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_message_total_price_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_total_points').change(function () {
        if (jQuery('#rs_show_hide_message_for_total_points').val() == '1') {
            jQuery('#rs_message_total_price_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_message_total_price_in_cart').parent().parent().hide();
        }
    });

    //Show or Hide Message in Cart Page that display Your Reward Points
    if (jQuery('#rs_show_hide_message_for_my_rewards').val() == '1') {
        jQuery('#rs_message_user_points_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_message_user_points_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_my_rewards').change(function () {
        if (jQuery('#rs_show_hide_message_for_my_rewards').val() == '1') {
            jQuery('#rs_message_user_points_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_in_cart').parent().parent().hide();
        }
    });

    //Show or Hide Message in Cart Page that Display Redeeming Your Points
    if (jQuery('#rs_show_hide_message_for_redeem_points').val() == '1') {
        jQuery('#rs_message_user_points_redeemed_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_message_user_points_redeemed_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_redeem_points').change(function () {
        if (jQuery('#rs_show_hide_message_for_redeem_points').val() == '1') {
            jQuery('#rs_message_user_points_redeemed_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_redeemed_in_cart').parent().parent().hide();
        }
    });


    //Show or Hide Message for Guest in Checkout Page
    if (jQuery('#rs_enable_acc_creation_for_guest_checkout_page').is(':checked')) {
        jQuery('#rs_message_for_guest_in_checkout').parent().parent().hide();
        jQuery('#rs_show_hide_message_for_guest_checkout_page').parent().parent().hide();
        jQuery('#rs_show_hide_message_for_guest').parent().parent().hide();
        jQuery('#rs_message_for_guest_in_cart').parent().parent().hide();
    } else {
        jQuery('#rs_show_hide_message_for_guest_checkout_page').parent().parent().show();
        if (jQuery('#rs_show_hide_message_for_guest_checkout_page').val() == '1') {
            jQuery('#rs_message_for_guest_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_message_for_guest_in_checkout').parent().parent().hide();
        }

        jQuery('#rs_show_hide_message_for_guest_checkout_page').change(function () {
            if (jQuery('#rs_show_hide_message_for_guest_checkout_page').val() == '1') {
                jQuery('#rs_message_for_guest_in_checkout').parent().parent().show();
            } else {
                jQuery('#rs_message_for_guest_in_checkout').parent().parent().hide();
            }
        });


        //Show or Hide Message for Guest in Cart Page
        jQuery('#rs_show_hide_message_for_guest').parent().parent().show();
        if (jQuery('#rs_show_hide_message_for_guest').val() == '1') {
            jQuery('#rs_message_for_guest_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_message_for_guest_in_cart').parent().parent().hide();
        }

        jQuery('#rs_show_hide_message_for_guest').change(function () {
            if (jQuery('#rs_show_hide_message_for_guest').val() == '1') {
                jQuery('#rs_message_for_guest_in_cart').parent().parent().show();
            } else {
                jQuery('#rs_message_for_guest_in_cart').parent().parent().hide();
            }
        });
    }

    jQuery('#rs_enable_acc_creation_for_guest_checkout_page').change(function () {
        if (jQuery('#rs_enable_acc_creation_for_guest_checkout_page').is(':checked')) {
            jQuery('#rs_message_for_guest_in_checkout').parent().parent().hide();
            jQuery('#rs_show_hide_message_for_guest_checkout_page').parent().parent().hide();
            jQuery('#rs_show_hide_message_for_guest').parent().parent().hide();
            jQuery('#rs_message_for_guest_in_cart').parent().parent().hide();
        } else {
            jQuery('#rs_show_hide_message_for_guest_checkout_page').parent().parent().show();
            if (jQuery('#rs_show_hide_message_for_guest_checkout_page').val() == '1') {
                jQuery('#rs_message_for_guest_in_checkout').parent().parent().show();
            } else {
                jQuery('#rs_message_for_guest_in_checkout').parent().parent().hide();
            }

            jQuery('#rs_show_hide_message_for_guest_checkout_page').change(function () {
                if (jQuery('#rs_show_hide_message_for_guest_checkout_page').val() == '1') {
                    jQuery('#rs_message_for_guest_in_checkout').parent().parent().show();
                } else {
                    jQuery('#rs_message_for_guest_in_checkout').parent().parent().hide();
                }
            });

            //Show or Hide Message for Guest in Cart Page
            jQuery('#rs_show_hide_message_for_guest').parent().parent().show();
            if (jQuery('#rs_show_hide_message_for_guest').val() == '1') {
                jQuery('#rs_message_for_guest_in_cart').parent().parent().show();
            } else {
                jQuery('#rs_message_for_guest_in_cart').parent().parent().hide();
            }

            jQuery('#rs_show_hide_message_for_guest').change(function () {
                if (jQuery('#rs_show_hide_message_for_guest').val() == '1') {
                    jQuery('#rs_message_for_guest_in_cart').parent().parent().show();
                } else {
                    jQuery('#rs_message_for_guest_in_cart').parent().parent().hide();
                }
            });
        }

        // Account signup and login message

        jQuery('#rs_show_hide_message_for_sign_up').parent().parent().show();
        if (jQuery('#rs_show_hide_message_for_sign_up').val() == '1') {
            jQuery('#rs_message_user_points_for_sign_up').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_for_sign_up').parent().parent().hide();
        }

        jQuery('#rs_show_hide_message_for_sign_up').change(function () {
            if (jQuery('#rs_show_hide_message_for_sign_up').val() == '1') {
                jQuery('#rs_message_user_points_for_sign_up').parent().parent().show();
            } else {
                jQuery('#rs_message_user_points_for_sign_up').parent().parent().hide();
            }
        });

        jQuery('#rs_show_hide_message_for_daily_login').parent().parent().show();
        if (jQuery('#rs_show_hide_message_for_daily_login').val() == '1') {
            jQuery('#rs_message_user_points_for_daily_login').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_for_daily_login').parent().parent().hide();
        }

        jQuery('#rs_show_hide_message_for_daily_login').change(function () {
            if (jQuery('#rs_show_hide_message_for_daily_login').val() == '1') {
                jQuery('#rs_message_user_points_for_daily_login').parent().parent().show();
            } else {
                jQuery('#rs_message_user_points_for_daily_login').parent().parent().hide();
            }
        });

        // Blog Post Creation and Comment Messages

        jQuery('#rs_show_hide_message_for_blog_create').parent().parent().show();
        if (jQuery('#rs_show_hide_message_for_blog_create').val() == '1') {
            jQuery('#rs_message_user_points_for_blog_creation').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_for_blog_creation').parent().parent().hide();
        }

        jQuery('#rs_show_hide_message_for_blog_create').change(function () {
            if (jQuery('#rs_show_hide_message_for_blog_create').val() == '1') {
                jQuery('#rs_message_user_points_for_blog_creation').parent().parent().show();
            } else {
                jQuery('#rs_message_user_points_for_blog_creation').parent().parent().hide();
            }
        });

        jQuery('#rs_show_hide_message_for_post_comment').parent().parent().show();
        if (jQuery('#rs_show_hide_message_for_post_comment').val() == '1') {
            jQuery('#rs_message_user_points_for_blog_comment').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_for_blog_comment').parent().parent().hide();
        }

        jQuery('#rs_show_hide_message_for_post_comment').change(function () {
            if (jQuery('#rs_show_hide_message_for_post_comment').val() == '1') {
                jQuery('#rs_message_user_points_for_blog_comment').parent().parent().show();
            } else {
                jQuery('#rs_message_user_points_for_blog_comment').parent().parent().hide();
            }
        });

        //Page Comment Message

        jQuery('#rs_show_hide_message_for_page_comment').parent().parent().show();
        if (jQuery('#rs_show_hide_message_for_page_comment').val() == '1') {
            jQuery('#rs_message_user_points_for_page_comment').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_for_page_comment').parent().parent().hide();
        }

        jQuery('#rs_show_hide_message_for_page_comment').change(function () {
            if (jQuery('#rs_show_hide_message_for_page_comment').val() == '1') {
                jQuery('#rs_message_user_points_for_page_comment').parent().parent().show();
            } else {
                jQuery('#rs_message_user_points_for_page_comment').parent().parent().hide();
            }
        });

    });


    //Show or Hide Message in Checkout Page for each Products
    if (jQuery('#rs_show_hide_message_for_each_products_checkout_page').val() == '1') {
        jQuery('#rs_message_product_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_message_product_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_each_products_checkout_page').change(function () {
        if (jQuery('#rs_show_hide_message_for_each_products_checkout_page').val() == '1') {
            jQuery('#rs_message_product_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_message_product_in_checkout').parent().parent().hide();
        }
    });

    //Show or Hide Buying Message in Checkout Page for each Products
    if (jQuery('#rs_show_hide_buy_point_message_for_each_products_checkout_page').val() == '1') {
        jQuery('#rs_buy_point_message_product_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_product_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_point_message_for_each_products_checkout_page').change(function () {
        if (jQuery('#rs_show_hide_buy_point_message_for_each_products_checkout_page').val() == '1') {
            jQuery('#rs_buy_point_message_product_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_product_in_checkout').parent().parent().hide();
        }
    });

    //Show or Hide Message in Checkout Page for Completing the Total Purchase
    if (jQuery('#rs_show_hide_message_for_total_points_checkout_page').val() == '1') {
        jQuery('#rs_message_total_price_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_message_total_price_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_total_points_checkout_page').change(function () {
        if (jQuery('#rs_show_hide_message_for_total_points_checkout_page').val() == '1') {
            jQuery('#rs_message_total_price_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_message_total_price_in_checkout').parent().parent().hide();
        }
    });

    //Show or Hide Message in Checkout Page that display Your Reward Points
    if (jQuery('#rs_show_hide_message_for_my_rewards_checkout_page').val() == '1') {
        jQuery('#rs_message_user_points_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_message_user_points_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_my_rewards_checkout_page').change(function () {
        if (jQuery('#rs_show_hide_message_for_my_rewards_checkout_page').val() == '1') {
            jQuery('#rs_message_user_points_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_in_checkout').parent().parent().hide();
        }
    });

    //Show or Hide Message in Checkout Page that Display Redeeming Your Points
    if (jQuery('#rs_show_hide_message_for_redeem_points_checkout_page').val() == '1') {
        jQuery('#rs_message_user_points_redeemed_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_message_user_points_redeemed_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_redeem_points_checkout_page').change(function () {
        if (jQuery('#rs_show_hide_message_for_redeem_points_checkout_page').val() == '1') {
            jQuery('#rs_message_user_points_redeemed_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_message_user_points_redeemed_in_checkout').parent().parent().hide();
        }
    });

    //Show or Hide Message for Payment Gateway Reward Points
    if (jQuery('#rs_show_hide_message_payment_gateway_reward_points').val() == '1') {
        jQuery('#rs_message_payment_gateway_reward_points').parent().parent().show();
    } else {
        jQuery('#rs_message_payment_gateway_reward_points').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_payment_gateway_reward_points').change(function () {
        if (jQuery('#rs_show_hide_message_payment_gateway_reward_points').val() == '1') {
            jQuery('#rs_message_payment_gateway_reward_points').parent().parent().show();
        } else {
            jQuery('#rs_message_payment_gateway_reward_points').parent().parent().hide();
        }
    });

    if (jQuery('#rs_restrict_days_for_product_purchase').is(':checked')) {
        jQuery('#rs_restrict_product_purchase_cron_type').closest('tr').show();
        jQuery('#rs_restrict_product_purchase_time').closest('tr').show();
    } else {
        jQuery('#rs_restrict_product_purchase_cron_type').closest('tr').hide();
        jQuery('#rs_restrict_product_purchase_time').closest('tr').hide();
    }

    jQuery('#rs_restrict_days_for_product_purchase').change(function () {
        if (jQuery('#rs_restrict_days_for_product_purchase').is(':checked')) {
            jQuery('#rs_restrict_product_purchase_cron_type').closest('tr').show();
            jQuery('#rs_restrict_product_purchase_time').closest('tr').show();
        } else {
            jQuery('#rs_restrict_product_purchase_cron_type').closest('tr').hide();
            jQuery('#rs_restrict_product_purchase_time').closest('tr').hide();
        }
    });

    if (jQuery('#rs_disable_point_if_reward_points_gateway').is(':checked')) {
        jQuery('#rs_restriction_msg_for_reward_gatweway').closest('tr').show();
    } else {
        jQuery('#rs_restriction_msg_for_reward_gatweway').closest('tr').hide();
    }

    jQuery('#rs_disable_point_if_reward_points_gateway').change(function () {
        if (jQuery('#rs_disable_point_if_reward_points_gateway').is(':checked')) {
            jQuery('#rs_restriction_msg_for_reward_gatweway').closest('tr').show();
        } else {
            jQuery('#rs_restriction_msg_for_reward_gatweway').closest('tr').hide();
        }
    });

    if (jQuery('#rs_show_hide_message_errmsg_for_point_price_coupon').val() == '1') {
        jQuery('#rs_errmsg_for_redeem_in_point_price_prt').parent().parent().show();
    } else {
        jQuery('#rs_errmsg_for_redeem_in_point_price_prt').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_errmsg_for_point_price_coupon').change(function () {
        if (jQuery('#rs_show_hide_message_errmsg_for_point_price_coupon').val() == '1') {
            jQuery('#rs_errmsg_for_redeem_in_point_price_prt').parent().parent().show();
        } else {
            jQuery('#rs_errmsg_for_redeem_in_point_price_prt').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_message_notice_for_redeeming').val() == '1') {
        jQuery('#rs_msg_for_redeem_when_tax_enabled').parent().parent().show();
    } else {
        jQuery('#rs_msg_for_redeem_when_tax_enabled').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_notice_for_redeeming').change(function () {
        if (jQuery('#rs_show_hide_message_notice_for_redeeming').val() == '1') {
            jQuery('#rs_msg_for_redeem_when_tax_enabled').parent().parent().show();
        } else {
            jQuery('#rs_msg_for_redeem_when_tax_enabled').parent().parent().hide();
        }
    });

    /*Show or hide Settings for Sumo Payment Message Tab */

    if (jQuery('#rs_show_hide_message_for_each_payment_plan_products').val() == '1') {
        jQuery('#rs_message_payment_plan_product_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_message_payment_plan_product_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_each_payment_plan_products').change(function () {
        if (jQuery('#rs_show_hide_message_for_each_payment_plan_products').val() == '1') {
            jQuery('#rs_message_payment_plan_product_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_message_payment_plan_product_in_cart').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_buy_point_message_for_each_payment_plan_products').val() == '1') {
        jQuery('#rs_buy_point_message_payment_plan_product_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_payment_plan_product_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_point_message_for_each_payment_plan_products').change(function () {
        if (jQuery('#rs_show_hide_buy_point_message_for_each_payment_plan_products').val() == '1') {
            jQuery('#rs_buy_point_message_payment_plan_product_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_payment_plan_product_in_cart').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_message_for_total_payment_plan_points_referral').val() == '1') {
        jQuery('#rs_referral_point_message_payment_plan_product_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_referral_point_message_payment_plan_product_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_total_payment_plan_points_referral').change(function () {
        if (jQuery('#rs_show_hide_message_for_total_payment_plan_points_referral').val() == '1') {
            jQuery('#rs_referral_point_message_payment_plan_product_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_referral_point_message_payment_plan_product_in_cart').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_message_for_total_payment_plan_points').val() == '1') {
        jQuery('#rs_message_payment_plan_total_price_in_cart').parent().parent().show();
    } else {
        jQuery('#rs_message_payment_plan_total_price_in_cart').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_total_payment_plan_points').change(function () {
        if (jQuery('#rs_show_hide_message_for_total_payment_plan_points').val() == '1') {
            jQuery('#rs_message_payment_plan_total_price_in_cart').parent().parent().show();
        } else {
            jQuery('#rs_message_payment_plan_total_price_in_cart').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_message_for_each_payment_plan_products_checkout_page').val() == '1') {
        jQuery('#rs_message_payment_plan_product_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_message_payment_plan_product_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_each_payment_plan_products_checkout_page').change(function () {
        if (jQuery('#rs_show_hide_message_for_each_payment_plan_products_checkout_page').val() == '1') {
            jQuery('#rs_message_payment_plan_product_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_message_payment_plan_product_in_checkout').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_buy_point_message_for_each_payment_plan_products_checkout_page').val() == '1') {
        jQuery('#rs_buy_point_message_payment_plan_product_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_buy_point_message_payment_plan_product_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_buy_point_message_for_each_payment_plan_products_checkout_page').change(function () {
        if (jQuery('#rs_show_hide_buy_point_message_for_each_payment_plan_products_checkout_page').val() == '1') {
            jQuery('#rs_buy_point_message_payment_plan_product_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_buy_point_message_payment_plan_product_in_checkout').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_message_for_total_payment_plan_points_referrel_checkout').val() == '1') {
        jQuery('#rs_referral_point_message_payment_plan_product_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_referral_point_message_payment_plan_product_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_total_payment_plan_points_referrel_checkout').change(function () {
        if (jQuery('#rs_show_hide_message_for_total_payment_plan_points_referrel_checkout').val() == '1') {
            jQuery('#rs_referral_point_message_payment_plan_product_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_referral_point_message_payment_plan_product_in_checkout').parent().parent().hide();
        }
    });

    if (jQuery('#rs_show_hide_message_for_total_payment_plan_points_checkout_page').val() == '1') {
        jQuery('#rs_message_payment_plan_total_price_in_checkout').parent().parent().show();
    } else {
        jQuery('#rs_message_payment_plan_total_price_in_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_message_for_total_payment_plan_points_checkout_page').change(function () {
        if (jQuery('#rs_show_hide_message_for_total_payment_plan_points_checkout_page').val() == '1') {
            jQuery('#rs_message_payment_plan_total_price_in_checkout').parent().parent().show();
        } else {
            jQuery('#rs_message_payment_plan_total_price_in_checkout').parent().parent().hide();
        }
    });



    /*Show or hide Settings for Message Tab - End*/

    /*Show or hide Settings for Cart Tab - Start*/

    var enable_auto_redeem_checkbox = jQuery('#rs_enable_disable_auto_redeem_points').is(':checked') ? 'yes' : 'no';
    if (enable_auto_redeem_checkbox === 'yes') {
        jQuery('#rs_percentage_cart_total_auto_redeem').parent().parent().show();
    } else {
        jQuery('#rs_percentage_cart_total_auto_redeem').parent().parent().hide();
    }

    jQuery('#rs_enable_disable_auto_redeem_points').click(function () {
        var enable_auto_redeem_checkbox = jQuery('#rs_enable_disable_auto_redeem_points').is(':checked') ? 'yes' : 'no';
        if (enable_auto_redeem_checkbox == 'yes') {
            jQuery('#rs_percentage_cart_total_auto_redeem').parent().parent().show();
        } else {
            jQuery('#rs_percentage_cart_total_auto_redeem').parent().parent().hide();
        }
    });
    var currentvalue = jQuery('#rs_show_hide_redeem_field').val();
    if (currentvalue === '1' || currentvalue == '2') {
        jQuery('#rs_enable_redeem_for_selected_products').parent().parent().parent().parent().show();
        jQuery('#rs_exclude_products_for_redeeming').parent().parent().parent().parent().show();
        jQuery('#rs_enable_redeem_for_selected_category').parent().parent().parent().parent().show();
        jQuery('#rs_exclude_category_for_redeeming').parent().parent().parent().parent().show();
        jQuery('#rs_show_redeeming_field').parent().parent().show();
        var enable_selected_product_checkbox = jQuery('#rs_enable_redeem_for_selected_products').is(':checked') ? 'yes' : 'no';
        var enable_exclude_product_checkbox = jQuery('#rs_exclude_products_for_redeeming').is(':checked') ? 'yes' : 'no';
        var enable_selected_category_checkbox = jQuery('#rs_enable_redeem_for_selected_category').is(':checked') ? 'yes' : 'no';
        var enable_exclude_category_checkbox = jQuery('#rs_exclude_category_for_redeeming').is(':checked') ? 'yes' : 'no';
        if (enable_selected_product_checkbox === 'yes') {
            jQuery('#rs_select_products_to_enable_redeeming').parent().parent().show();
        } else {
            jQuery('#rs_select_products_to_enable_redeeming').parent().parent().hide();
        }
        if (enable_exclude_product_checkbox === 'yes') {
            jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().show();
        } else {
            jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().hide();
        }
        if (enable_selected_category_checkbox === 'yes') {
            jQuery('#rs_select_category_to_enable_redeeming').parent().parent().show();
        } else {
            jQuery('#rs_select_category_to_enable_redeeming').parent().parent().hide();
        }
        if (enable_exclude_category_checkbox === 'yes') {
            jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().show();
        } else {
            jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().hide();
        }


        //When enabling the product and category
        jQuery('#rs_enable_redeem_for_selected_products').click(function () {
            var enable_redeem_for_selected_product = jQuery('#rs_enable_redeem_for_selected_products').is(':checked') ? 'yes' : 'no';
            if (enable_redeem_for_selected_product == 'yes') {
                jQuery('#rs_select_products_to_enable_redeeming').parent().parent().show();
            } else {
                jQuery('#rs_select_products_to_enable_redeeming').parent().parent().hide();
            }
        });
        jQuery('#rs_exclude_products_for_redeeming').click(function () {
            var enable_exclude_product_checkbox = jQuery('#rs_exclude_products_for_redeeming').is(':checked') ? 'yes' : 'no';
            if (enable_exclude_product_checkbox == 'yes') {
                jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().show();
            } else {
                jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().hide();
            }
        });
        jQuery('#rs_enable_redeem_for_selected_category').click(function () {
            var enable_selected_category_checkbox = jQuery('#rs_enable_redeem_for_selected_category').is(':checked') ? 'yes' : 'no';
            if (enable_selected_category_checkbox == 'yes') {
                jQuery('#rs_select_category_to_enable_redeeming').parent().parent().show();
            } else {
                jQuery('#rs_select_category_to_enable_redeeming').parent().parent().hide();
            }
        });
        jQuery('#rs_exclude_category_for_redeeming').click(function () {
            var enable_exclude_category_checkbox = jQuery('#rs_exclude_category_for_redeeming').is(':checked') ? 'yes' : 'no';
            if (enable_exclude_category_checkbox == 'yes') {
                jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().show();
            } else {
                jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().hide();
            }
        });
        if (currentvalue === '2') {
            jQuery('#rs_show_redeeming_field').parent().parent().show();
        }
    } else {
        jQuery('#rs_enable_redeem_for_selected_products').parent().parent().parent().parent().hide();
        jQuery('#rs_exclude_products_for_redeeming').parent().parent().parent().parent().hide();
        jQuery('#rs_enable_redeem_for_selected_category').parent().parent().parent().parent().hide();
        jQuery('#rs_exclude_category_for_redeeming').parent().parent().parent().parent().hide();
        jQuery('#rs_select_products_to_enable_redeeming').parent().parent().hide();
        jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().hide();
        jQuery('#rs_select_category_to_enable_redeeming').parent().parent().hide();
        jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().hide();
        jQuery('#rs_show_redeeming_field').parent().parent().hide();
        if (currentvalue === '5') {
            jQuery('#rs_show_redeeming_field').parent().parent().show();
        }
    }

    jQuery('#rs_show_hide_redeem_field').change(function () {
        var currentvalue = jQuery(this).val();
        if (currentvalue === '1' || currentvalue == '2') {
            jQuery('#rs_enable_redeem_for_selected_products').parent().parent().parent().parent().show();
            jQuery('#rs_exclude_products_for_redeeming').parent().parent().parent().parent().show();
            jQuery('#rs_enable_redeem_for_selected_category').parent().parent().parent().parent().show();
            jQuery('#rs_exclude_category_for_redeeming').parent().parent().parent().parent().show();
            jQuery('#rs_show_redeeming_field').parent().parent().show();
            var enable_selected_product_checkbox = jQuery('#rs_enable_redeem_for_selected_products').is(':checked') ? 'yes' : 'no';
            var enable_exclude_product_checkbox = jQuery('#rs_exclude_products_for_redeeming').is(':checked') ? 'yes' : 'no';
            var enable_selected_category_checkbox = jQuery('#rs_enable_redeem_for_selected_category').is(':checked') ? 'yes' : 'no';
            var enable_exclude_category_checkbox = jQuery('#rs_exclude_category_for_redeeming').is(':checked') ? 'yes' : 'no';
            if (enable_selected_product_checkbox === 'yes') {
                jQuery('#rs_select_products_to_enable_redeeming').parent().parent().show();
            } else {
                jQuery('#rs_select_products_to_enable_redeeming').parent().parent().hide();
            }
            if (enable_exclude_product_checkbox === 'yes') {
                jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().show();
            } else {
                jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().hide();
            }
            if (enable_selected_category_checkbox === 'yes') {
                jQuery('#rs_select_category_to_enable_redeeming').parent().parent().show();
            } else {
                jQuery('#rs_select_category_to_enable_redeeming').parent().parent().hide();
            }
            if (enable_exclude_category_checkbox === 'yes') {
                jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().show();
            } else {
                jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().hide();
            }


            //When enabling the product and category
            jQuery('#rs_enable_redeem_for_selected_products').click(function () {
                var enable_redeem_for_selected_product = jQuery('#rs_enable_redeem_for_selected_products').is(':checked') ? 'yes' : 'no';
                if (enable_redeem_for_selected_product == 'yes') {
                    jQuery('#rs_select_products_to_enable_redeeming').parent().parent().show();
                } else {
                    jQuery('#rs_select_products_to_enable_redeeming').parent().parent().hide();
                }
            });
            jQuery('#rs_exclude_products_for_redeeming').click(function () {
                var enable_exclude_product_checkbox = jQuery('#rs_exclude_products_for_redeeming').is(':checked') ? 'yes' : 'no';
                if (enable_exclude_product_checkbox == 'yes') {
                    jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().show();
                } else {
                    jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().hide();
                }
            });
            jQuery('#rs_enable_redeem_for_selected_category').click(function () {
                var enable_selected_category_checkbox = jQuery('#rs_enable_redeem_for_selected_category').is(':checked') ? 'yes' : 'no';
                if (enable_selected_category_checkbox == 'yes') {
                    jQuery('#rs_select_category_to_enable_redeeming').parent().parent().show();
                } else {
                    jQuery('#rs_select_category_to_enable_redeeming').parent().parent().hide();
                }
            });
            jQuery('#rs_exclude_category_for_redeeming').click(function () {
                var enable_exclude_category_checkbox = jQuery('#rs_exclude_category_for_redeeming').is(':checked') ? 'yes' : 'no';
                if (enable_exclude_category_checkbox == 'yes') {
                    jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().show();
                } else {
                    jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().hide();
                }
            });
            if (currentvalue === '2') {
                jQuery('#rs_show_redeeming_field').parent().parent().show();
            }
        } else {
            jQuery('#rs_enable_redeem_for_selected_products').parent().parent().parent().parent().hide();
            jQuery('#rs_exclude_products_for_redeeming').parent().parent().parent().parent().hide();
            jQuery('#rs_enable_redeem_for_selected_category').parent().parent().parent().parent().hide();
            jQuery('#rs_exclude_category_for_redeeming').parent().parent().parent().parent().hide();
            jQuery('#rs_select_products_to_enable_redeeming').parent().parent().hide();
            jQuery('#rs_exclude_products_to_enable_redeeming').parent().parent().hide();
            jQuery('#rs_select_category_to_enable_redeeming').parent().parent().hide();
            jQuery('#rs_exclude_category_to_enable_redeeming').parent().parent().hide();
            jQuery('#rs_show_redeeming_field').parent().parent().hide();
            if (currentvalue === '5') {
                jQuery('#rs_show_redeeming_field').parent().parent().show();
            }
        }
    });
    //Show or Hide Redeeming Field Caption
    if (jQuery('#rs_show_hide_redeem_caption').val() == '1') {
        jQuery('#rs_redeem_field_caption').parent().parent().show();
    } else {
        jQuery('#rs_redeem_field_caption').parent().parent().hide();
    }

    jQuery('#rs_show_hide_redeem_caption').change(function () {
        if (jQuery('#rs_show_hide_redeem_caption').val() == '1') {
            jQuery('#rs_redeem_field_caption').parent().parent().show();
        } else {
            jQuery('#rs_redeem_field_caption').parent().parent().hide();
        }
    });
    //Show or Hide Redeeming Field Placeholder
    if (jQuery('#rs_show_hide_redeem_placeholder').val() == '1') {
        jQuery('#rs_redeem_field_placeholder').parent().parent().show();
    } else {
        jQuery('#rs_redeem_field_placeholder').parent().parent().hide();
    }

    jQuery('#rs_show_hide_redeem_placeholder').change(function () {
        if (jQuery('#rs_show_hide_redeem_placeholder').val() == '1') {
            jQuery('#rs_redeem_field_placeholder').parent().parent().show();
        } else {
            jQuery('#rs_redeem_field_placeholder').parent().parent().hide();
        }
    });
    //Show or Hide Current User Points is Empty Error Message
    if (jQuery('#rs_show_hide_points_empty_error_message').val() == '1') {
        jQuery('#rs_current_points_empty_error_message').parent().parent().show();
    } else {
        jQuery('#rs_current_points_empty_error_message').parent().parent().hide();
    }

    jQuery('#rs_show_hide_points_empty_error_message').change(function () {
        if (jQuery('#rs_show_hide_points_empty_error_message').val() == '1') {
            jQuery('#rs_current_points_empty_error_message').parent().parent().show();
        } else {
            jQuery('#rs_current_points_empty_error_message').parent().parent().hide();
        }
    });

    //Show or Hide auto redeem not applicable Error Message
    if (jQuery('#rs_show_hide_auto_redeem_not_applicable').val() == '1') {
        jQuery('#rs_auto_redeem_not_applicable_error_message').parent().parent().show();
    } else {
        jQuery('#rs_auto_redeem_not_applicable_error_message').parent().parent().hide();
    }

    jQuery('#rs_show_hide_auto_redeem_not_applicable').change(function () {
        if (jQuery('#rs_show_hide_auto_redeem_not_applicable').val() == '1') {
            jQuery('#rs_auto_redeem_not_applicable_error_message').parent().parent().show();
        } else {
            jQuery('#rs_auto_redeem_not_applicable_error_message').parent().parent().hide();
        }
    });
    //Show or Hide Minimum Points for first time Redeeming Error Message
    if (jQuery('#rs_show_hide_first_redeem_error_message').val() == '1') {
        jQuery('#rs_min_points_first_redeem_error_message').parent().parent().show();
    } else {
        jQuery('#rs_min_points_first_redeem_error_message').parent().parent().hide();
    }

    jQuery('#rs_show_hide_first_redeem_error_message').change(function () {
        if (jQuery('#rs_show_hide_first_redeem_error_message').val() == '1') {
            jQuery('#rs_min_points_first_redeem_error_message').parent().parent().show();
        } else {
            jQuery('#rs_min_points_first_redeem_error_message').parent().parent().hide();
        }
    });
    //Show or Hide Minimum Points After first time Redeeming Error Message
    if (jQuery('#rs_show_hide_after_first_redeem_error_message').val() == '1') {
        jQuery('#rs_min_points_after_first_error').parent().parent().show();
    } else {
        jQuery('#rs_min_points_after_first_error').parent().parent().hide();
    }

    jQuery('#rs_show_hide_after_first_redeem_error_message').change(function () {
        if (jQuery('#rs_show_hide_after_first_redeem_error_message').val() == '1') {
            jQuery('#rs_min_points_after_first_error').parent().parent().show();
        } else {
            jQuery('#rs_min_points_after_first_error').parent().parent().hide();
        }
    });
    //Show or Hide Minimum Cart Total for Redeeming Error Message
    if (jQuery('#rs_show_hide_minimum_cart_total_error_message').val() == '1') {
        jQuery('#rs_min_cart_total_redeem_error').parent().parent().show();
    } else {
        jQuery('#rs_min_cart_total_redeem_error').parent().parent().hide();
    }

    jQuery('#rs_show_hide_minimum_cart_total_error_message').change(function () {
        if (jQuery('#rs_show_hide_minimum_cart_total_error_message').val() == '1') {
            jQuery('#rs_min_cart_total_redeem_error').parent().parent().show();
        } else {
            jQuery('#rs_min_cart_total_redeem_error').parent().parent().hide();
        }
    });

    /*Show or hide Settings for Cart Tab - End*/

    /*Show or hide Settings for Checkout Tab - Start*/

    var enable_selected_product_for_purchase = jQuery('#rs_enable_selected_product_for_purchase_using_points').is(':checked') ? 'yes' : 'no';
    if (enable_selected_product_for_purchase == 'yes') {
        jQuery('#rs_select_product_for_purchase_using_points').parent().parent().show();
    } else {
        jQuery('#rs_select_product_for_purchase_using_points').parent().parent().hide();
    }

    jQuery('#rs_enable_selected_product_for_purchase_using_points').change(function () {
        jQuery('#rs_select_product_for_purchase_using_points').parent().parent().toggle();
    });

    var enable_selected_product_for_purchase1 = jQuery('#rs_enable_selected_product_for_hide_gateway').is(':checked') ? 'yes' : 'no';
    if (enable_selected_product_for_purchase1 == 'yes') {
        jQuery('#rs_select_product_for_hide_gateway').parent().parent().show();
    } else {
        jQuery('#rs_select_product_for_hide_gateway').parent().parent().hide();
    }

    jQuery('#rs_enable_selected_product_for_hide_gateway').change(function () {
        jQuery('#rs_select_product_for_hide_gateway').parent().parent().toggle();
    });

    /*SUMO Reward Points Payment Gateway Visibility Settings - Start */

    if (jQuery('#rs_show_hide_reward_points_gatewy').val() == '1') {
        jQuery('#rs_enable_selected_product_for_purchase_using_points').closest('tr').show();
        jQuery('#rs_enable_selected_category_for_purchase_using_points').closest('tr').show();
        jQuery('#rs_enable_selected_product_for_hide_gateway').closest('tr').hide();
        jQuery('#rs_enable_selected_category_to_hide_gateway').closest('tr').hide();
        jQuery('#rs_select_product_for_hide_gateway').closest('tr').hide();
        jQuery('#rs_select_category_to_hide_gateway').closest('tr').hide();
        jQuery('#rs_enable_gateway_visible_to_all_product').closest('tr').show();
        jQuery('#rs_errmsg_when_other_products_added_to_cart_page').closest('tr').show();

        /*Show or Hide for Selected Product in Visible Option - Start*/
        if (jQuery('#rs_enable_selected_product_for_purchase_using_points').is(':checked')) {
            jQuery('#rs_select_product_for_purchase_using_points').closest('tr').show();
        } else {
            jQuery('#rs_select_product_for_purchase_using_points').closest('tr').hide();
        }

        jQuery('#rs_enable_selected_product_for_purchase_using_points').change(function () {
            if (jQuery('#rs_enable_selected_product_for_purchase_using_points').is(':checked')) {
                jQuery('#rs_select_product_for_purchase_using_points').closest('tr').show();
            } else {
                jQuery('#rs_select_product_for_purchase_using_points').closest('tr').hide();
            }
        });
        /*Show or Hide for Selected Product in Visible Option - End*/

        /*Show or Hide for Selected Category in Visible Option - Start*/
        if (jQuery('#rs_enable_selected_category_for_purchase_using_points').is(':checked')) {
            jQuery('#rs_select_category_for_purchase_using_points').closest('tr').show();
        } else {
            jQuery('#rs_select_category_for_purchase_using_points').closest('tr').hide();
        }

        jQuery('#rs_enable_selected_category_for_purchase_using_points').change(function () {
            if (jQuery('#rs_enable_selected_category_for_purchase_using_points').is(':checked')) {
                jQuery('#rs_select_category_for_purchase_using_points').closest('tr').show();
            } else {
                jQuery('#rs_select_category_for_purchase_using_points').closest('tr').hide();
            }
        });
        /*Show or Hide for Selected Category in Visible Option - End*/
    } else {
        jQuery('#rs_enable_selected_product_for_purchase_using_points').closest('tr').hide();
        jQuery('#rs_enable_selected_category_for_purchase_using_points').closest('tr').hide();
        jQuery('#rs_select_product_for_purchase_using_points').closest('tr').hide();
        jQuery('#rs_select_category_for_purchase_using_points').closest('tr').hide();
        jQuery('#rs_enable_selected_product_for_hide_gateway').closest('tr').show();
        jQuery('#rs_enable_selected_category_to_hide_gateway').closest('tr').show();
        jQuery('#rs_enable_gateway_visible_to_all_product').closest('tr').hide();
        jQuery('#rs_errmsg_when_other_products_added_to_cart_page').closest('tr').show();

        /*Show or Hide for Selected Product in Hide Option - Start*/
        if (jQuery('#rs_enable_selected_product_for_hide_gateway').is(':checked')) {
            jQuery('#rs_select_product_for_hide_gateway').closest('tr').show();
        } else {
            jQuery('#rs_select_product_for_hide_gateway').closest('tr').hide();
        }

        jQuery('#rs_enable_selected_product_for_hide_gateway').change(function () {
            if (jQuery('#rs_enable_selected_product_for_hide_gateway').is(':checked')) {
                jQuery('#rs_select_product_for_hide_gateway').closest('tr').show();
            } else {
                jQuery('#rs_select_product_for_hide_gateway').closest('tr').hide();
            }
        });
        /*Show or Hide for Selected Product in Hide Option - End*/

        /*Show or Hide for Selected Category in Hide Option - Start*/
        if (jQuery('#rs_enable_selected_category_to_hide_gateway').is(':checked')) {
            jQuery('#rs_select_category_to_hide_gateway').closest('tr').show();
        } else {
            jQuery('#rs_select_category_to_hide_gateway').closest('tr').hide();
        }

        jQuery('#rs_enable_selected_category_to_hide_gateway').change(function () {
            if (jQuery('#rs_enable_selected_category_to_hide_gateway').is(':checked')) {
                jQuery('#rs_select_category_to_hide_gateway').closest('tr').show();
            } else {
                jQuery('#rs_select_category_to_hide_gateway').closest('tr').hide();
            }
        });
        /*Show or Hide for Selected Category in Hide Option - End*/
    }

    jQuery('#rs_show_hide_reward_points_gatewy').change(function () {
        if (jQuery('#rs_show_hide_reward_points_gatewy').val() == '1') {
            jQuery('#rs_enable_selected_product_for_purchase_using_points').closest('tr').show();
            jQuery('#rs_enable_selected_category_for_purchase_using_points').closest('tr').show();
            jQuery('#rs_enable_selected_product_for_hide_gateway').closest('tr').hide();
            jQuery('#rs_enable_selected_category_to_hide_gateway').closest('tr').hide();
            jQuery('#rs_select_product_for_hide_gateway').closest('tr').hide();
            jQuery('#rs_select_category_to_hide_gateway').closest('tr').hide();
            jQuery('#rs_enable_gateway_visible_to_all_product').closest('tr').show();
            jQuery('#rs_errmsg_when_other_products_added_to_cart_page').closest('tr').show();

            /*Show or Hide for Selected Product in Visible Option - Start*/
            if (jQuery('#rs_enable_selected_product_for_purchase_using_points').is(':checked')) {
                jQuery('#rs_select_product_for_purchase_using_points').closest('tr').show();
            } else {
                jQuery('#rs_select_product_for_purchase_using_points').closest('tr').hide();
            }

            jQuery('#rs_enable_selected_product_for_purchase_using_points').change(function () {
                if (jQuery('#rs_enable_selected_product_for_purchase_using_points').is(':checked')) {
                    jQuery('#rs_select_product_for_purchase_using_points').closest('tr').show();
                } else {
                    jQuery('#rs_select_product_for_purchase_using_points').closest('tr').hide();
                }
            });
            /*Show or Hide for Selected Product in Visible Option - End*/

            /*Show or Hide for Selected Category in Visible Option - Start*/
            if (jQuery('#rs_enable_selected_category_for_purchase_using_points').is(':checked')) {
                jQuery('#rs_select_category_for_purchase_using_points').closest('tr').show();
            } else {
                jQuery('#rs_select_category_for_purchase_using_points').closest('tr').hide();
            }

            jQuery('#rs_enable_selected_category_for_purchase_using_points').change(function () {
                if (jQuery('#rs_enable_selected_category_for_purchase_using_points').is(':checked')) {
                    jQuery('#rs_select_category_for_purchase_using_points').closest('tr').show();
                } else {
                    jQuery('#rs_select_category_for_purchase_using_points').closest('tr').hide();
                }
            });
            /*Show or Hide for Selected Category in Visible Option - End*/
        } else {
            jQuery('#rs_enable_selected_product_for_purchase_using_points').closest('tr').hide();
            jQuery('#rs_enable_selected_category_for_purchase_using_points').closest('tr').hide();
            jQuery('#rs_select_product_for_purchase_using_points').closest('tr').hide();
            jQuery('#rs_select_category_for_purchase_using_points').closest('tr').hide();
            jQuery('#rs_enable_selected_product_for_hide_gateway').closest('tr').show();
            jQuery('#rs_enable_selected_category_to_hide_gateway').closest('tr').show();
            jQuery('#rs_enable_gateway_visible_to_all_product').closest('tr').hide();
            jQuery('#rs_errmsg_when_other_products_added_to_cart_page').closest('tr').show();

            /*Show or Hide for Selected Product in Hide Option - Start*/
            if (jQuery('#rs_enable_selected_product_for_hide_gateway').is(':checked')) {
                jQuery('#rs_select_product_for_hide_gateway').closest('tr').show();
            } else {
                jQuery('#rs_select_product_for_hide_gateway').closest('tr').hide();
            }

            jQuery('#rs_enable_selected_product_for_hide_gateway').change(function () {
                if (jQuery('#rs_enable_selected_product_for_hide_gateway').is(':checked')) {
                    jQuery('#rs_select_product_for_hide_gateway').closest('tr').show();
                } else {
                    jQuery('#rs_select_product_for_hide_gateway').closest('tr').hide();
                }
            });
            /*Show or Hide for Selected Product in Hide Option - End*/

            /*Show or Hide for Selected Category in Hide Option - Start*/
            if (jQuery('#rs_enable_selected_category_to_hide_gateway').is(':checked')) {
                jQuery('#rs_select_category_to_hide_gateway').closest('tr').show();
            } else {
                jQuery('#rs_select_category_to_hide_gateway').closest('tr').hide();
            }

            jQuery('#rs_enable_selected_category_to_hide_gateway').change(function () {
                if (jQuery('#rs_enable_selected_category_to_hide_gateway').is(':checked')) {
                    jQuery('#rs_select_category_to_hide_gateway').closest('tr').show();
                } else {
                    jQuery('#rs_select_category_to_hide_gateway').closest('tr').hide();
                }
            });
            /*Show or Hide for Selected Category in Hide Option - End*/
        }
    });

    /*SUMO Reward Points Payment Gateway Visibility Settings - End */


    //Show or Hide For Redeem Button Type
    if (jQuery('#rs_redeem_field_type_option_checkout').val() == '1') {
        jQuery('#rs_percentage_cart_total_redeem_checkout').parent().parent().hide();
    } else {
        jQuery('#rs_percentage_cart_total_redeem_checkout').parent().parent().show();
    }

    jQuery('#rs_redeem_field_type_option_checkout').change(function () {
        if (jQuery('#rs_redeem_field_type_option_checkout').val() == '1') {
            jQuery('#rs_percentage_cart_total_redeem_checkout').parent().parent().hide();
        } else {
            jQuery('#rs_percentage_cart_total_redeem_checkout').parent().parent().show();
        }
    });

    /*Show or hide Settings for Checkout Tab - End*/

    /*Show or hide Settings for My Account Tab - Start*/

    if (jQuery('#rs_show_hide_generate_referral').val() == '1') {
        jQuery('#rs_show_hide_generate_referral_link_type').parent().parent().show();
        jQuery('#rs_generate_referral_link_based_on_user').parent().parent().show();
        jQuery('#rs_enable_copy_to_clipboard').closest('tr').show();
        jQuery('#rs_generate_link_label').closest('tr').show();
        jQuery('#rs_generate_link_sno_label').closest('tr').show();
        jQuery('#rs_generate_link_date_label').closest('tr').show();
        jQuery('#rs_generate_link_referrallink_label').closest('tr').show();
        jQuery('#rs_generate_link_social_label').closest('tr').show();
        jQuery('#rs_generate_link_action_label').closest('tr').show();
        jQuery('#rs_generate_link_button_label').closest('tr').show();
        jQuery('#rs_display_generate_referral').closest('tr').show();
        jQuery('#rs_extra_class_name_generate_referral_link').closest('tr').show();

        if (jQuery('#rs_show_hide_generate_referral_link_type').val() == '1') {
            jQuery('#rs_prefill_generate_link').parent().parent().show();
            jQuery('#rs_static_generate_link').parent().parent().hide();
            jQuery('#rs_my_referral_link_button_label').parent().parent().hide();
        } else {
            jQuery('#rs_prefill_generate_link').parent().parent().hide();
            jQuery('#rs_static_generate_link').parent().parent().show();
            jQuery('#rs_my_referral_link_button_label').parent().parent().show();
        }

        jQuery('#rs_show_hide_generate_referral_link_type').change(function () {
            if (jQuery('#rs_show_hide_generate_referral_link_type').val() == '1') {
                jQuery('#rs_prefill_generate_link').parent().parent().show();
                jQuery('#rs_static_generate_link').parent().parent().hide();
                jQuery('#rs_my_referral_link_button_label').parent().parent().hide();
            } else {
                jQuery('#rs_prefill_generate_link').parent().parent().hide();
                jQuery('#rs_static_generate_link').parent().parent().show();
                jQuery('#rs_my_referral_link_button_label').parent().parent().show();
            }
        });

        jQuery('#rs_select_type_of_user_for_referral').closest('tr').show();
        if (jQuery('#rs_select_type_of_user_for_referral').val() === '1') {
            jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
        } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '2') {
            jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().show();
        } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '3') {
            jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().show();
            jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
        } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '4') {
            jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().show();
            jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
        } else {
            jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
            jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().show();
            jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();

        }

        jQuery('#rs_select_type_of_user_for_referral').change(function () {
            if (jQuery('#rs_select_type_of_user_for_referral').val() === '1') {
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
            } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '2') {
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().show();
            } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '3') {
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().show();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
            } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '4') {
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().show();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
            } else {
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().show();
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();

            }
        });

        jQuery('#rs_display_msg_when_access_is_prevented').closest('tr').show();
        if (jQuery('#rs_display_msg_when_access_is_prevented').val() == '1') {
            jQuery('#rs_msg_for_restricted_user').closest('tr').show();
        } else {
            jQuery('#rs_msg_for_restricted_user').closest('tr').hide();
        }

        jQuery('#rs_display_msg_when_access_is_prevented').change(function () {
            if (jQuery('#rs_display_msg_when_access_is_prevented').val() == '1') {
                jQuery('#rs_msg_for_restricted_user').closest('tr').show();
            } else {
                jQuery('#rs_msg_for_restricted_user').closest('tr').hide();
            }
        });
    } else {
        jQuery('#rs_show_hide_generate_referral_link_type').parent().parent().hide();
        jQuery('#rs_prefill_generate_link').parent().parent().hide();
        jQuery('#rs_static_generate_link').parent().parent().hide();
        jQuery('#rs_my_referral_link_button_label').parent().parent().hide();
        jQuery('#rs_generate_referral_link_based_on_user').parent().parent().hide();
        jQuery('#rs_enable_copy_to_clipboard').closest('tr').hide();
        jQuery('#rs_generate_link_label').closest('tr').hide();
        jQuery('#rs_generate_link_sno_label').closest('tr').hide();
        jQuery('#rs_generate_link_date_label').closest('tr').hide();
        jQuery('#rs_generate_link_referrallink_label').closest('tr').hide();
        jQuery('#rs_generate_link_social_label').closest('tr').hide();
        jQuery('#rs_generate_link_action_label').closest('tr').hide();
        jQuery('#rs_generate_link_button_label').closest('tr').hide();
        jQuery('#rs_select_type_of_user_for_referral').closest('tr').hide();
        jQuery('#rs_select_exclude_users_list_for_show_referral_link').closest('tr').hide();
        jQuery('#rs_select_include_users_for_show_referral_link').closest('tr').hide();
        jQuery('#rs_select_users_role_for_show_referral_link').closest('tr').hide();
        jQuery('#rs_select_exclude_users_role_for_show_referral_link').closest('tr').hide();
        jQuery('#rs_display_msg_when_access_is_prevented').closest('tr').hide();
        jQuery('#rs_msg_for_restricted_user').closest('tr').hide();
        jQuery('#rs_display_generate_referral').closest('tr').hide();
        jQuery('#rs_extra_class_name_generate_referral_link').closest('tr').hide();
    }

    jQuery('#rs_show_hide_generate_referral').change(function () {
        if (jQuery('#rs_show_hide_generate_referral').val() == '1') {
            jQuery('#rs_show_hide_generate_referral_link_type').parent().parent().show();
            jQuery('#rs_generate_referral_link_based_on_user').parent().parent().show();
            jQuery('#rs_enable_copy_to_clipboard').closest('tr').show();
            jQuery('#rs_generate_link_label').closest('tr').show();
            jQuery('#rs_generate_link_sno_label').closest('tr').show();
            jQuery('#rs_generate_link_date_label').closest('tr').show();
            jQuery('#rs_generate_link_referrallink_label').closest('tr').show();
            jQuery('#rs_generate_link_social_label').closest('tr').show();
            jQuery('#rs_generate_link_action_label').closest('tr').show();
            jQuery('#rs_generate_link_button_label').closest('tr').show();
            jQuery('#rs_display_generate_referral').closest('tr').show();
            jQuery('#rs_extra_class_name_generate_referral_link').closest('tr').show();
            if (jQuery('#rs_show_hide_generate_referral_link_type').val() == '1') {
                jQuery('#rs_prefill_generate_link').parent().parent().show();
                jQuery('#rs_static_generate_link').parent().parent().hide();
                jQuery('#rs_my_referral_link_button_label').parent().parent().hide();
            } else {
                jQuery('#rs_prefill_generate_link').parent().parent().hide();
                jQuery('#rs_static_generate_link').parent().parent().show();
                jQuery('#rs_my_referral_link_button_label').parent().parent().show();
            }

            jQuery('#rs_show_hide_generate_referral_link_type').change(function () {
                if (jQuery('#rs_show_hide_generate_referral_link_type').val() == '1') {
                    jQuery('#rs_prefill_generate_link').parent().parent().show();
                    jQuery('#rs_static_generate_link').parent().parent().hide();
                    jQuery('#rs_my_referral_link_button_label').parent().parent().hide();
                } else {
                    jQuery('#rs_prefill_generate_link').parent().parent().hide();
                    jQuery('#rs_static_generate_link').parent().parent().show();
                    jQuery('#rs_my_referral_link_button_label').parent().parent().show();
                }
            });

            jQuery('#rs_select_type_of_user_for_referral').closest('tr').show();

            if (jQuery('#rs_select_type_of_user_for_referral').val() === '1') {
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
            } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '2') {
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().show();
            } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '3') {
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().show();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
            } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '4') {
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().show();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
            } else {
                jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().show();
                jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();

            }

            jQuery('#rs_select_type_of_user_for_referral').change(function () {
                if (jQuery('#rs_select_type_of_user_for_referral').val() === '1') {
                    jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
                } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '2') {
                    jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().show();
                } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '3') {
                    jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().show();
                    jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                } else if (jQuery('#rs_select_type_of_user_for_referral').val() === '4') {
                    jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().show();
                    jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();
                } else {
                    jQuery('#rs_select_exclude_users_list_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_users_role_for_show_referral_link').parent().parent().hide();
                    jQuery('#rs_select_exclude_users_role_for_show_referral_link').parent().parent().show();
                    jQuery('#rs_select_include_users_for_show_referral_link').parent().parent().hide();

                }
            });
            jQuery('#rs_display_msg_when_access_is_prevented').closest('tr').show();
            if (jQuery('#rs_display_msg_when_access_is_prevented').val() == '1') {
                jQuery('#rs_msg_for_restricted_user').closest('tr').show();
            } else {
                jQuery('#rs_msg_for_restricted_user').closest('tr').hide();
            }

            jQuery('#rs_display_msg_when_access_is_prevented').change(function () {
                if (jQuery('#rs_display_msg_when_access_is_prevented').val() == '1') {
                    jQuery('#rs_msg_for_restricted_user').closest('tr').show();
                } else {
                    jQuery('#rs_msg_for_restricted_user').closest('tr').hide();
                }
            });
        } else {
            jQuery('#rs_show_hide_generate_referral_link_type').parent().parent().hide();
            jQuery('#rs_prefill_generate_link').parent().parent().hide();
            jQuery('#rs_static_generate_link').parent().parent().hide();
            jQuery('#rs_my_referral_link_button_label').parent().parent().hide();
            jQuery('#rs_generate_referral_link_based_on_user').parent().parent().hide();
            jQuery('#rs_enable_copy_to_clipboard').closest('tr').hide();
            jQuery('#rs_generate_link_label').closest('tr').hide();
            jQuery('#rs_generate_link_sno_label').closest('tr').hide();
            jQuery('#rs_generate_link_date_label').closest('tr').hide();
            jQuery('#rs_generate_link_referrallink_label').closest('tr').hide();
            jQuery('#rs_generate_link_social_label').closest('tr').hide();
            jQuery('#rs_generate_link_action_label').closest('tr').hide();
            jQuery('#rs_generate_link_button_label').closest('tr').hide();
            jQuery('#rs_select_type_of_user_for_referral').closest('tr').hide();
            jQuery('#rs_select_exclude_users_list_for_show_referral_link').closest('tr').hide();
            jQuery('#rs_select_include_users_for_show_referral_link').closest('tr').hide();
            jQuery('#rs_select_users_role_for_show_referral_link').closest('tr').hide();
            jQuery('#rs_select_exclude_users_role_for_show_referral_link').closest('tr').hide();
            jQuery('#rs_display_msg_when_access_is_prevented').closest('tr').hide();
            jQuery('#rs_msg_for_restricted_user').closest('tr').hide();
            jQuery('#rs_display_generate_referral').closest('tr').hide();
            jQuery('#rs_extra_class_name_generate_referral_link').closest('tr').hide();
        }
    });

    if (jQuery('#rs_show_hide_redeem_voucher').val() == '1') {
        jQuery('#rs_redeem_your_gift_voucher_label').closest('tr').show();
        jQuery('#rs_redeem_gift_voucher_button_label').closest('tr').show();
        jQuery('#rs_redeem_voucher_position').closest('tr').show();
        jQuery('#rs_redeem_your_gift_voucher_placeholder').closest('tr').show();
    } else {
        jQuery('#rs_redeem_your_gift_voucher_label').closest('tr').hide();
        jQuery('#rs_redeem_gift_voucher_button_label').closest('tr').hide();
        jQuery('#rs_redeem_voucher_position').closest('tr').hide();
        jQuery('#rs_redeem_your_gift_voucher_placeholder').closest('tr').hide();
    }

    jQuery('#rs_show_hide_redeem_voucher').change(function () {
        if (jQuery('#rs_show_hide_redeem_voucher').val() == '1') {
            jQuery('#rs_redeem_your_gift_voucher_label').closest('tr').show();
            jQuery('#rs_redeem_gift_voucher_button_label').closest('tr').show();
            jQuery('#rs_redeem_voucher_position').closest('tr').show();
            jQuery('#rs_redeem_your_gift_voucher_placeholder').closest('tr').show();
        } else {
            jQuery('#rs_redeem_your_gift_voucher_label').closest('tr').hide();
            jQuery('#rs_redeem_gift_voucher_button_label').closest('tr').hide();
            jQuery('#rs_redeem_voucher_position').closest('tr').hide();
            jQuery('#rs_redeem_your_gift_voucher_placeholder').closest('tr').hide();
        }
    });

    if (jQuery('#rs_account_show_hide_facebook_like_button').val() == '1') {
        jQuery('#rs_facebook_title').closest('tr').show();
        jQuery('#rs_facebook_description').closest('tr').show();
        jQuery('#rs_fbshare_image_url_upload').closest('tr').show();
    } else {
        jQuery('#rs_facebook_title').closest('tr').hide();
        jQuery('#rs_facebook_description').closest('tr').hide();
        jQuery('#rs_fbshare_image_url_upload').closest('tr').hide();
    }

    jQuery('#rs_account_show_hide_facebook_like_button').change(function () {
        if (jQuery('#rs_account_show_hide_facebook_like_button').val() == '1') {
            jQuery('#rs_facebook_title').closest('tr').show();
            jQuery('#rs_facebook_description').closest('tr').show();
            jQuery('#rs_fbshare_image_url_upload').closest('tr').show();
        } else {
            jQuery('#rs_facebook_title').closest('tr').hide();
            jQuery('#rs_facebook_description').closest('tr').hide();
            jQuery('#rs_fbshare_image_url_upload').closest('tr').hide();
        }
    });

    if (jQuery('#rs_show_hide_referal_table').val() == '1') {
        jQuery('#rs_referal_table_title').closest('tr').show();
        jQuery('#rs_my_referal_sno_label').closest('tr').show();
        jQuery('#rs_my_referal_userid_label').closest('tr').show();
        jQuery('#rs_my_total_referal_points_label').closest('tr').show();
    } else {
        jQuery('#rs_referal_table_title').closest('tr').hide();
        jQuery('#rs_my_referal_sno_label').closest('tr').hide();
        jQuery('#rs_my_referal_userid_label').closest('tr').hide();
        jQuery('#rs_my_total_referal_points_label').closest('tr').hide();
    }

    jQuery('#rs_show_hide_referal_table').change(function () {
        if (jQuery('#rs_show_hide_referal_table').val() == '1') {
            jQuery('#rs_referal_table_title').closest('tr').show();
            jQuery('#rs_my_referal_sno_label').closest('tr').show();
            jQuery('#rs_my_referal_userid_label').closest('tr').show();
            jQuery('#rs_my_total_referal_points_label').closest('tr').show();
        } else {
            jQuery('#rs_referal_table_title').closest('tr').hide();
            jQuery('#rs_my_referal_sno_label').closest('tr').hide();
            jQuery('#rs_my_referal_userid_label').closest('tr').hide();
            jQuery('#rs_my_total_referal_points_label').closest('tr').hide();
        }
    });

    if (jQuery('#rs_show_hide_referal_table_shortcode').val() == '1') {
        jQuery('#rs_referal_table_title_shortcode').closest('tr').show();
        jQuery('#rs_my_referal_sno_label_shortcode').closest('tr').show();
        jQuery('#rs_my_referal_userid_label_shortcode').closest('tr').show();
        jQuery('#rs_my_total_referal_points_label_shortcode').closest('tr').show();
    } else {
        jQuery('#rs_referal_table_title_shortcode').closest('tr').hide();
        jQuery('#rs_my_referal_sno_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_referal_userid_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_total_referal_points_label_shortcode').closest('tr').hide();
    }

    jQuery('#rs_show_hide_referal_table_shortcode').change(function () {
        if (jQuery('#rs_show_hide_referal_table_shortcode').val() == '1') {
            jQuery('#rs_referal_table_title_shortcode').closest('tr').show();
            jQuery('#rs_my_referal_sno_label_shortcode').closest('tr').show();
            jQuery('#rs_my_referal_userid_label_shortcode').closest('tr').show();
            jQuery('#rs_my_total_referal_points_label_shortcode').closest('tr').show();
        } else {
            jQuery('#rs_referal_table_title_shortcode').closest('tr').hide();
            jQuery('#rs_my_referal_sno_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_referal_userid_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_total_referal_points_label_shortcode').closest('tr').hide();
        }
    });

    if (jQuery('#rs_show_hide_iagree_termsandcondition_field').val() == '2') {
        jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').show();
        jQuery('#rs_refer_friend_termscondition_caption').closest('tr').show();
        jQuery('#rs_refer_friend_termscondition_url').closest('tr').show();
    } else {
        jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').hide();
        jQuery('#rs_refer_friend_termscondition_caption').closest('tr').hide();
        jQuery('#rs_refer_friend_termscondition_url').closest('tr').hide();
    }

    jQuery('#rs_show_hide_iagree_termsandcondition_field').change(function () {
        if (jQuery('#rs_show_hide_iagree_termsandcondition_field').val() == '2') {
            jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').show();
            jQuery('#rs_refer_friend_termscondition_caption').closest('tr').show();
            jQuery('#rs_refer_friend_termscondition_url').closest('tr').show();
        } else {
            jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').hide();
            jQuery('#rs_refer_friend_termscondition_caption').closest('tr').hide();
            jQuery('#rs_refer_friend_termscondition_url').closest('tr').hide();
        }
    });

    /*Show or hide Settings for My Account Tab - End*/

    /*To hide Loader Image in Bulk Update Tab - Start*/

    jQuery('.gif_rs_sumo_reward_button').css('display', 'none');
    jQuery('.gif_rs_bulk_update_button_for_buying_points').css('display', 'none');
    jQuery('.gif_rs_sumo_reward_button_social').css('display', 'none');
    jQuery('.gif_rs_sumo_point_price_button').css('display', 'none');

    /*To hide Loader Image in Bulk Update Tab - End*/

    /*Show or hide Settings for Bulk Update Tab - Start*/
    if ((jQuery('.rs_which_point_precing_product_selection').val() === '1')) {
        jQuery('#rs_select_particular_products_for_point_price').parent().parent().hide();
        jQuery('#rs_select_particular_categories_for_point_price').parent().parent().hide();
    } else if (jQuery('.rs_which_point_precing_product_selection').val() === '2') {
        jQuery('#rs_select_particular_products_for_point_price').parent().parent().show();
        jQuery('#rs_select_particular_categories_for_point_price').parent().parent().hide();
    } else if (jQuery('.rs_which_point_precing_product_selection').val() === '3') {
        jQuery('#rs_select_particular_products_for_point_price').parent().parent().hide();
        jQuery('#rs_select_particular_categories_for_point_price').parent().parent().hide();
    } else {
        jQuery('#rs_select_particular_categories_for_point_price').parent().parent().show();
        jQuery('#rs_select_particular_products_for_point_price').parent().parent().hide();
    }


    jQuery('.rs_which_point_precing_product_selection').change(function () {
        if ((jQuery(this).val() === '1')) {
            jQuery('#rs_select_particular_categories_for_point_price').parent().parent().hide();
            jQuery('#rs_select_particular_products_for_point_price').parent().parent().hide();
        } else if (jQuery(this).val() === '2') {
            jQuery('#rs_select_particular_products_for_point_price').parent().parent().show();
            jQuery('#rs_select_particular_categories_for_point_price').parent().parent().hide();
        } else if (jQuery(this).val() === '3') {
            jQuery('#rs_select_particular_categories_for_point_price').parent().parent().hide();
            jQuery('#rs_select_particular_products_for_point_price').parent().parent().hide();
        } else {
            jQuery('#rs_select_particular_categories_for_point_price').parent().parent().show();
            jQuery('#rs_select_particular_products_for_point_price').parent().parent().hide();
        }
    });




    if ((jQuery('.rs_which_product_selection').val() === '1')) {
        jQuery('#rs_select_particular_products').parent().parent().hide();
        jQuery('#rs_select_particular_categories').parent().parent().hide();
    } else if (jQuery('.rs_which_product_selection').val() === '2') {
        jQuery('#rs_select_particular_products').parent().parent().show();
        jQuery('#rs_select_particular_categories').parent().parent().hide();
    } else if (jQuery('.rs_which_product_selection').val() === '3') {
        jQuery('#rs_select_particular_products').parent().parent().hide();
        jQuery('#rs_select_particular_categories').parent().parent().hide();
    } else {
        jQuery('#rs_select_particular_categories').parent().parent().show();
        jQuery('#rs_select_particular_products').parent().parent().hide();
    }

    if ((jQuery('.rs_which_social_product_selection').val() === '1')) {
        jQuery('#rs_select_particular_social_products').parent().parent().hide();
        jQuery('#rs_select_particular_social_categories').parent().parent().hide();
    } else if (jQuery('.rs_which_social_product_selection').val() === '2') {
        jQuery('#rs_select_particular_social_products').parent().parent().show();
        jQuery('#rs_select_particular_social_categories').parent().parent().hide();
    } else if (jQuery('.rs_which_social_product_selection').val() === '3') {
        jQuery('#rs_select_particular_social_products').parent().parent().hide();
        jQuery('#rs_select_particular_social_categories').parent().parent().hide();
    } else {
        jQuery('#rs_select_particular_social_categories').parent().parent().show();
        jQuery('#rs_select_particular_social_products').parent().parent().hide();
    }

    jQuery('.rs_which_product_selection').change(function () {
        if ((jQuery(this).val() === '1') || (jQuery(this).val() === '3')) {
            jQuery('#rs_select_particular_products').parent().parent().hide();
            jQuery('#rs_select_particular_categories').parent().parent().hide();
        } else if (jQuery(this).val() === '2') {
            jQuery('#rs_select_particular_products').parent().parent().show();
            jQuery('#rs_select_particular_categories').parent().parent().hide();
        } else {
            jQuery('#rs_select_particular_categories').parent().parent().show();
            jQuery('#rs_select_particular_products').parent().parent().hide();
        }
    });

    jQuery('.rs_which_social_product_selection').change(function () {
        if ((jQuery(this).val() === '1') || (jQuery(this).val() === '3')) {
            jQuery('#rs_select_particular_social_products').parent().parent().hide();
            jQuery('#rs_select_particular_social_categories').parent().parent().hide();
        } else if (jQuery(this).val() === '2') {
            jQuery('#rs_select_particular_social_products').parent().parent().show();
            jQuery('#rs_select_particular_social_categories').parent().parent().hide();
        } else {
            jQuery('#rs_select_particular_social_categories').parent().parent().show();
            jQuery('#rs_select_particular_social_products').parent().parent().hide();
        }
    });

    var selectrangevalue = jQuery('#rs_sumo_select_order_range').val();
    if (selectrangevalue === '1') {
        jQuery('#rs_from_date').parent().parent().hide();
    } else {
        jQuery('#rs_from_date').parent().parent().show();
    }
    jQuery('#rs_sumo_select_order_range').change(function () {
        if (jQuery(this).val() === '1') {
            jQuery('#rs_from_date').parent().parent().hide();
        } else {
            jQuery('#rs_from_date').parent().parent().show();
        }
    });

    if (jQuery('#rs_reward_content_menu_page').is(':checked') == true) {
        jQuery('#rs_my_reward_table_menu_page').parent().parent().show();
        jQuery('#rs_show_hide_generate_referral_menu_page').parent().parent().show();
        jQuery('#rs_show_hide_referal_table_menu_page').parent().parent().show();
        jQuery('#rs_my_cashback_table_menu_page').parent().parent().show();
        jQuery('#rs_show_hide_nominee_field_menu_page').parent().parent().show();
        jQuery('#rs_show_hide_redeem_voucher_menu_page').parent().parent().show();
        jQuery('#rs_show_hide_your_subscribe_link_menu_page').parent().parent().show();
        jQuery('#rs_my_reward_content_title').parent().parent().show();
        jQuery('#rs_my_reward_url_title').parent().parent().show();
    } else {
        jQuery('#rs_my_reward_table_menu_page').parent().parent().hide();
        jQuery('#rs_show_hide_generate_referral_menu_page').parent().parent().hide();
        jQuery('#rs_show_hide_referal_table_menu_page').parent().parent().hide();
        jQuery('#rs_my_cashback_table_menu_page').parent().parent().hide();
        jQuery('#rs_show_hide_nominee_field_menu_page').parent().parent().hide();
        jQuery('#rs_show_hide_redeem_voucher_menu_page').parent().parent().hide();
        jQuery('#rs_show_hide_your_subscribe_link_menu_page').parent().parent().hide();
        jQuery('#rs_my_reward_content_title').parent().parent().hide();
        jQuery('#rs_my_reward_url_title').parent().parent().hide();
    }

    jQuery('#rs_reward_content_menu_page').change(function () {
        if (jQuery('#rs_reward_content_menu_page').is(':checked') == true) {
            jQuery('#rs_my_reward_table_menu_page').parent().parent().show();
            jQuery('#rs_show_hide_generate_referral_menu_page').parent().parent().show();
            jQuery('#rs_show_hide_referal_table_menu_page').parent().parent().show();
            jQuery('#rs_my_cashback_table_menu_page').parent().parent().show();
            jQuery('#rs_show_hide_nominee_field_menu_page').parent().parent().show();
            jQuery('#rs_show_hide_redeem_voucher_menu_page').parent().parent().show();
            jQuery('#rs_show_hide_your_subscribe_link_menu_page').parent().parent().show();
            jQuery('#rs_my_reward_content_title').parent().parent().show();
            jQuery('#rs_my_reward_url_title').parent().parent().show();
        } else {
            jQuery('#rs_my_reward_table_menu_page').parent().parent().hide();
            jQuery('#rs_show_hide_generate_referral_menu_page').parent().parent().hide();
            jQuery('#rs_show_hide_referal_table_menu_page').parent().parent().hide();
            jQuery('#rs_my_cashback_table_menu_page').parent().parent().hide();
            jQuery('#rs_show_hide_nominee_field_menu_page').parent().parent().hide();
            jQuery('#rs_show_hide_redeem_voucher_menu_page').parent().parent().hide();
            jQuery('#rs_show_hide_your_subscribe_link_menu_page').parent().parent().hide();
            jQuery('#rs_my_reward_content_title').parent().parent().hide();
            jQuery('#rs_my_reward_url_title').parent().parent().hide();
        }
    });
    /*
     * Show or Hide For Reward Points Menu Restrict Based on User Role
     */
    if (jQuery('#rs_menu_restriction_based_on_user_role').is(':checked') == true) {
        jQuery('.rewardpoints_userrole_menu_restriction').parent().parent().show();
    } else {
        jQuery('.rewardpoints_userrole_menu_restriction').parent().parent().hide();
    }

    jQuery('#rs_menu_restriction_based_on_user_role').change(function () {
        if (jQuery('#rs_menu_restriction_based_on_user_role').is(':checked') == true) {
            jQuery('.rewardpoints_userrole_menu_restriction').parent().parent().show();
        } else {
            jQuery('.rewardpoints_userrole_menu_restriction').parent().parent().hide();
        }
    });
    /*
     * Show or Hide For Reward Points In Update
     */

    if (jQuery('#rs_local_enable_disable_reward').val() == '2') {
        jQuery('.show_if_enable_in_reward').parent().parent().hide();
    } else {
        jQuery('.show_if_enable_in_reward').parent().parent().show();

        if (jQuery('#rs_local_reward_type').val() === '1') {
            jQuery('#rs_local_reward_points').parent().parent().show();
            jQuery('#rs_local_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points').parent().parent().hide();
            jQuery('#rs_local_reward_percent').parent().parent().show();
        }

        jQuery('#rs_local_reward_type').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points').parent().parent().show();
                jQuery('#rs_local_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points').parent().parent().hide();
                jQuery('#rs_local_reward_percent').parent().parent().show();
            }
        });
    }

    jQuery('#rs_local_enable_disable_reward').change(function () {
        if (jQuery(this).val() == '2') {
            jQuery('.show_if_enable_in_reward').parent().parent().hide();
        } else {
            jQuery('.show_if_enable_in_reward').parent().parent().show();

            if (jQuery('#rs_local_reward_type').val() === '1') {
                jQuery('#rs_local_reward_points').parent().parent().show();
                jQuery('#rs_local_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points').parent().parent().hide();
                jQuery('#rs_local_reward_percent').parent().parent().show();
            }

            jQuery('#rs_local_reward_type').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points').parent().parent().show();
                    jQuery('#rs_local_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points').parent().parent().hide();
                    jQuery('#rs_local_reward_percent').parent().parent().show();
                }
            });
        }
    });

    if (jQuery('#rs_local_enable_disable_referral_reward').val() == '2') {
        jQuery('.show_if_enable_in_update_referral').parent().parent().hide();
    } else {
        jQuery('.show_if_enable_in_update_referral').parent().parent().show();

        if (jQuery('#rs_local_referral_reward_type').val() === '1') {
            jQuery('#rs_local_referral_reward_point').parent().parent().show();
            jQuery('#rs_local_referral_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_local_referral_reward_point').parent().parent().hide();
            jQuery('#rs_local_referral_reward_percent').parent().parent().show();
        }

        jQuery('#rs_local_referral_reward_type').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_referral_reward_point').parent().parent().show();
                jQuery('#rs_local_referral_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_local_referral_reward_point').parent().parent().hide();
                jQuery('#rs_local_referral_reward_percent').parent().parent().show();
            }
        });

        if (jQuery('#rs_local_referral_reward_type_get_refer').val() === '1') {
            jQuery('#rs_local_referral_reward_point_for_getting_referred').parent().parent().show();
            jQuery('#rs_local_referral_reward_percent_for_getting_referred').parent().parent().hide();
        } else {
            jQuery('#rs_local_referral_reward_point_for_getting_referred').parent().parent().hide();
            jQuery('#rs_local_referral_reward_percent_for_getting_referred').parent().parent().show();
        }

        jQuery('#rs_local_referral_reward_type_get_refer').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_referral_reward_point_for_getting_referred').parent().parent().show();
                jQuery('#rs_local_referral_reward_percent_for_getting_referred').parent().parent().hide();
            } else {
                jQuery('#rs_local_referral_reward_point_for_getting_referred').parent().parent().hide();
                jQuery('#rs_local_referral_reward_percent_for_getting_referred').parent().parent().show();
            }
        });

    }

    jQuery('#rs_local_enable_disable_referral_reward').change(function () {
        if (jQuery('#rs_local_enable_disable_referral_reward').val() == '2') {
            jQuery('.show_if_enable_in_update_referral').parent().parent().hide();
        } else {
            jQuery('.show_if_enable_in_update_referral').parent().parent().show();

            if (jQuery('#rs_local_referral_reward_type').val() === '1') {
                jQuery('#rs_local_referral_reward_point').parent().parent().show();
                jQuery('#rs_local_referral_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_local_referral_reward_point').parent().parent().hide();
                jQuery('#rs_local_referral_reward_percent').parent().parent().show();
            }

            jQuery('#rs_local_referral_reward_type').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_referral_reward_point').parent().parent().show();
                    jQuery('#rs_local_referral_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_local_referral_reward_point').parent().parent().hide();
                    jQuery('#rs_local_referral_reward_percent').parent().parent().show();
                }
            });

            if (jQuery('#rs_local_referral_reward_type_get_refer').val() === '1') {
                jQuery('#rs_local_referral_reward_point_for_getting_referred').parent().parent().show();
                jQuery('#rs_local_referral_reward_percent_for_getting_referred').parent().parent().hide();
            } else {
                jQuery('#rs_local_referral_reward_point_for_getting_referred').parent().parent().hide();
                jQuery('#rs_local_referral_reward_percent_for_getting_referred').parent().parent().show();
            }

            jQuery('#rs_local_referral_reward_type_get_refer').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_referral_reward_point_for_getting_referred').parent().parent().show();
                    jQuery('#rs_local_referral_reward_percent_for_getting_referred').parent().parent().hide();
                } else {
                    jQuery('#rs_local_referral_reward_point_for_getting_referred').parent().parent().hide();
                    jQuery('#rs_local_referral_reward_percent_for_getting_referred').parent().parent().show();
                }
            });
        }
    });

    /*
     * End of Show or Hide For Reward Points In Update
     */


    /*
     * Show or Hide For Social Reward Points In Update
     */
    if (jQuery('#rs_local_enable_disable_social_reward').val() == '2') {
        jQuery('.show_if_social_enable_in_update').parent().parent().hide();
    } else {
        jQuery('.show_if_social_enable_in_update').parent().parent().show();

        if (jQuery('#rs_local_reward_type_for_facebook').val() === '1') {
            jQuery('#rs_local_reward_points_facebook').parent().parent().show();
            jQuery('#rs_local_reward_percent_facebook').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points_facebook').parent().parent().hide();
            jQuery('#rs_local_reward_percent_facebook').parent().parent().show();
        }

        jQuery('#rs_local_reward_type_for_facebook').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points_facebook').parent().parent().show();
                jQuery('#rs_local_reward_percent_facebook').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_facebook').parent().parent().hide();
                jQuery('#rs_local_reward_percent_facebook').parent().parent().show();
            }
        });

        if (jQuery('#rs_local_reward_type_for_facebook_share').val() === '1') {
            jQuery('#rs_local_reward_points_facebook_share').parent().parent().show();
            jQuery('#rs_local_reward_percent_facebook_share').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points_facebook_share').parent().parent().hide();
            jQuery('#rs_local_reward_percent_facebook_share').parent().parent().show();
        }

        jQuery('#rs_local_reward_type_for_facebook_share').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points_facebook_share').parent().parent().show();
                jQuery('#rs_local_reward_percent_facebook_share').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_facebook_share').parent().parent().hide();
                jQuery('#rs_local_reward_percent_facebook_share').parent().parent().show();
            }
        });
        if (jQuery('#rs_local_reward_type_for_twitter').val() === '1') {
            jQuery('#rs_local_reward_points_twitter').parent().parent().show();
            jQuery('#rs_local_reward_percent_twitter').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points_twitter').parent().parent().hide();
            jQuery('#rs_local_reward_percent_twitter').parent().parent().show();
        }

        jQuery('#rs_local_reward_type_for_twitter').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points_twitter').parent().parent().show();
                jQuery('#rs_local_reward_percent_twitter').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_twitter').parent().parent().hide();
                jQuery('#rs_local_reward_percent_twitter').parent().parent().show();
            }
        });
        if (jQuery('#rs_local_reward_type_for_twitter_follow').val() === '1') {
            jQuery('#rs_local_reward_points_twitter_follow').parent().parent().show();
            jQuery('#rs_local_reward_percent_twitter_follow').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points_twitter_follow').parent().parent().hide();
            jQuery('#rs_local_reward_percent_twitter_follow').parent().parent().show();
        }

        jQuery('#rs_local_reward_type_for_twitter_follow').change(function () {

            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points_twitter_follow').parent().parent().show();
                jQuery('#rs_local_reward_percent_twitter_follow').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_twitter_follow').parent().parent().hide();
                jQuery('#rs_local_reward_percent_twitter_follow').parent().parent().show();
            }
        });
        if (jQuery('#rs_local_reward_type_for_vk').val() === '1') {
            jQuery('#rs_local_reward_points_vk').parent().parent().show();
            jQuery('#rs_local_reward_percent_vk').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points_vk').parent().parent().hide();
            jQuery('#rs_local_reward_percent_vk').parent().parent().show();
        }

        jQuery('#rs_local_reward_type_for_vk').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points_vk').parent().parent().show();
                jQuery('#rs_local_reward_percent_vk').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_vk').parent().parent().hide();
                jQuery('#rs_local_reward_percent_vk').parent().parent().show();
            }
        });

        if (jQuery('#rs_local_reward_type_for_ok_follow').val() === '1') {
            jQuery('#rs_local_reward_points_ok_follow').parent().parent().show();
            jQuery('#rs_local_reward_percent_ok_follow').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points_ok_follow').parent().parent().hide();
            jQuery('#rs_local_reward_percent_ok_follow').parent().parent().show();
        }

        jQuery('#rs_local_reward_type_for_ok_follow').change(function () {

            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points_ok_follow').parent().parent().show();
                jQuery('#rs_local_reward_percent_ok_follow').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_ok_follow').parent().parent().hide();
                jQuery('#rs_local_reward_percent_ok_follow').parent().parent().show();
            }
        });
        if (jQuery('#rs_local_reward_type_for_instagram').val() === '1') {
            jQuery('#rs_local_reward_points_instagram').parent().parent().show();
            jQuery('#rs_local_reward_percent_instagram').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points_instagram').parent().parent().hide();
            jQuery('#rs_local_reward_percent_instagram').parent().parent().show();
        }

        jQuery('#rs_local_reward_type_for_instagram').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points_instagram').parent().parent().show();
                jQuery('#rs_local_reward_percent_instagram').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_instagram').parent().parent().hide();
                jQuery('#rs_local_reward_percent_instagram').parent().parent().show();
            }
        });
        if (jQuery('#rs_local_reward_type_for_google').val() === '1') {
            jQuery('#rs_local_reward_points_google').parent().parent().show();
            jQuery('#rs_local_reward_percent_google').parent().parent().hide();
        } else {
            jQuery('#rs_local_reward_points_google').parent().parent().hide();
            jQuery('#rs_local_reward_percent_google').parent().parent().show();
        }

        jQuery('#rs_local_reward_type_for_google').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_local_reward_points_google').parent().parent().show();
                jQuery('#rs_local_reward_percent_google').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_google').parent().parent().hide();
                jQuery('#rs_local_reward_percent_google').parent().parent().show();
            }
        });
    }

    jQuery('#rs_local_enable_disable_social_reward').change(function () {
        if (jQuery(this).val() == '2') {
            jQuery('.show_if_social_enable_in_update').parent().parent().hide();
        } else {
            jQuery('.show_if_social_enable_in_update').parent().parent().show();

            if (jQuery('#rs_local_reward_type_for_facebook').val() === '1') {
                jQuery('#rs_local_reward_points_facebook').parent().parent().show();
                jQuery('#rs_local_reward_percent_facebook').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_facebook').parent().parent().hide();
                jQuery('#rs_local_reward_percent_facebook').parent().parent().show();
            }

            jQuery('#rs_local_reward_type_for_facebook').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points_facebook').parent().parent().show();
                    jQuery('#rs_local_reward_percent_facebook').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points_facebook').parent().parent().hide();
                    jQuery('#rs_local_reward_percent_facebook').parent().parent().show();
                }
            });

            if (jQuery('#rs_local_reward_type_for_facebook_share').val() === '1') {
                jQuery('#rs_local_reward_points_facebook_share').parent().parent().show();
                jQuery('#rs_local_reward_percent_facebook_share').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_facebook_share').parent().parent().hide();
                jQuery('#rs_local_reward_percent_facebook_share').parent().parent().show();
            }

            jQuery('#rs_local_reward_type_for_facebook_share').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points_facebook_share').parent().parent().show();
                    jQuery('#rs_local_reward_percent_facebook_share').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points_facebook_share').parent().parent().hide();
                    jQuery('#rs_local_reward_percent_facebook_share').parent().parent().show();
                }
            });

            if (jQuery('#rs_local_reward_type_for_twitter').val() === '1') {
                jQuery('#rs_local_reward_points_twitter').parent().parent().show();
                jQuery('#rs_local_reward_percent_twitter').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_twitter').parent().parent().hide();
                jQuery('#rs_local_reward_percent_twitter').parent().parent().show();
            }

            jQuery('#rs_local_reward_type_for_twitter').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points_twitter').parent().parent().show();
                    jQuery('#rs_local_reward_percent_twitter').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points_twitter').parent().parent().hide();
                    jQuery('#rs_local_reward_percent_twitter').parent().parent().show();
                }
            });

            if (jQuery('#rs_local_reward_type_for_twitter_follow').val() === '1') {
                jQuery('#rs_local_reward_points_twitter_follow').parent().parent().show();
                jQuery('#rs_local_reward_percent_twitter_follow').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_twitter_follow').parent().parent().hide();
                jQuery('#rs_local_reward_percent_twitter_follow').parent().parent().show();
            }

            jQuery('#rs_local_reward_type_for_twitter_follow').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points_twitter_follow').parent().parent().show();
                    jQuery('#rs_local_reward_percent_twitter_follow').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points_twitter_follow').parent().parent().hide();
                    jQuery('#rs_local_reward_percent_twitter_follow').parent().parent().show();
                }
            });
            if (jQuery('#rs_local_reward_type_for_vk').val() === '1') {
                jQuery('#rs_local_reward_points_vk').parent().parent().show();
                jQuery('#rs_local_reward_percent_vk').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_vk').parent().parent().hide();
                jQuery('#rs_local_reward_percent_vk').parent().parent().show();
            }

            jQuery('#rs_local_reward_type_for_vk').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points_vk').parent().parent().show();
                    jQuery('#rs_local_reward_percent_vk').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points_vk').parent().parent().hide();
                    jQuery('#rs_local_reward_percent_vk').parent().parent().show();
                }
            });
            if (jQuery('#rs_local_reward_type_for_instagram').val() === '1') {
                jQuery('#rs_local_reward_points_instagram').parent().parent().show();
                jQuery('#rs_local_reward_percent_instagram').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_instagram').parent().parent().hide();
                jQuery('#rs_local_reward_percent_instagram').parent().parent().show();
            }

            jQuery('#rs_local_reward_type_for_instagram').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points_instagram').parent().parent().show();
                    jQuery('#rs_local_reward_percent_instagram').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points_instagram').parent().parent().hide();
                    jQuery('#rs_local_reward_percent_instagram').parent().parent().show();
                }
            });
            if (jQuery('#rs_local_reward_type_for_google').val() === '1') {
                jQuery('#rs_local_reward_points_google').parent().parent().show();
                jQuery('#rs_local_reward_percent_google').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_google').parent().parent().hide();
                jQuery('#rs_local_reward_percent_google').parent().parent().show();
            }

            jQuery('#rs_local_reward_type_for_google').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points_google').parent().parent().show();
                    jQuery('#rs_local_reward_percent_google').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points_google').parent().parent().hide();
                    jQuery('#rs_local_reward_percent_google').parent().parent().show();
                }
            });

            if (jQuery('#rs_local_reward_type_for_ok_follow').val() === '1') {
                jQuery('#rs_local_reward_points_ok_follow').parent().parent().show();
                jQuery('#rs_local_reward_percent_ok_follow').parent().parent().hide();
            } else {
                jQuery('#rs_local_reward_points_ok_follow').parent().parent().hide();
                jQuery('#rs_local_reward_percent_ok_follow').parent().parent().show();
            }

            jQuery('#rs_local_reward_type_for_ok_follow').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_local_reward_points_ok_follow').parent().parent().show();
                    jQuery('#rs_local_reward_percent_ok_follow').parent().parent().hide();
                } else {
                    jQuery('#rs_local_reward_points_ok_follow').parent().parent().hide();
                    jQuery('#rs_local_reward_percent_ok_follow').parent().parent().show();
                }
            });
        }
    });

    /*Show or hide Settings for Bulk Update Tab - End*/

    /*Show or hide Settings for Social Reward Tab - Start*/

    /*Show or Hide for FB Like Section - Start*/
    if ((jQuery('#rs_global_show_hide_facebook_like_button').val()) === '1') {
        jQuery('#rs_global_show_hide_social_tooltip_for_facebook').parent().parent().show();
        jQuery('#rs_global_social_facebook_url').parent().parent().show();

        /*Show or Hide for FB Custom URL - Start*/
        if ((jQuery('#rs_global_social_facebook_url').val()) === '2') {
            jQuery('#rs_global_social_facebook_url_custom').parent().parent().show();
        } else {
            jQuery('#rs_global_social_facebook_url_custom').parent().parent().hide();
        }

        jQuery('#rs_global_social_facebook_url').change(function () {
            if ((jQuery('#rs_global_social_facebook_url').val()) === '2') {
                jQuery('#rs_global_social_facebook_url_custom').parent().parent().show();
            } else {
                jQuery('#rs_global_social_facebook_url_custom').parent().parent().hide();
            }
        });
        /*Show or Hide for FB Custom URL - End*/

        /*Show or Hide for FB Like Tooltip - Start*/
        if ((jQuery('#rs_global_show_hide_social_tooltip_for_facebook').val()) === '1') {
            jQuery('#rs_social_message_for_facebook').parent().parent().show();
        } else {
            jQuery('#rs_social_message_for_facebook').parent().parent().hide();
        }

        jQuery('#rs_global_show_hide_social_tooltip_for_facebook').change(function () {
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_facebook').val()) === '1') {
                jQuery('#rs_social_message_for_facebook').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_facebook').parent().parent().hide();
            }
        });
        jQuery('#rs_send_mail_Facebook_like').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_Facebook_like').is(':checked') == true) {
            jQuery('#rs_email_subject_facebook_like').closest('tr').show();
            jQuery('#rs_email_message_facebook_like').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_facebook_like').closest('tr').hide();
            jQuery('#rs_email_message_facebook_like').closest('tr').hide();
        }

        jQuery('#rs_send_mail_Facebook_like').change(function () {
            if (jQuery('#rs_send_mail_Facebook_like').is(':checked') == true) {
                jQuery('#rs_email_subject_facebook_like').closest('tr').show();
                jQuery('#rs_email_message_facebook_like').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_facebook_like').closest('tr').hide();
                jQuery('#rs_email_message_facebook_like').closest('tr').hide();
            }
        });
        /*Show or Hide for FB Like Tooltip - End*/
        jQuery('#rs_succcess_message_for_facebook_like').parent().parent().show();
        jQuery('#rs_unsucccess_message_for_facebook_unlike').parent().parent().show();
    } else {
        jQuery('#rs_global_show_hide_social_tooltip_for_facebook').parent().parent().hide();
        jQuery('#rs_social_message_for_facebook').parent().parent().hide();
        jQuery('#rs_global_social_facebook_url').parent().parent().hide();
        jQuery('#rs_global_social_facebook_url_custom').parent().parent().hide();
        jQuery('#rs_succcess_message_for_facebook_like').parent().parent().hide();
        jQuery('#rs_unsucccess_message_for_facebook_unlike').parent().parent().hide();
        jQuery('#rs_send_mail_Facebook_like').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_facebook_like').parent().parent().hide();
        jQuery('#rs_email_message_facebook_like').parent().parent().hide();


    }

    jQuery('#rs_global_show_hide_facebook_like_button').change(function () {
        if ((jQuery('#rs_global_show_hide_facebook_like_button').val()) === '1') {
            jQuery('#rs_global_show_hide_social_tooltip_for_facebook').parent().parent().show();
            jQuery('#rs_global_social_facebook_url').parent().parent().show();

            /*Show or Hide for FB Custom URL - Start*/
            if ((jQuery('#rs_global_social_facebook_url').val()) === '2') {
                jQuery('#rs_global_social_facebook_url_custom').parent().parent().show();
            } else {
                jQuery('#rs_global_social_facebook_url_custom').parent().parent().hide();
            }

            jQuery('#rs_global_social_facebook_url').change(function () {
                if ((jQuery('#rs_global_social_facebook_url').val()) === '2') {
                    jQuery('#rs_global_social_facebook_url_custom').parent().parent().show();
                } else {
                    jQuery('#rs_global_social_facebook_url_custom').parent().parent().hide();
                }
            });
            /*Show or Hide for FB Custom URL - End*/

            /*Show or Hide for FB Like Tooltip - Start*/
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_facebook').val()) === '1') {
                jQuery('#rs_social_message_for_facebook').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_facebook').parent().parent().hide();
            }

            jQuery('#rs_global_show_hide_social_tooltip_for_facebook').change(function () {
                if ((jQuery('#rs_global_show_hide_social_tooltip_for_facebook').val()) === '1') {
                    jQuery('#rs_social_message_for_facebook').parent().parent().show();
                } else {
                    jQuery('#rs_social_message_for_facebook').parent().parent().hide();
                }
            });
            jQuery('#rs_send_mail_Facebook_like').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_Facebook_like').is(':checked') == true) {
                jQuery('#rs_email_subject_facebook_like').parent().parent().show();
                jQuery('#rs_email_message_facebook_like').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_facebook_like').parent().parent().hide();
                jQuery('#rs_email_message_facebook_like').parent().parent().hide();
            }

            jQuery('#rs_send_mail_Facebook_like').change(function () {
                if (jQuery('#rs_send_mail_Facebook_like').is(':checked') == true) {
                    jQuery('#rs_email_subject_facebook_like').parent().parent().show();
                    jQuery('#rs_email_message_facebook_like').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_facebook_like').parent().parent().hide();
                    jQuery('#rs_email_message_facebook_like').parent().parent().hide();
                }
            });
            /*Show or Hide for FB Like Tooltip - End*/
            jQuery('#rs_succcess_message_for_facebook_like').parent().parent().show();
            jQuery('#rs_unsucccess_message_for_facebook_unlike').parent().parent().show();
        } else {
            jQuery('#rs_global_show_hide_social_tooltip_for_facebook').parent().parent().hide();
            jQuery('#rs_social_message_for_facebook').parent().parent().hide();
            jQuery('#rs_global_social_facebook_url').parent().parent().hide();
            jQuery('#rs_global_social_facebook_url_custom').parent().parent().hide();
            jQuery('#rs_succcess_message_for_facebook_like').parent().parent().hide();
            jQuery('#rs_unsucccess_message_for_facebook_unlike').parent().parent().hide();
            jQuery('#rs_send_mail_Facebook_like').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_facebook_like').parent().parent().hide();
            jQuery('#rs_email_message_facebook_like').parent().parent().hide();
        }
    });
    /*Show or Hide for FB Like Section - End*/

    /*Show or Hide for FB Share Section - Start*/
    if ((jQuery('#rs_global_show_hide_facebook_share_button').val()) === '1') {
        jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').parent().parent().show();
        jQuery('#rs_fbshare_button_label').parent().parent().show();

        /*Show or Hide for FB Share Tooltip - Start*/
        if ((jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').val()) === '1') {
            jQuery('#rs_social_message_for_facebook_share').parent().parent().show();
        } else {
            jQuery('#rs_social_message_for_facebook_share').parent().parent().hide();
        }

        jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').change(function () {
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').val()) === '1') {
                jQuery('#rs_social_message_for_facebook_share').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_facebook_share').parent().parent().hide();
            }
        });
        jQuery('#rs_send_mail_facebook_share').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_facebook_share').is(':checked') == true) {
            jQuery('#rs_email_subject_facebook_share').parent().parent().show();
            jQuery('#rs_email_message_facebook_share').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_facebook_share').parent().parent().hide();
            jQuery('#rs_email_message_facebook_share').parent().parent().hide();
        }

        jQuery('#rs_send_mail_facebook_share').change(function () {
            if (jQuery('#rs_send_mail_facebook_share').is(':checked') == true) {
                jQuery('#rs_email_subject_facebook_share').parent().parent().show();
                jQuery('#rs_email_message_facebook_share').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_facebook_share').parent().parent().hide();
                jQuery('#rs_email_message_facebook_share').parent().parent().hide();
            }
        });




        /*Show or Hide for FB Share Tooltip - End*/
        jQuery('#rs_succcess_message_for_facebook_share').parent().parent().show();
        jQuery('#rs_unsucccess_message_for_facebook_share').parent().parent().show();
    } else {
        jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').parent().parent().hide();
        jQuery('#rs_social_message_for_facebook_share').parent().parent().hide();
        jQuery('#rs_succcess_message_for_facebook_share').parent().parent().hide();
        jQuery('#rs_unsucccess_message_for_facebook_share').parent().parent().hide();
        jQuery('#rs_fbshare_button_label').parent().parent().hide();
        jQuery('#rs_send_mail_facebook_share').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_facebook_share').parent().parent().hide();
        jQuery('#rs_email_message_facebook_share').parent().parent().hide();
    }

    jQuery('#rs_global_show_hide_facebook_share_button').change(function () {
        if ((jQuery('#rs_global_show_hide_facebook_share_button').val()) === '1') {
            jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').parent().parent().show();
            jQuery('#rs_fbshare_button_label').parent().parent().show();

            /*Show or Hide for FB Share Tooltip - Start*/
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').val()) === '1') {
                jQuery('#rs_social_message_for_facebook_share').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_facebook_share').parent().parent().hide();
            }

            jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').change(function () {
                if ((jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').val()) === '1') {
                    jQuery('#rs_social_message_for_facebook_share').parent().parent().show();
                } else {
                    jQuery('#rs_social_message_for_facebook_share').parent().parent().hide();
                }
            });

            jQuery('#rs_send_mail_facebook_share').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_facebook_share').is(':checked') == true) {
                jQuery('#rs_email_subject_facebook_share').parent().parent().show();
                jQuery('#rs_email_message_facebook_share').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_facebook_share').parent().parent().hide();
                jQuery('#rs_email_message_facebook_share').parent().parent().hide();
            }

            jQuery('#rs_send_mail_facebook_share').change(function () {
                if (jQuery('#rs_send_mail_facebook_share').is(':checked') == true) {
                    jQuery('#rs_email_subject_facebook_share').parent().parent().show();
                    jQuery('#rs_email_message_facebook_share').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_facebook_share').parent().parent().hide();
                    jQuery('#rs_email_message_facebook_share').parent().parent().hide();
                }
            });

            /*Show or Hide for FB Share Tooltip - End*/
            jQuery('#rs_succcess_message_for_facebook_share').parent().parent().show();
            jQuery('#rs_unsucccess_message_for_facebook_share').parent().parent().show();
        } else {
            jQuery('#rs_global_show_hide_social_tooltip_for_facebook_share').parent().parent().hide();
            jQuery('#rs_social_message_for_facebook_share').parent().parent().hide();
            jQuery('#rs_succcess_message_for_facebook_share').parent().parent().hide();
            jQuery('#rs_unsucccess_message_for_facebook_share').parent().parent().hide();
            jQuery('#rs_fbshare_button_label').parent().parent().hide();
            jQuery('#rs_send_mail_facebook_share').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_facebook_share').parent().parent().hide();
            jQuery('#rs_email_message_facebook_share').parent().parent().hide();
        }
    });
    /*Show or Hide for FB Share Section - End*/

    /*Show or Hide for Twitter Tweet Section - Start*/
    if ((jQuery('#rs_global_show_hide_twitter_tweet_button').val()) === '1') {
        jQuery('#rs_global_show_hide_social_tooltip_for_twitter').parent().parent().show();
        jQuery('#rs_global_social_twitter_url').parent().parent().show();
        /*Show or Hide for Twitter Custom URL - Start*/
        if ((jQuery('#rs_global_social_twitter_url').val()) === '2') {
            jQuery('#rs_global_social_twitter_url_custom').parent().parent().show();
        } else {
            jQuery('#rs_global_social_twitter_url_custom').parent().parent().hide();
        }

        jQuery('#rs_global_social_twitter_url').change(function () {
            jQuery('#rs_global_social_twitter_url_custom').parent().parent().toggle();
        });
        /*Show or Hide for Twitter Custom URL - End*/

        /*Show or Hide for Twitter Tweet Tooltip - Start*/
        if ((jQuery('#rs_global_show_hide_social_tooltip_for_twitter').val()) === '1') {
            jQuery('#rs_social_message_for_twitter').parent().parent().show();
        } else {
            jQuery('#rs_social_message_for_twitter').parent().parent().hide();
        }

        jQuery('#rs_global_show_hide_social_tooltip_for_twitter').change(function () {
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_twitter').val()) === '1') {
                jQuery('#rs_social_message_for_twitter').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_twitter').parent().parent().hide();
            }
        });

        jQuery('#rs_send_mail_tewitter_tweet').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_tewitter_tweet').is(':checked') == true) {
            jQuery('#rs_email_subject_twitter_tweet').parent().parent().show();
            jQuery('#rs_email_message_twitter_tweet').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_twitter_tweet').parent().parent().hide();
            jQuery('#rs_email_message_twitter_tweet').parent().parent().hide();
        }

        jQuery('#rs_send_mail_tewitter_tweet').change(function () {
            if (jQuery('#rs_send_mail_tewitter_tweet').is(':checked') == true) {
                jQuery('#rs_email_subject_twitter_tweet').parent().parent().show();
                jQuery('#rs_email_message_twitter_tweet').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_twitter_tweet').parent().parent().hide();
                jQuery('#rs_email_message_twitter_tweet').parent().parent().hide();
            }
        });
        /*Show or Hide for Twitter Tweet Tooltip - End*/
        jQuery('#rs_succcess_message_for_twitter_share').parent().parent().show();
        jQuery('#rs_unsucccess_message_for_twitter_unshare').parent().parent().show();
    } else {
        jQuery('#rs_global_show_hide_social_tooltip_for_twitter').parent().parent().hide();
        jQuery('#rs_social_message_for_twitter').parent().parent().hide();
        jQuery('#rs_succcess_message_for_twitter_share').parent().parent().hide();
        jQuery('#rs_global_social_twitter_url').parent().parent().hide();
        jQuery('#rs_global_social_twitter_url_custom').parent().parent().hide();
        jQuery('#rs_unsucccess_message_for_twitter_unshare').parent().parent().hide();
        jQuery('#rs_send_mail_tewitter_tweet').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_twitter_tweet').parent().parent().parent().parent().hide();
        jQuery('#rs_email_message_twitter_tweet').parent().parent().hide();
    }

    jQuery('#rs_global_show_hide_twitter_tweet_button').change(function () {
        if ((jQuery('#rs_global_show_hide_twitter_tweet_button').val()) === '1') {
            jQuery('#rs_global_show_hide_social_tooltip_for_twitter').parent().parent().show();
            jQuery('#rs_global_social_twitter_url').parent().parent().show();
            /*Show or Hide for Twitter Custom URL - Start*/
            if ((jQuery('#rs_global_social_twitter_url').val()) === '2') {
                jQuery('#rs_global_social_twitter_url_custom').parent().parent().show();
            } else {
                jQuery('#rs_global_social_twitter_url_custom').parent().parent().hide();
            }

            jQuery('#rs_global_social_twitter_url').change(function () {
                jQuery('#rs_global_social_twitter_url_custom').parent().parent().toggle();
            });
            /*Show or Hide for Twitter Custom URL - End*/

            /*Show or Hide for Twitter Tweet Tooltip - Start*/
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_twitter').val()) === '1') {
                jQuery('#rs_social_message_for_twitter').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_twitter').parent().parent().hide();
            }

            jQuery('#rs_global_show_hide_social_tooltip_for_twitter').change(function () {
                if ((jQuery('#rs_global_show_hide_social_tooltip_for_twitter').val()) === '1') {
                    jQuery('#rs_social_message_for_twitter').parent().parent().show();
                } else {
                    jQuery('#rs_social_message_for_twitter').parent().parent().hide();
                }
            });
            jQuery('#rs_send_mail_tewitter_tweet').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_tewitter_tweet').is(':checked') == true) {
                jQuery('#rs_email_subject_twitter_tweet').parent().parent().show();
                jQuery('#rs_email_message_twitter_tweet').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_twitter_tweet').parent().parent().hide();
                jQuery('#rs_email_message_twitter_tweet').parent().parent().hide();
            }

            jQuery('#rs_send_mail_tewitter_tweet').change(function () {
                if (jQuery('#rs_send_mail_tewitter_tweet').is(':checked') == true) {
                    jQuery('#rs_email_subject_twitter_tweet').parent().parent().show();
                    jQuery('#rs_email_message_twitter_tweet').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_twitter_tweet').parent().parent().hide();
                    jQuery('#rs_email_message_twitter_tweet').parent().parent().hide();
                }
            });
            /*Show or Hide for Twitter Tweet Tooltip - End*/
            jQuery('#rs_succcess_message_for_twitter_share').parent().parent().show();
            jQuery('#rs_unsucccess_message_for_twitter_unshare').parent().parent().show();
        } else {
            jQuery('#rs_global_show_hide_social_tooltip_for_twitter').parent().parent().hide();
            jQuery('#rs_social_message_for_twitter').parent().parent().hide();
            jQuery('#rs_succcess_message_for_twitter_share').parent().parent().hide();
            jQuery('#rs_global_social_twitter_url').parent().parent().hide();
            jQuery('#rs_global_social_twitter_url_custom').parent().parent().hide();
            jQuery('#rs_unsucccess_message_for_twitter_unshare').parent().parent().hide();
            jQuery('#rs_send_mail_tewitter_tweet').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_twitter_tweet').parent().parent().hide();
            jQuery('#rs_email_message_twitter_tweet').parent().parent().hide();
        }
    });
    /*Show or Hide for Twitter Tweet Section - End*/

    /*Show or Hide for Twitter Follow Section - Start*/
    if ((jQuery('#rs_global_show_hide_twitter_follow_tweet_button').val()) === '1') {
        jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').parent().parent().show();
        jQuery('#rs_global_social_twitter_profile_name').parent().parent().show();

        /*Show or Hide for Twitter Follow Tooltip - Start*/
        if ((jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').val()) === '1') {
            jQuery('#rs_social_message_for_twitter_follow').parent().parent().show();
        } else {
            jQuery('#rs_social_message_for_twitter_follow').parent().parent().hide();
        }

        jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').change(function () {
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').val()) === '1') {
                jQuery('#rs_social_message_for_twitter_follow').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_twitter_follow').parent().parent().hide();
            }
        });

        jQuery('#rs_send_mail_twitter_follow').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_twitter_follow').is(':checked') == true) {
            jQuery('#rs_email_subject_twitter_follow').parent().parent().show();
            jQuery('#rs_email_message_twitter_follow').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_twitter_follow').parent().parent().hide();
            jQuery('#rs_email_message_twitter_follow').parent().parent().hide();
        }

        jQuery('#rs_send_mail_twitter_follow').change(function () {
            if (jQuery('#rs_send_mail_twitter_follow').is(':checked') == true) {
                jQuery('#rs_email_subject_twitter_follow').parent().parent().show();
                jQuery('#rs_email_message_twitter_follow').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_twitter_follow').parent().parent().hide();
                jQuery('#rs_email_message_twitter_follow').parent().parent().hide();
            }
        });
        /*Show or Hide for Twitter Follow Tooltip - End*/
        jQuery('#rs_succcess_message_for_twitter_follow').parent().parent().show();
        jQuery('#rs_unsucccess_message_for_twitter_unfollow').parent().parent().show();
    } else {
        jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').parent().parent().hide();
        jQuery('#rs_global_social_twitter_profile_name').parent().parent().hide();
        jQuery('#rs_social_message_for_twitter_follow').parent().parent().hide();
        jQuery('#rs_succcess_message_for_twitter_follow').parent().parent().hide();
        jQuery('#rs_unsucccess_message_for_twitter_unfollow').parent().parent().hide();
        jQuery('#rs_send_mail_twitter_follow').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_twitter_follow').parent().parent().hide();
        jQuery('#rs_email_message_twitter_follow').parent().parent().hide();
    }

    jQuery('#rs_global_show_hide_twitter_follow_tweet_button').change(function () {
        if ((jQuery('#rs_global_show_hide_twitter_follow_tweet_button').val()) === '1') {
            jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').parent().parent().show();
            jQuery('#rs_global_social_twitter_profile_name').parent().parent().show();
            /*Show or Hide for Twitter Follow Tooltip - Start*/
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').val()) === '1') {
                jQuery('#rs_social_message_for_twitter_follow').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_twitter_follow').parent().parent().hide();
            }

            jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').change(function () {
                if ((jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').val()) === '1') {
                    jQuery('#rs_social_message_for_twitter_follow').parent().parent().show();
                } else {
                    jQuery('#rs_social_message_for_twitter_follow').parent().parent().hide();
                }
            });

            jQuery('#rs_send_mail_twitter_follow').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_twitter_follow').is(':checked') == true) {
                jQuery('#rs_email_subject_twitter_follow').parent().parent().show();
                jQuery('#rs_email_message_twitter_follow').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_twitter_follow').parent().parent().hide();
                jQuery('#rs_email_message_twitter_follow').parent().parent().hide();
            }

            jQuery('#rs_send_mail_twitter_follow').change(function () {
                if (jQuery('#rs_send_mail_twitter_follow').is(':checked') == true) {
                    jQuery('#rs_email_subject_twitter_follow').parent().parent().show();
                    jQuery('#rs_email_message_twitter_follow').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_twitter_follow').parent().parent().hide();
                    jQuery('#rs_email_message_twitter_follow').parent().parent().hide();
                }
            });
            /*Show or Hide for Twitter Follow Tooltip - End*/
            jQuery('#rs_succcess_message_for_twitter_follow').parent().parent().show();
            jQuery('#rs_unsucccess_message_for_twitter_unfollow').parent().parent().show();
        } else {
            jQuery('#rs_global_show_hide_social_tooltip_for_twitter_follow').parent().parent().hide();
            jQuery('#rs_global_social_twitter_profile_name').parent().parent().hide();
            jQuery('#rs_social_message_for_twitter_follow').parent().parent().hide();
            jQuery('#rs_succcess_message_for_twitter_follow').parent().parent().hide();
            jQuery('#rs_unsucccess_message_for_twitter_unfollow').parent().parent().hide();
            jQuery('#rs_send_mail_twitter_follow').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_twitter_follow').parent().parent().hide();
            jQuery('#rs_email_message_twitter_follow').parent().parent().hide();
        }
    });
    /*Show or Hide for Twitter Follow Section - End*/

    /*Show or Hide for Instagram Section - Start*/
    if ((jQuery('#rs_global_show_hide_instagram_button').val()) === '1') {
        jQuery('#rs_instagram_profile_name').parent().parent().show();
        jQuery('#rs_global_show_hide_social_tooltip_for_instagram').parent().parent().show();
        /*Show or Hide for Instagram Tooltip - Start*/
        if ((jQuery('#rs_global_show_hide_social_tooltip_for_instagram').val()) === '1') {
            jQuery('#rs_social_message_for_instagram').parent().parent().show();
        } else {
            jQuery('#rs_social_message_for_instagram').parent().parent().hide();
        }

        jQuery('#rs_global_show_hide_social_tooltip_for_instagram').change(function () {
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_instagram').val()) === '1') {
                jQuery('#rs_social_message_for_instagram').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_instagram').parent().parent().hide();
            }
        });

        jQuery('#rs_send_mail_instagram').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_instagram').is(':checked') == true) {
            jQuery('#rs_email_subject_instagram').parent().parent().show();
            jQuery('#rs_email_message_instagram').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_instagram').parent().parent().hide();
            jQuery('#rs_email_message_instagram').parent().parent().hide();
        }

        jQuery('#rs_send_mail_instagram').change(function () {
            if (jQuery('#rs_send_mail_instagram').is(':checked') == true) {
                jQuery('#rs_email_subject_instagram').parent().parent().show();
                jQuery('#rs_email_message_instagram').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_instagram').parent().parent().hide();
                jQuery('#rs_email_message_instagram').parent().parent().hide();
            }
        });
        /*Show or Hide for Instagram Tooltip - End*/
        jQuery('#rs_succcess_message_for_instagram').parent().parent().show();
        jQuery('#rs_unsucccess_message_for_instagram').parent().parent().show();
    } else {
        jQuery('#rs_instagram_profile_name').parent().parent().hide();
        jQuery('#rs_global_show_hide_social_tooltip_for_instagram').parent().parent().hide();
        jQuery('#rs_social_message_for_instagram').parent().parent().hide();
        jQuery('#rs_succcess_message_for_instagram').parent().parent().hide();
        jQuery('#rs_unsucccess_message_for_instagram').parent().parent().hide();
        jQuery('#rs_send_mail_instagram').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_instagram').parent().parent().hide();
        jQuery('#rs_email_message_instagram').parent().parent().hide();
    }

    jQuery('#rs_global_show_hide_instagram_button').change(function () {
        if ((jQuery('#rs_global_show_hide_instagram_button').val()) === '1') {
            jQuery('#rs_instagram_profile_name').parent().parent().show();
            jQuery('#rs_global_show_hide_social_tooltip_for_instagram').parent().parent().show();
            /*Show or Hide for Instagram Tooltip - Start*/
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_instagram').val()) === '1') {
                jQuery('#rs_social_message_for_instagram').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_instagram').parent().parent().hide();
            }

            jQuery('#rs_global_show_hide_social_tooltip_for_instagram').change(function () {
                if ((jQuery('#rs_global_show_hide_social_tooltip_for_instagram').val()) === '1') {
                    jQuery('#rs_social_message_for_instagram').parent().parent().show();
                } else {
                    jQuery('#rs_social_message_for_instagram').parent().parent().hide();
                }
            });
            jQuery('#rs_send_mail_instagram').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_instagram').is(':checked') == true) {
                jQuery('#rs_email_subject_instagram').parent().parent().show();
                jQuery('#rs_email_message_instagram').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_instagram').parent().parent().hide();
                jQuery('#rs_email_message_instagram').parent().parent().hide();
            }

            jQuery('#rs_send_mail_instagram').change(function () {
                if (jQuery('#rs_send_mail_instagram').is(':checked') == true) {
                    jQuery('#rs_email_subject_instagram').parent().parent().show();
                    jQuery('#rs_email_message_instagram').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_instagram').parent().parent().hide();
                    jQuery('#rs_email_message_instagram').parent().parent().hide();
                }
            });
            /*Show or Hide for Instagram Tooltip - End*/
            jQuery('#rs_succcess_message_for_instagram').parent().parent().show();
            jQuery('#rs_unsucccess_message_for_instagram').parent().parent().show();
        } else {
            jQuery('#rs_instagram_profile_name').parent().parent().hide();
            jQuery('#rs_global_show_hide_social_tooltip_for_instagram').parent().parent().hide();
            jQuery('#rs_social_message_for_instagram').parent().parent().hide();
            jQuery('#rs_succcess_message_for_instagram').parent().parent().hide();
            jQuery('#rs_unsucccess_message_for_instagram').parent().parent().hide();
            jQuery('#rs_send_mail_instagram').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_instagram').parent().parent().hide();
            jQuery('#rs_email_message_instagram').parent().parent().hide();
        }
    });
    /*Show or Hide for Instagram Section - End*/

    /*Show or Hide for VK.Com Section - Start*/
    if ((jQuery('#rs_global_show_hide_vk_button').val()) === '1') {
        jQuery('#rs_vk_application_id').parent().parent().show();
        jQuery('#rs_global_show_hide_social_tooltip_for_vk').parent().parent().show();

        /*Show or Hide for VK.Com Tooltip - Start*/
        if ((jQuery('#rs_global_show_hide_social_tooltip_for_vk').val()) === '1') {
            jQuery('#rs_social_message_for_vk').parent().parent().show();
        } else {
            jQuery('#rs_social_message_for_vk').parent().parent().hide();
        }

        jQuery('#rs_global_show_hide_social_tooltip_for_vk').change(function () {
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_vk').val()) === '1') {
                jQuery('#rs_social_message_for_vk').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_vk').parent().parent().hide();
            }
        });
        /*Show or Hide for VK.Com Tooltip - End*/

        jQuery('#rs_send_mail_vk').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_vk').is(':checked') == true) {
            jQuery('#rs_email_subject_vk').parent().parent().show();
            jQuery('#rs_email_message_vk').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_vk').parent().parent().hide();
            jQuery('#rs_email_message_vk').parent().parent().hide();
        }

        jQuery('#rs_send_mail_vk').change(function () {
            if (jQuery('#rs_send_mail_vk').is(':checked') == true) {
                jQuery('#rs_email_subject_vk').parent().parent().show();
                jQuery('#rs_email_message_vk').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_vk').parent().parent().hide();
                jQuery('#rs_email_message_vk').parent().parent().hide();
            }
        });
        jQuery('#rs_succcess_message_for_vk').parent().parent().show();
        jQuery('#rs_unsucccess_message_for_vk').parent().parent().show();
    } else {
        jQuery('#rs_vk_application_id').parent().parent().hide();
        jQuery('#rs_global_show_hide_social_tooltip_for_vk').parent().parent().hide();
        jQuery('#rs_social_message_for_vk').parent().parent().hide();
        jQuery('#rs_succcess_message_for_vk').parent().parent().hide();
        jQuery('#rs_unsucccess_message_for_vk').parent().parent().hide();
        jQuery('#rs_send_mail_vk').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_vk').parent().parent().hide();
        jQuery('#rs_email_message_vk').parent().parent().hide();
    }

    jQuery('#rs_global_show_hide_vk_button').change(function () {
        if ((jQuery('#rs_global_show_hide_vk_button').val()) === '1') {
            jQuery('#rs_vk_application_id').parent().parent().show();
            jQuery('#rs_global_show_hide_social_tooltip_for_vk').parent().parent().show();

            /*Show or Hide for VK.Com Tooltip - Start*/
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_vk').val()) === '1') {
                jQuery('#rs_social_message_for_vk').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_vk').parent().parent().hide();
            }

            jQuery('#rs_global_show_hide_social_tooltip_for_vk').change(function () {
                if ((jQuery('#rs_global_show_hide_social_tooltip_for_vk').val()) === '1') {
                    jQuery('#rs_social_message_for_vk').parent().parent().show();
                } else {
                    jQuery('#rs_social_message_for_vk').parent().parent().hide();
                }
            });
            /*Show or Hide for VK.Com Tooltip - End*/

            jQuery('#rs_send_mail_vk').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_vk').is(':checked') == true) {
                jQuery('#rs_email_subject_vk').parent().parent().show();
                jQuery('#rs_email_message_vk').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_vk').parent().parent().hide();
                jQuery('#rs_email_message_vk').parent().parent().hide();
            }

            jQuery('#rs_send_mail_vk').change(function () {
                if (jQuery('#rs_send_mail_vk').is(':checked') == true) {
                    jQuery('#rs_email_subject_vk').parent().parent().show();
                    jQuery('#rs_email_message_vk').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_vk').parent().parent().hide();
                    jQuery('#rs_email_message_vk').parent().parent().hide();
                }
            });
            jQuery('#rs_succcess_message_for_vk').parent().parent().show();
            jQuery('#rs_unsucccess_message_for_vk').parent().parent().show();
        } else {
            jQuery('#rs_vk_application_id').parent().parent().hide();
            jQuery('#rs_global_show_hide_social_tooltip_for_vk').parent().parent().hide();
            jQuery('#rs_social_message_for_vk').parent().parent().hide();
            jQuery('#rs_succcess_message_for_vk').parent().parent().hide();
            jQuery('#rs_unsucccess_message_for_vk').parent().parent().hide();
            jQuery('#rs_send_mail_vk').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_vk').parent().parent().hide();
            jQuery('#rs_email_message_vk').parent().parent().hide();
        }
    });
    /*Show or Hide for VK.Com Section - End*/

    /*Show or Hide for Google+1 Section - Start*/
    if ((jQuery('#rs_global_show_hide_google_plus_button').val()) === '1') {
        jQuery('#rs_global_social_google_url').parent().parent().show();
        jQuery('#rs_global_show_hide_social_tooltip_for_google').parent().parent().show();

        /*Show or Hide for Google+1 Custom URL - Start*/
        if ((jQuery('#rs_global_social_google_url').val()) === '2') {
            jQuery('#rs_global_social_google_url_custom').parent().parent().show();
        } else {
            jQuery('#rs_global_social_google_url_custom').parent().parent().hide();
        }

        jQuery('#rs_global_social_google_url').change(function () {
            if ((jQuery('#rs_global_social_google_url').val()) === '2') {
                jQuery('#rs_global_social_google_url_custom').parent().parent().show();
            } else {
                jQuery('#rs_global_social_google_url_custom').parent().parent().hide();
            }
        });
        /*Show or Hide for Google+1 Custom URL - End*/

        /*Show or Hide for Google+1 Tooltip - Start*/
        if ((jQuery('#rs_global_show_hide_social_tooltip_for_google').val()) === '1') {
            jQuery('#rs_social_message_for_google_plus').parent().parent().show();
        } else {
            jQuery('#rs_social_message_for_google_plus').parent().parent().hide();
        }

        jQuery('#rs_global_show_hide_social_tooltip_for_google').change(function () {
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_google').val()) === '1') {
                jQuery('#rs_social_message_for_google_plus').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_google_plus').parent().parent().hide();
            }
        });

        jQuery('#rs_send_mail_google').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_google').is(':checked') == true) {
            jQuery('#rs_email_subject_google').parent().parent().show();
            jQuery('#rs_email_message_google').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_google').parent().parent().hide();
            jQuery('#rs_email_message_google').parent().parent().hide();
        }

        jQuery('#rs_send_mail_google').change(function () {
            if (jQuery('#rs_send_mail_google').is(':checked') == true) {
                jQuery('#rs_email_subject_google').parent().parent().show();
                jQuery('#rs_email_message_google').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_google').parent().parent().hide();
                jQuery('#rs_email_message_google').parent().parent().hide();
            }
        });
        /*Show or Hide for Google+1 Tooltip - End*/
        jQuery('#rs_succcess_message_for_google_share').parent().parent().show();
        jQuery('#rs_unsucccess_message_for_google_unshare').parent().parent().show();
    } else {
        jQuery('#rs_global_social_google_url').parent().parent().hide();
        jQuery('#rs_global_social_google_url_custom').parent().parent().hide();
        jQuery('#rs_global_show_hide_social_tooltip_for_google').parent().parent().hide();
        jQuery('#rs_social_message_for_google_plus').parent().parent().hide();
        jQuery('#rs_succcess_message_for_google_share').parent().parent().hide();
        jQuery('#rs_unsucccess_message_for_google_unshare').parent().parent().hide();
        jQuery('#rs_send_mail_google').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_google').parent().parent().hide();
        jQuery('#rs_email_message_google').parent().parent().hide();
    }

    jQuery('#rs_global_show_hide_google_plus_button').change(function () {
        if ((jQuery('#rs_global_show_hide_google_plus_button').val()) === '1') {
            jQuery('#rs_global_social_google_url').parent().parent().show();
            jQuery('#rs_global_show_hide_social_tooltip_for_google').parent().parent().show();

            /*Show or Hide for Google+1 Custom URL - Start*/
            if ((jQuery('#rs_global_social_google_url').val()) === '2') {
                jQuery('#rs_global_social_google_url_custom').parent().parent().show();
            } else {
                jQuery('#rs_global_social_google_url_custom').parent().parent().hide();
            }

            jQuery('#rs_global_social_google_url').change(function () {
                if ((jQuery('#rs_global_social_google_url').val()) === '2') {
                    jQuery('#rs_global_social_google_url_custom').parent().parent().show();
                } else {
                    jQuery('#rs_global_social_google_url_custom').parent().parent().hide();
                }
            });
            /*Show or Hide for Google+1 Custom URL - End*/

            /*Show or Hide for Google+1 Tooltip - Start*/
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_google').val()) === '1') {
                jQuery('#rs_social_message_for_google_plus').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_google_plus').parent().parent().hide();
            }

            jQuery('#rs_global_show_hide_social_tooltip_for_google').change(function () {
                if ((jQuery('#rs_global_show_hide_social_tooltip_for_google').val()) === '1') {
                    jQuery('#rs_social_message_for_google_plus').parent().parent().show();
                } else {
                    jQuery('#rs_social_message_for_google_plus').parent().parent().hide();
                }
            });
            jQuery('#rs_send_mail_google').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_google').is(':checked') == true) {
                jQuery('#rs_email_subject_google').parent().parent().show();
                jQuery('#rs_email_message_google').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_google').parent().parent().hide();
                jQuery('#rs_email_message_google').parent().parent().hide();
            }

            jQuery('#rs_send_mail_google').change(function () {
                if (jQuery('#rs_send_mail_google').is(':checked') == true) {
                    jQuery('#rs_email_subject_google').parent().parent().show();
                    jQuery('#rs_email_message_google').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_google').parent().parent().hide();
                    jQuery('#rs_email_message_google').parent().parent().hide();
                }
            });
            /*Show or Hide for Google+1 Tooltip - End*/
            jQuery('#rs_succcess_message_for_google_share').parent().parent().show();
            jQuery('#rs_unsucccess_message_for_google_unshare').parent().parent().show();
        } else {
            jQuery('#rs_global_social_google_url').parent().parent().hide();
            jQuery('#rs_global_social_google_url_custom').parent().parent().hide();
            jQuery('#rs_global_show_hide_social_tooltip_for_google').parent().parent().hide();
            jQuery('#rs_social_message_for_google_plus').parent().parent().hide();
            jQuery('#rs_succcess_message_for_google_share').parent().parent().hide();
            jQuery('#rs_unsucccess_message_for_google_unshare').parent().parent().hide();
            jQuery('#rs_send_mail_google').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_google').parent().parent().hide();
            jQuery('#rs_email_message_google').parent().parent().hide();
        }
    });
    /*Show or Hide for Google+1 Section - End*/

    /*Show or Hide for OK.ru Section - Start*/
    if ((jQuery('#rs_global_show_hide_ok_button').val()) === '1') {
        jQuery('#rs_global_social_ok_url').parent().parent().show();
        jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').parent().parent().show();
        /*Show or Hide for Google+1 Custom URL - Start*/
        if ((jQuery('#rs_global_social_ok_url').val()) === '2') {
            jQuery('#rs_global_social_ok_url_custom').parent().parent().show();
        } else {
            jQuery('#rs_global_social_ok_url_custom').parent().parent().hide();
        }

        jQuery('#rs_global_social_ok_url').change(function () {
            if ((jQuery('#rs_global_social_ok_url').val()) === '2') {
                jQuery('#rs_global_social_ok_url_custom').parent().parent().show();
            } else {
                jQuery('#rs_global_social_ok_url_custom').parent().parent().hide();
            }
        });
        /*Show or Hide for Google+1 Custom URL - End*/

        /*Show or Hide for OK.ru Tooltip - Start*/
        if ((jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').val()) === '1') {
            jQuery('#rs_social_message_for_ok_follow').parent().parent().show();
        } else {
            jQuery('#rs_social_message_for_ok_follow').parent().parent().hide();
        }

        jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').change(function () {
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').val()) === '1') {
                jQuery('#rs_social_message_for_ok_follow').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_ok_follow').parent().parent().hide();
            }
        });

        jQuery('#rs_send_mail_ok').parent().parent().parent().parent().show();
        if (jQuery('#rs_send_mail_ok').is(':checked') == true) {
            jQuery('#rs_email_subject_ok').parent().parent().show();
            jQuery('#rs_email_message_ok').parent().parent().show();
        } else {
            jQuery('#rs_email_subject_ok').parent().parent().hide();
            jQuery('#rs_email_message_ok').parent().parent().hide();
        }

        jQuery('#rs_send_mail_ok').change(function () {
            if (jQuery('#rs_send_mail_ok').is(':checked') == true) {
                jQuery('#rs_email_subject_ok').parent().parent().show();
                jQuery('#rs_email_message_ok').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_ok').parent().parent().hide();
                jQuery('#rs_email_message_ok').parent().parent().hide();
            }
        });
        /*Show or Hide for OK.ru Tooltip - End*/
        jQuery('#rs_succcess_message_for_ok_follow').parent().parent().show();
        jQuery('#rs_unsucccess_message_for_ok_unfollow').parent().parent().show();
    } else {
        jQuery('#rs_global_social_ok_url').parent().parent().hide();
        jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').parent().parent().hide();
        jQuery('#rs_social_message_for_ok_follow').parent().parent().hide();
        jQuery('#rs_succcess_message_for_ok_follow').parent().parent().hide();
        jQuery('#rs_unsucccess_message_for_ok_unfollow').parent().parent().hide();
        jQuery('#rs_global_social_ok_url_custom').parent().parent().hide();
        jQuery('#rs_send_mail_ok').parent().parent().parent().parent().hide();
        jQuery('#rs_email_subject_ok').parent().parent().hide();
        jQuery('#rs_email_message_ok').parent().parent().hide();
    }

    jQuery('#rs_global_show_hide_ok_button').change(function () {
        if ((jQuery('#rs_global_show_hide_ok_button').val()) === '1') {
            jQuery('#rs_global_social_ok_url').parent().parent().show();
            jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').parent().parent().show();
            /*Show or Hide for Google+1 Custom URL - Start*/
            if ((jQuery('#rs_global_social_ok_url').val()) === '2') {
                jQuery('#rs_global_social_ok_url_custom').parent().parent().show();
            } else {
                jQuery('#rs_global_social_ok_url_custom').parent().parent().hide();
            }

            jQuery('#rs_global_social_ok_url').change(function () {
                if ((jQuery('#rs_global_social_ok_url').val()) === '2') {
                    jQuery('#rs_global_social_ok_url_custom').parent().parent().show();
                } else {
                    jQuery('#rs_global_social_ok_url_custom').parent().parent().hide();
                }
            });
            /*Show or Hide for Google+1 Custom URL - End*/

            /*Show or Hide for OK.ru Tooltip - Start*/
            if ((jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').val()) === '1') {
                jQuery('#rs_social_message_for_ok_follow').parent().parent().show();
            } else {
                jQuery('#rs_social_message_for_ok_follow').parent().parent().hide();
            }

            jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').change(function () {
                if ((jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').val()) === '1') {
                    jQuery('#rs_social_message_for_ok_follow').parent().parent().show();
                } else {
                    jQuery('#rs_social_message_for_ok_follow').parent().parent().hide();
                }
            });
            /*Show or Hide for OK.ru Tooltip - End*/
            jQuery('#rs_send_mail_ok').parent().parent().parent().parent().show();
            if (jQuery('#rs_send_mail_ok').is(':checked') == true) {
                jQuery('#rs_email_subject_ok').parent().parent().show();
                jQuery('#rs_email_message_ok').parent().parent().show();
            } else {
                jQuery('#rs_email_subject_ok').parent().parent().hide();
                jQuery('#rs_email_message_ok').parent().parent().hide();
            }

            jQuery('#rs_send_mail_ok').change(function () {
                if (jQuery('#rs_send_mail_ok').is(':checked') == true) {
                    jQuery('#rs_email_subject_ok').parent().parent().show();
                    jQuery('#rs_email_message_ok').parent().parent().show();
                } else {
                    jQuery('#rs_email_subject_ok').parent().parent().hide();
                    jQuery('#rs_email_message_ok').parent().parent().hide();
                }
            });
            jQuery('#rs_succcess_message_for_ok_follow').parent().parent().show();
            jQuery('#rs_unsucccess_message_for_ok_unfollow').parent().parent().show();
        } else {
            jQuery('#rs_global_social_ok_url').parent().parent().hide();
            jQuery('#rs_global_show_hide_social_tooltip_for_ok_follow').parent().parent().hide();
            jQuery('#rs_social_message_for_ok_follow').parent().parent().hide();
            jQuery('#rs_succcess_message_for_ok_follow').parent().parent().hide();
            jQuery('#rs_unsucccess_message_for_ok_unfollow').parent().parent().hide();
            jQuery('#rs_global_social_ok_url_custom').parent().parent().hide();
            jQuery('#rs_send_mail_ok').parent().parent().parent().parent().hide();
            jQuery('#rs_email_subject_ok').parent().parent().hide();
            jQuery('#rs_email_message_ok').parent().parent().hide();
        }
    });
    /*Show or Hide for OK.ru Section - End*/

    if (jQuery('#rs_global_social_enable_disable_reward').val() == '2') {
        jQuery('.show_if_social_tab_enable').parent().parent().hide();
    } else {
        jQuery('.show_if_social_tab_enable').parent().parent().show();
        /*Facebook Reward Type Validation in jQuery Start*/
        if ((jQuery('#rs_global_social_reward_type_facebook').val()) === '1') {
            jQuery('#rs_global_social_facebook_reward_points').parent().parent().show();
            jQuery('#rs_global_social_facebook_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_social_facebook_reward_points').parent().parent().hide();
            jQuery('#rs_global_social_facebook_reward_percent').parent().parent().show();
        }
        jQuery('#rs_global_social_reward_type_facebook').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_global_social_facebook_reward_points').parent().parent().show();
                jQuery('#rs_global_social_facebook_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_facebook_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_facebook_reward_percent').parent().parent().show();
            }
        });
        if ((jQuery('#rs_global_social_reward_type_facebook_share').val()) === '1') {
            jQuery('#rs_global_social_facebook_share_reward_points').parent().parent().show();
            jQuery('#rs_global_social_facebook_share_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_social_facebook_share_reward_points').parent().parent().hide();
            jQuery('#rs_global_social_facebook_share_reward_percent').parent().parent().show();
        }
        jQuery('#rs_global_social_reward_type_facebook_share').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_global_social_facebook_share_reward_points').parent().parent().show();
                jQuery('#rs_global_social_facebook_share_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_facebook_share_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_facebook_share_reward_percent').parent().parent().show();
            }
        });
        /*Facebook Reward Type Validation in jQuery Ends*/

        /*Twitter Reward Type Validation in jQuery Start*/
        if ((jQuery('#rs_global_social_reward_type_twitter').val()) === '1') {
            jQuery('#rs_global_social_twitter_reward_points').parent().parent().show();
            jQuery('#rs_global_social_twitter_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_social_twitter_reward_points').parent().parent().hide();
            jQuery('#rs_global_social_twitter_reward_percent').parent().parent().show();
        }
        jQuery('#rs_global_social_reward_type_twitter').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_global_social_twitter_reward_points').parent().parent().show();
                jQuery('#rs_global_social_twitter_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_twitter_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_twitter_reward_percent').parent().parent().show();
            }
        });

        /*Twitter Reward Type Validation in jQuery Ends*/
        if ((jQuery('#rs_global_social_reward_type_twitter_follow').val()) === '1') {
            jQuery('#rs_global_social_twitter_follow_reward_points').parent().parent().show();
            jQuery('#rs_global_social_twitter_follow_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_social_twitter_follow_reward_points').parent().parent().hide();
            jQuery('#rs_global_social_twitter_follow_reward_percent').parent().parent().show();
        }
        jQuery('#rs_global_social_reward_type_twitter_follow').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_global_social_twitter_follow_reward_points').parent().parent().show();
                jQuery('#rs_global_social_twitter_follow_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_twitter_follow_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_twitter_follow_reward_percent').parent().parent().show();
            }
        });

        /*ok.ru Reward Type Validation in jQuery Ends*/
        if ((jQuery('#rs_global_social_reward_type_ok_follow').val()) === '1') {
            jQuery('#rs_global_social_ok_follow_reward_points').parent().parent().show();
            jQuery('#rs_global_social_ok_follow_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_social_ok_follow_reward_points').parent().parent().hide();
            jQuery('#rs_global_social_ok_follow_reward_percent').parent().parent().show();
        }
        jQuery('#rs_global_social_reward_type_ok_follow').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_global_social_ok_follow_reward_points').parent().parent().show();
                jQuery('#rs_global_social_ok_follow_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_ok_follow_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_ok_follow_reward_percent').parent().parent().show();
            }
        });
        /*Google Reward Type Validation in jQuery Start*/
        if ((jQuery('#rs_global_social_reward_type_google').val()) === '1') {
            jQuery('#rs_global_social_google_reward_points').parent().parent().show();
            jQuery('#rs_global_social_google_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_social_google_reward_points').parent().parent().hide();
            jQuery('#rs_global_social_google_reward_percent').parent().parent().show();
        }
        jQuery('#rs_global_social_reward_type_google').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_global_social_google_reward_points').parent().parent().show();
                jQuery('#rs_global_social_google_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_google_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_google_reward_percent').parent().parent().show();
            }
        });
        /*Google Reward Type Validation in jQuery Ends*/

        /*VK Reward Type Validation in jQuery Start*/
        if ((jQuery('#rs_global_social_reward_type_vk').val()) === '1') {
            jQuery('#rs_global_social_vk_reward_points').parent().parent().show();
            jQuery('#rs_global_social_vk_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_social_vk_reward_points').parent().parent().hide();
            jQuery('#rs_global_social_vk_reward_percent').parent().parent().show();
        }
        jQuery('#rs_global_social_reward_type_vk').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_global_social_vk_reward_points').parent().parent().show();
                jQuery('#rs_global_social_vk_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_vk_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_vk_reward_percent').parent().parent().show();
            }
        });
        if ((jQuery('#rs_global_social_reward_type_instagram').val()) === '1') {
            jQuery('#rs_global_social_instagram_reward_points').parent().parent().show();
            jQuery('#rs_global_social_instagram_reward_percent').parent().parent().hide();
        } else {
            jQuery('#rs_global_social_instagram_reward_points').parent().parent().hide();
            jQuery('#rs_global_social_instagram_reward_percent').parent().parent().show();
        }
        jQuery('#rs_global_social_reward_type_instagram').change(function () {
            if ((jQuery(this).val()) === '1') {
                jQuery('#rs_global_social_instagram_reward_points').parent().parent().show();
                jQuery('#rs_global_social_instagram_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_instagram_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_instagram_reward_percent').parent().parent().show();
            }
        });
        /*VK Reward Type Validation in jQuery Ends*/

//        if (jQuery('#product-type').val() === 'variable') {
//            jQuery('._social_rewardsystem_options_facebook_field').css('display', 'none');
//            jQuery('._social_rewardsystem_options_facebook_share_field').css('display', 'none');
//            jQuery('._social_rewardsystem_options_twitter_field').css('display', 'none');
//            jQuery('._social_rewardsystem_options_google_field').css('display', 'none');
//        } else {
//            jQuery('._social_rewardsystem_options_facebook_field').css('display', 'block');
//            jQuery('._social_rewardsystem_options_facebook_share_field').css('display', 'block');
//            jQuery('._social_rewardsystem_options_twitter_field').css('display', 'block');
//            jQuery('._social_rewardsystem_options_google_field').css('display', 'block');
//        }
//        jQuery('#product-type').change(function () {
//            if (jQuery(this).val() === 'variable') {
//                jQuery('._social_rewardsystem_options_facebook_field').css('display', 'none');
//                jQuery('._social_rewardsystem_options_facebook_share_field').css('display', 'none');
//
//                jQuery('._social_rewardsystem_options_twitter_field').css('display', 'none');
//                jQuery('._social_rewardsystem_options_google_field').css('display', 'none');
//            } else {
//                jQuery('._social_rewardsystem_options_facebook_field').css('display', 'block');
//                jQuery('._social_rewardsystem_options_facebook_share_field').css('display', 'block');
//                jQuery('._social_rewardsystem_options_twitter_field').css('display', 'block');
//                jQuery('._social_rewardsystem_options_google_field').css('display', 'block');
//            }
//        });
    }

    jQuery('#rs_global_social_enable_disable_reward').change(function () {
        if (jQuery('#rs_global_social_enable_disable_reward').val() == '2') {
            jQuery('.show_if_social_tab_enable').parent().parent().hide();
        } else {
            jQuery('.show_if_social_tab_enable').parent().parent().show();
            /*Facebook Reward Type Validation in jQuery Start*/
            if ((jQuery('#rs_global_social_reward_type_facebook').val()) === '1') {
                jQuery('#rs_global_social_facebook_reward_points').parent().parent().show();
                jQuery('#rs_global_social_facebook_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_facebook_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_facebook_reward_percent').parent().parent().show();
            }
            jQuery('#rs_global_social_reward_type_facebook').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_global_social_facebook_reward_points').parent().parent().show();
                    jQuery('#rs_global_social_facebook_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_social_facebook_reward_points').parent().parent().hide();
                    jQuery('#rs_global_social_facebook_reward_percent').parent().parent().show();
                }
            });

            if ((jQuery('#rs_global_social_reward_type_facebook_share').val()) === '1') {
                jQuery('#rs_global_social_facebook_share_reward_points').parent().parent().show();
                jQuery('#rs_global_social_facebook_share_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_facebook_share_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_facebook_share_reward_percent').parent().parent().show();
            }
            jQuery('#rs_global_social_reward_type_facebook_share').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_global_social_facebook_share_reward_points').parent().parent().show();
                    jQuery('#rs_global_social_facebook_share_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_social_facebook_share_reward_points').parent().parent().hide();
                    jQuery('#rs_global_social_facebook_share_reward_percent').parent().parent().show();
                }
            });
            /*Facebook Reward Type Validation in jQuery Ends*/

            /*Twitter Reward Type Validation in jQuery Start*/
            if ((jQuery('#rs_global_social_reward_type_twitter').val()) === '1') {
                jQuery('#rs_global_social_twitter_reward_points').parent().parent().show();
                jQuery('#rs_global_social_twitter_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_twitter_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_twitter_reward_percent').parent().parent().show();
            }
            jQuery('#rs_global_social_reward_type_twitter').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_global_social_twitter_reward_points').parent().parent().show();
                    jQuery('#rs_global_social_twitter_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_social_twitter_reward_points').parent().parent().hide();
                    jQuery('#rs_global_social_twitter_reward_percent').parent().parent().show();
                }
            });
            /*Twitter Reward Type Validation in jQuery Ends*/
            if ((jQuery('#rs_global_social_reward_type_twitter_follow').val()) === '1') {
                jQuery('#rs_global_social_twitter_follow_reward_points').parent().parent().show();
                jQuery('#rs_global_social_twitter_follow_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_twitter_follow_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_twitter_follow_reward_percent').parent().parent().show();
            }
            jQuery('#rs_global_social_reward_type_twitter_follow').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_global_social_twitte_follow_reward_points').parent().parent().show();
                    jQuery('#rs_global_social_twitter_follow_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_social_twitter_follow_reward_points').parent().parent().hide();
                    jQuery('#rs_global_social_twitter_follow_reward_percent').parent().parent().show();
                }
            });

            /*OK.ru Reward Type Validation in jQuery Ends*/
            if ((jQuery('#rs_global_social_reward_type_ok_follow').val()) === '1') {
                jQuery('#rs_global_social_ok_follow_reward_points').parent().parent().show();
                jQuery('#rs_global_social_ok_follow_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_ok_follow_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_ok_follow_reward_percent').parent().parent().show();
            }
            jQuery('#rs_global_social_reward_type_ok_follow').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_global_social_ok_follow_reward_points').parent().parent().show();
                    jQuery('#rs_global_social_ok_follow_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_social_ok_follow_reward_points').parent().parent().hide();
                    jQuery('#rs_global_social_ok_follow_reward_percent').parent().parent().show();
                }
            });
            /*Google Reward Type Validation in jQuery Start*/
            if ((jQuery('#rs_global_social_reward_type_google').val()) === '1') {
                jQuery('#rs_global_social_google_reward_points').parent().parent().show();
                jQuery('#rs_global_social_google_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_google_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_google_reward_percent').parent().parent().show();
            }
            jQuery('#rs_global_social_reward_type_google').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_global_social_google_reward_points').parent().parent().show();
                    jQuery('#rs_global_social_google_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_social_google_reward_points').parent().parent().hide();
                    jQuery('#rs_global_social_google_reward_percent').parent().parent().show();
                }
            });
            /*Google Reward Type Validation in jQuery Ends*/

            /*VK Reward Type Validation in jQuery Start*/
            if ((jQuery('#rs_global_social_reward_type_vk').val()) === '1') {
                jQuery('#rs_global_social_vk_reward_points').parent().parent().show();
                jQuery('#rs_global_social_vk_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_vk_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_vk_reward_percent').parent().parent().show();
            }
            jQuery('#rs_global_social_reward_type_vk').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_global_social_vk_reward_points').parent().parent().show();
                    jQuery('#rs_global_social_vk_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_social_vk_reward_points').parent().parent().hide();
                    jQuery('#rs_global_social_vk_reward_percent').parent().parent().show();
                }
            });
            /*VK Reward Type Validation in jQuery Ends*/
            if ((jQuery('#rs_global_social_reward_type_instagram').val()) === '1') {
                jQuery('#rs_global_social_instagram_reward_points').parent().parent().show();
                jQuery('#rs_global_social_instagram_reward_percent').parent().parent().hide();
            } else {
                jQuery('#rs_global_social_instagram_reward_points').parent().parent().hide();
                jQuery('#rs_global_social_instagram_reward_percent').parent().parent().show();
            }
            jQuery('#rs_global_social_reward_type_instagram').change(function () {
                if ((jQuery(this).val()) === '1') {
                    jQuery('#rs_global_social_instagram_reward_points').parent().parent().show();
                    jQuery('#rs_global_social_instagram_reward_percent').parent().parent().hide();
                } else {
                    jQuery('#rs_global_social_instagram_reward_points').parent().parent().hide();
                    jQuery('#rs_global_social_instagram_reward_percent').parent().parent().show();
                }
            });

            if (jQuery('#product-type').val() === 'variable') {
                jQuery('._social_rewardsystem_options_facebook_field').css('display', 'none');
                jQuery('._social_rewardsystem_options_facebook_share_field').css('display', 'none');
                jQuery('._social_rewardsystem_options_twitter_field').css('display', 'none');
                jQuery('._social_rewardsystem_options_twitter_field_follow').css('display', 'none');


                jQuery('._social_rewardsystem_options_google_field').css('display', 'none');
            } else {
                jQuery('._social_rewardsystem_options_facebook_field').css('display', 'block');
                jQuery('._social_rewardsystem_options_facebook_share_field').css('display', 'block');
                jQuery('._social_rewardsystem_options_twitter_field').css('display', 'block');
                jQuery('._social_rewardsystem_options_twitter_field_follow').css('display', 'block');

                jQuery('._social_rewardsystem_options_google_field').css('display', 'block');
            }
            jQuery('#product-type').change(function () {
                if (jQuery(this).val() === 'variable') {
                    jQuery('._social_rewardsystem_options_facebook_field').css('display', 'none');
                    jQuery('._social_rewardsystem_options_facebook_share_field').css('display', 'none');
                    jQuery('._social_rewardsystem_options_twitter_field').css('display', 'none');
                    jQuery('._social_rewardsystem_options_twitter_field_follow').css('display', 'none');

                    jQuery('._social_rewardsystem_options_google_field').css('display', 'none');
                } else {
                    jQuery('._social_rewardsystem_options_facebook_field').css('display', 'block');
                    jQuery('._social_rewardsystem_options_facebook_share_field').css('display', 'block');
                    jQuery('._social_rewardsystem_options_twitter_field').css('display', 'block');
                    jQuery('._social_rewardsystem_options_twitter_field_follow').css('display', 'block');

                    jQuery('._social_rewardsystem_options_google_field').css('display', 'block');
                }

            });
        }
    });
    /*Show or hide Settings for Social Reward Tab - End*/

    /*Show or hide Settings for SMS Tab - Start*/

    if ((jQuery('input[name=rs_sms_sending_api_option]:checked').val()) === '1') {
        jQuery('#rs_nexmo_key').parent().parent().hide();
        jQuery('#rs_nexmo_secret').parent().parent().hide();
        jQuery('#rs_twilio_secret_account_id').parent().parent().show();
        jQuery('#rs_twilio_auth_token_id').parent().parent().show();
        jQuery('#rs_twilio_from_number').parent().parent().show();
    } else {
        jQuery('#rs_nexmo_key').parent().parent().show();
        jQuery('#rs_nexmo_secret').parent().parent().show();
        jQuery('#rs_twilio_secret_account_id').parent().parent().hide();
        jQuery('#rs_twilio_auth_token_id').parent().parent().hide();
        jQuery('#rs_twilio_from_number').parent().parent().hide();
    }
    jQuery('input[name=rs_sms_sending_api_option]:radio').change(function () {
        if ((jQuery('input[name=rs_sms_sending_api_option]:checked').val()) === '1') {
            jQuery('#rs_nexmo_key').parent().parent().hide();
            jQuery('#rs_nexmo_secret').parent().parent().hide();
            jQuery('#rs_twilio_secret_account_id').parent().parent().show();
            jQuery('#rs_twilio_auth_token_id').parent().parent().show();
            jQuery('#rs_twilio_from_number').parent().parent().show();
        } else {
            jQuery('#rs_nexmo_key').parent().parent().show();
            jQuery('#rs_nexmo_secret').parent().parent().show();
            jQuery('#rs_twilio_secret_account_id').parent().parent().toggle();
            jQuery('#rs_twilio_auth_token_id').parent().parent().toggle();
            jQuery('#rs_twilio_from_number').parent().parent().toggle();
        }
    });

    /*Show or hide Settings for SMS Tab - End*/

    /*Show or hide Settings for Order Tab - Start*/

    if (jQuery('#rs_enable_msg_for_earned_points').is(":checked")) {
        jQuery('#rs_msg_for_earned_points').parent().parent().show();
    } else {
        jQuery('#rs_msg_for_earned_points').parent().parent().hide();
    }

    jQuery('#rs_enable_msg_for_earned_points').change(function () {
        if (jQuery('#rs_enable_msg_for_earned_points').is(":checked")) {
            jQuery('#rs_msg_for_earned_points').parent().parent().show();
        } else {
            jQuery('#rs_msg_for_earned_points').parent().parent().hide();
        }
    });

    if (jQuery('#rs_enable_msg_for_redeem_points').is(":checked")) {
        jQuery('#rs_msg_for_redeem_points').parent().parent().show();
    } else {
        jQuery('#rs_msg_for_redeem_points').parent().parent().hide();
    }

    jQuery('#rs_enable_msg_for_redeem_points').change(function () {
        if (jQuery('#rs_enable_msg_for_redeem_points').is(":checked")) {
            jQuery('#rs_msg_for_redeem_points').parent().parent().show();
        } else {
            jQuery('#rs_msg_for_redeem_points').parent().parent().hide();
        }
    });

    /*Show or hide Settings for Order Tab - End*/

    /*Show or hide Settings for Import/Export Tab - Start*/

    if ((jQuery('input[name=rs_export_import_user_option]:checked').val()) === '2') {
        jQuery('#rs_import_export_users_list').parent().parent().show();
    } else {
        jQuery('#rs_import_export_users_list').parent().parent().hide();
    }
    jQuery('input[name=rs_export_import_user_option]:radio').change(function () {
        jQuery('#rs_import_export_users_list').parent().parent().toggle();
    });

    if ((jQuery('input[name=rs_export_import_date_option]:checked').val()) === '2') {
        jQuery('#rs_point_export_start_date').parent().parent().show();
        jQuery('#rs_point_export_end_date').parent().parent().show();
    } else {
        jQuery('#rs_point_export_start_date').parent().parent().hide();
        jQuery('#rs_point_export_end_date').parent().parent().hide();
    }
    jQuery('input[name=rs_export_import_date_option]:radio').change(function () {
        jQuery('#rs_point_export_start_date').parent().parent().toggle();
        jQuery('#rs_point_export_end_date').parent().parent().toggle();
    });

    /*Show or hide Settings for Import/Export Tab - End*/

    /*Show or hide Settings for Report in CSV Tab - Start*/

    if ((jQuery('input[name=rs_export_user_report_option]:checked').val()) === '2') {
        jQuery('#rs_export_users_report_list').parent().parent().show();
    } else {
        jQuery('#rs_export_users_report_list').parent().parent().hide();
    }
    jQuery('input[name=rs_export_user_report_option]:radio').change(function () {
        jQuery('#rs_export_users_report_list').parent().parent().toggle();
    });

    if ((jQuery('input[name=rs_export_report_date_option]:checked').val()) === '2') {
        jQuery('#rs_point_export_report_start_date').parent().parent().show();
        jQuery('#rs_point_export_report_end_date').parent().parent().show();
    } else {
        jQuery('#rs_point_export_report_start_date').parent().parent().hide();
        jQuery('#rs_point_export_report_end_date').parent().parent().hide();
    }
    jQuery('input[name=rs_export_report_date_option]:radio').change(function () {
        jQuery('#rs_point_export_report_start_date').parent().parent().toggle();
        jQuery('#rs_point_export_report_end_date').parent().parent().toggle();
    });

    /*Show or hide Settings for Report in CSV Tab - End*/

    /*Show or hide Settings for Form for Send Points Tab - Start*/
    if (jQuery('#rs_enable_msg_for_send_point').val() == '1') {
        jQuery('#rs_select_send_points_user_type').closest('tr').show();
        /*Show or Hide for User Selection - Start*/
        if (jQuery('#rs_select_send_points_user_type').val() == '1') {
            jQuery('#rs_select_users_list_for_send_point').parent().parent().hide();
        }
        jQuery('#rs_select_send_points_user_type').change(function () {
            if (jQuery(this).val() == '2') {
                jQuery('#rs_select_users_list_for_send_point').parent().parent().show();
            } else {
                jQuery('#rs_select_users_list_for_send_point').parent().parent().hide();
            }
        });
        /*Show or Hide for User Selection - End*/
        jQuery('#rs_total_send_points_request').closest('tr').show();
        jQuery('#rs_points_to_send_request').closest('tr').show();
        jQuery('#rs_select_user_label').closest('tr').show();
        jQuery('#rs_select_user_placeholder').closest('tr').show();
        jQuery('#rs_select_points_submit_label').closest('tr').show();
        jQuery('#rs_request_approval_type').closest('tr').show();
        jQuery('#rs_limit_for_send_point').closest('tr').show();

        /*Show or Hide for Maximum Restriction Points to Send - Start*/
        if (jQuery('#rs_limit_for_send_point').val() == '1') {
            jQuery('#rs_limit_send_points_request').parent().parent().show();
            jQuery('#rs_err_when_point_greater_than_limit').parent().parent().show();
        } else {
            jQuery('#rs_limit_send_points_request').parent().parent().hide();
            jQuery('#rs_err_when_point_greater_than_limit').parent().parent().hide();
        }
        jQuery('#rs_limit_for_send_point').change(function () {
            if (jQuery(this).val() == '1') {
                jQuery('#rs_limit_send_points_request').parent().parent().show();
                jQuery('#rs_err_when_point_greater_than_limit').parent().parent().show();
            } else {
                jQuery('#rs_limit_send_points_request').parent().parent().hide();
                jQuery('#rs_err_when_point_greater_than_limit').parent().parent().hide();
            }
        });
        /*Show or Hide for Maximum Restriction Points to Send - End*/
        jQuery('#rs_request_approval_type').closest('tr').show();

        /*Show or Hide for Approval Type - Start*/
        if (jQuery('#rs_request_approval_type').val() == '1') {
            jQuery('#rs_message_send_point_request_submitted').parent().parent().show();
            jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().hide();
        } else {
            jQuery('#rs_message_send_point_request_submitted').parent().parent().hide();
            jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().show();
        }
        jQuery('#rs_request_approval_type').change(function () {
            if (jQuery('#rs_request_approval_type').val() == '1') {
                jQuery('#rs_message_send_point_request_submitted').parent().parent().show();
                jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().hide();
            } else {
                jQuery('#rs_message_send_point_request_submitted').parent().parent().hide();
                jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().show();
            }
        });
        /*Show or Hide for Approval Type - End*/

    } else {
        jQuery('#rs_select_send_points_user_type').closest('tr').hide();
        jQuery('#rs_select_users_list_for_send_point').parent().parent().hide();
        jQuery('#rs_total_send_points_request').closest('tr').hide();
        jQuery('#rs_points_to_send_request').closest('tr').hide();
        jQuery('#rs_select_user_label').closest('tr').hide();
        jQuery('#rs_select_user_placeholder').closest('tr').hide();
        jQuery('#rs_select_points_submit_label').closest('tr').hide();
        jQuery('#rs_request_approval_type').closest('tr').hide();
        jQuery('#rs_limit_for_send_point').closest('tr').hide();
        jQuery('#rs_limit_send_points_request').parent().parent().hide();
        jQuery('#rs_err_when_point_greater_than_limit').parent().parent().hide();
        jQuery('#rs_request_approval_type').closest('tr').hide();
        jQuery('#rs_message_send_point_request_submitted').parent().parent().hide();
        jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().hide();
    }

    jQuery('#rs_enable_msg_for_send_point').change(function () {
        if (jQuery('#rs_enable_msg_for_send_point').val() == '1') {
            jQuery('#rs_select_send_points_user_type').closest('tr').show();

            /*Show or Hide for User Selection - Start*/
            if (jQuery('#rs_select_send_points_user_type').val() == '1') {
                jQuery('#rs_select_users_list_for_send_point').parent().parent().hide();
            } else {
                jQuery('#rs_select_users_list_for_send_point').parent().parent().show();
            }
            jQuery('#rs_select_send_points_user_type').change(function () {
                if (jQuery(this).val() == '2') {
                    jQuery('#rs_select_users_list_for_send_point').parent().parent().show();
                } else {
                    jQuery('#rs_select_users_list_for_send_point').parent().parent().hide();
                }
            });
            /*Show or Hide for User Selection - End*/
            jQuery('#rs_total_send_points_request').closest('tr').show();
            jQuery('#rs_points_to_send_request').closest('tr').show();
            jQuery('#rs_select_user_label').closest('tr').show();
            jQuery('#rs_select_user_placeholder').closest('tr').show();
            jQuery('#rs_select_points_submit_label').closest('tr').show();
            jQuery('#rs_request_approval_type').closest('tr').show();
            jQuery('#rs_limit_for_send_point').closest('tr').show();

            /*Show or Hide for Maximum Restriction Points to Send - Start*/
            if (jQuery('#rs_limit_for_send_point').val() == '1') {
                jQuery('#rs_limit_send_points_request').parent().parent().show();
                jQuery('#rs_err_when_point_greater_than_limit').parent().parent().show();
            } else {
                jQuery('#rs_limit_send_points_request').parent().parent().hide();
                jQuery('#rs_err_when_point_greater_than_limit').parent().parent().hide();
            }
            jQuery('#rs_limit_for_send_point').change(function () {
                if (jQuery(this).val() == '1') {
                    jQuery('#rs_limit_send_points_request').parent().parent().show();
                    jQuery('#rs_err_when_point_greater_than_limit').parent().parent().show();
                } else {
                    jQuery('#rs_limit_send_points_request').parent().parent().hide();
                    jQuery('#rs_err_when_point_greater_than_limit').parent().parent().hide();
                }
            });
            /*Show or Hide for Maximum Restriction Points to Send - End*/
            jQuery('#rs_request_approval_type').closest('tr').show();

            /*Show or Hide for Approval Type - Start*/
            if (jQuery('#rs_request_approval_type').val() == '1') {
                jQuery('#rs_message_send_point_request_submitted').parent().parent().show();
                jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().hide();
            } else {
                jQuery('#rs_message_send_point_request_submitted').parent().parent().hide();
                jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().show();
            }
            jQuery('#rs_request_approval_type').change(function () {
                if (jQuery('#rs_request_approval_type').val() == '1') {
                    jQuery('#rs_message_send_point_request_submitted').parent().parent().show();
                    jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().hide();
                } else {
                    jQuery('#rs_message_send_point_request_submitted').parent().parent().hide();
                    jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().show();
                }
            });
            /*Show or Hide for Approval Type - End*/

        } else {
            jQuery('#rs_select_send_points_user_type').closest('tr').hide();
            jQuery('#rs_select_users_list_for_send_point').parent().parent().hide();
            jQuery('#rs_total_send_points_request').closest('tr').hide();
            jQuery('#rs_points_to_send_request').closest('tr').hide();
            jQuery('#rs_select_user_label').closest('tr').hide();
            jQuery('#rs_select_user_placeholder').closest('tr').hide();
            jQuery('#rs_select_points_submit_label').closest('tr').hide();
            jQuery('#rs_request_approval_type').closest('tr').hide();
            jQuery('#rs_limit_for_send_point').closest('tr').hide();
            jQuery('#rs_limit_send_points_request').parent().parent().hide();
            jQuery('#rs_err_when_point_greater_than_limit').parent().parent().hide();
            jQuery('#rs_request_approval_type').closest('tr').hide();
            jQuery('#rs_message_send_point_request_submitted').parent().parent().hide();
            jQuery('#rs_message_send_point_request_submitted_for_auto').parent().parent().hide();
        }
    });

    /*Show or hide Settings for Form for Send Points Tab - End*/

    /*Show or hide Settings for Nominee Tab - Start*/

    var currentvalue = jQuery('#rs_show_hide_nominee_field').val();
    if (currentvalue == '1') {
        jQuery('#rs_my_nominee_title').parent().parent().show();
        jQuery('#rs_select_type_of_user_for_nominee').parent().parent().show();
        jQuery('#rs_select_type_of_user_for_nominee_name').parent().parent().show();

        if (jQuery('#rs_select_type_of_user_for_nominee').val() == '1') {
            jQuery('#rs_select_users_list_for_nominee').parent().parent().show();
            jQuery('#rs_select_users_role_for_nominee').parent().parent().hide();
        } else {
            jQuery('#rs_select_users_list_for_nominee').parent().parent().hide();
            jQuery('#rs_select_users_role_for_nominee').parent().parent().show();
        }

        jQuery('#rs_select_type_of_user_for_nominee').change(function () {
            if (jQuery('#rs_select_type_of_user_for_nominee').val() == '1') {
                jQuery('#rs_select_users_list_for_nominee').parent().parent().show();
                jQuery('#rs_select_users_role_for_nominee').parent().parent().hide();
            } else {
                jQuery('#rs_select_users_list_for_nominee').parent().parent().hide();
                jQuery('#rs_select_users_role_for_nominee').parent().parent().show();
            }
        });
    } else {
        jQuery('#rs_my_nominee_title').parent().parent().hide();
        jQuery('#rs_select_type_of_user_for_nominee').parent().parent().hide();
        jQuery('#rs_select_users_list_for_nominee').parent().parent().hide();
        jQuery('#rs_select_users_role_for_nominee').parent().parent().hide();
        jQuery('#rs_select_type_of_user_for_nominee_name').parent().parent().hide();
    }

    jQuery('#rs_show_hide_nominee_field').change(function () {
        var currentvalue = jQuery('#rs_show_hide_nominee_field').val();
        if (currentvalue == '1') {
            jQuery('#rs_my_nominee_title').parent().parent().show();
            jQuery('#rs_select_type_of_user_for_nominee').parent().parent().show();
            jQuery('#rs_select_type_of_user_for_nominee_name').parent().parent().show();

            if (jQuery('#rs_select_type_of_user_for_nominee').val() == '1') {
                jQuery('#rs_select_users_list_for_nominee').parent().parent().show();
                jQuery('#rs_select_users_role_for_nominee').parent().parent().hide();
            } else {
                jQuery('#rs_select_users_list_for_nominee').parent().parent().hide();
                jQuery('#rs_select_users_role_for_nominee').parent().parent().show();
            }

            jQuery('#rs_select_type_of_user_for_nominee').change(function () {
                if (jQuery('#rs_select_type_of_user_for_nominee').val() == '1') {
                    jQuery('#rs_select_users_list_for_nominee').parent().parent().show();
                    jQuery('#rs_select_users_role_for_nominee').parent().parent().hide();
                } else {
                    jQuery('#rs_select_users_list_for_nominee').parent().parent().hide();
                    jQuery('#rs_select_users_role_for_nominee').parent().parent().show();
                }
            });
        } else {
            jQuery('#rs_my_nominee_title').parent().parent().hide();
            jQuery('#rs_select_type_of_user_for_nominee').parent().parent().hide();
            jQuery('#rs_select_users_list_for_nominee').parent().parent().hide();
            jQuery('#rs_select_users_role_for_nominee').parent().parent().hide();
            jQuery('#rs_select_type_of_user_for_nominee_name').parent().parent().hide();
        }
    });


    var currentvalue = jQuery('#rs_show_hide_nominee_field_shortcode').val();
    if (currentvalue == '1') {
        jQuery('#rs_my_nominee_title_shortcode').parent().parent().show();
        jQuery('#rs_select_type_of_user_for_nominee_shortcode').parent().parent().show();
        jQuery('#rs_select_type_of_user_for_nominee_name_shortcode').parent().parent().show();

        if (jQuery('#rs_select_type_of_user_for_nominee_shortcode').val() == '1') {
            jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().show();
            jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().hide();
        } else {
            jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().hide();
            jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().show();
        }

        jQuery('#rs_select_type_of_user_for_nominee_shortcode').change(function () {
            if (jQuery('#rs_select_type_of_user_for_nominee_shortcode').val() == '1') {
                jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().show();
                jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().hide();
            } else {
                jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().hide();
                jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().show();
            }
        });
    } else {
        jQuery('#rs_my_nominee_title_shortcode').parent().parent().hide();
        jQuery('#rs_select_type_of_user_for_nominee_shortcode').parent().parent().hide();
        jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().hide();
        jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().hide();
        jQuery('#rs_select_type_of_user_for_nominee_name_shortcode').parent().parent().hide();
    }

    jQuery('#rs_show_hide_nominee_field_shortcode').change(function () {
        var currentvalue = jQuery('#rs_show_hide_nominee_field_shortcode').val();
        if (currentvalue == '1') {
            jQuery('#rs_my_nominee_title_shortcode').parent().parent().show();
            jQuery('#rs_select_type_of_user_for_nominee_shortcode').parent().parent().show();
            jQuery('#rs_select_type_of_user_for_nominee_name_shortcode').parent().parent().show();

            if (jQuery('#rs_select_type_of_user_for_nominee_shortcode').val() == '1') {
                jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().show();
                jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().hide();
            } else {
                jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().hide();
                jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().show();
            }

            jQuery('#rs_select_type_of_user_for_nominee_shortcode').change(function () {
                if (jQuery('#rs_select_type_of_user_for_nominee_shortcode').val() == '1') {
                    jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().show();
                    jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().hide();
                } else {
                    jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().hide();
                    jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().show();
                }
            });
        } else {
            jQuery('#rs_my_nominee_title_shortcode').parent().parent().hide();
            jQuery('#rs_select_type_of_user_for_nominee_shortcode').parent().parent().hide();
            jQuery('#rs_select_users_list_for_nominee_shortcode').parent().parent().hide();
            jQuery('#rs_select_users_role_for_nominee_shortcode').parent().parent().hide();
            jQuery('#rs_select_type_of_user_for_nominee_name_shortcode').parent().parent().hide();
        }
    });



    var currentvalues = jQuery('#rs_show_hide_nominee_field_in_checkout').val();
    if (currentvalues == '1') {
        jQuery('#rs_my_nominee_title_in_checkout').parent().parent().show();
        jQuery('#rs_select_type_of_user_for_nominee_checkout').parent().parent().show();
        jQuery('#rs_select_type_of_user_for_nominee_name_checkout').parent().parent().show();

        if (jQuery('#rs_select_type_of_user_for_nominee_checkout').val() == '1') {
            jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().show();
            jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().hide();
        } else {
            jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().hide();
            jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().show();
        }

        jQuery('#rs_select_type_of_user_for_nominee_checkout').change(function () {
            if (jQuery('#rs_select_type_of_user_for_nominee_checkout').val() == '1') {
                jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().show();
                jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().hide();
            } else {
                jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().hide();
                jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().show();
            }
        });
    } else {
        jQuery('#rs_my_nominee_title_in_checkout').parent().parent().hide();
        jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().hide();
        jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().hide();
        jQuery('#rs_select_type_of_user_for_nominee_checkout').parent().parent().hide();
        jQuery('#rs_select_type_of_user_for_nominee_name_checkout').parent().parent().hide();
    }

    jQuery('#rs_show_hide_nominee_field_in_checkout').change(function () {
        var currentvalues = jQuery('#rs_show_hide_nominee_field_in_checkout').val();
        if (currentvalues == '1') {
            jQuery('#rs_my_nominee_title_in_checkout').parent().parent().show();
            jQuery('#rs_select_type_of_user_for_nominee_checkout').parent().parent().show();
            jQuery('#rs_select_type_of_user_for_nominee_name_checkout').parent().parent().show();

            if (jQuery('#rs_select_type_of_user_for_nominee_checkout').val() == '1') {
                jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().show();
                jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().hide();
            } else {
                jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().hide();
                jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().show();
            }

            jQuery('#rs_select_type_of_user_for_nominee_checkout').change(function () {
                if (jQuery('#rs_select_type_of_user_for_nominee_checkout').val() == '1') {
                    jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().show();
                    jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().hide();
                } else {
                    jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().hide();
                    jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().show();
                }
            });
        } else {
            jQuery('#rs_my_nominee_title_in_checkout').parent().parent().hide();
            jQuery('#rs_select_users_list_for_nominee_in_checkout').parent().parent().hide();
            jQuery('#rs_select_users_role_for_nominee_checkout').parent().parent().hide();
            jQuery('#rs_select_type_of_user_for_nominee_checkout').parent().parent().hide();
            jQuery('#rs_select_type_of_user_for_nominee_name_checkout').parent().parent().hide();
        }
    });

    /*Show or hide Settings for Nominee Tab - End*/

    /*Show or hide Settings for Point URL Tab - Start*/

    jQuery('#rs_expiry_time_for_pointurl').datepicker({dateFormat: 'yy-mm-dd', minDate: 0});
    if (jQuery('#rs_time_limit_for_pointurl').val() == '1') {
        jQuery('#rs_expiry_time_for_pointurl').parent().parent().hide();
    } else {
        jQuery('#rs_expiry_time_for_pointurl').parent().parent().show();
    }

    jQuery('#rs_time_limit_for_pointurl').change(function () {
        if (jQuery('#rs_time_limit_for_pointurl').val() == '1') {
            jQuery('#rs_expiry_time_for_pointurl').parent().parent().hide();
        } else {
            jQuery('#rs_expiry_time_for_pointurl').parent().parent().show();
        }
    });

    if (jQuery('#rs_count_limit_for_pointurl').val() == '1') {
        jQuery('#rs_count_for_pointurl').parent().parent().hide();
    } else {
        jQuery('#rs_count_for_pointurl').parent().parent().show();
    }

    jQuery('#rs_count_limit_for_pointurl').change(function () {
        if (jQuery('#rs_count_limit_for_pointurl').val() == '1') {
            jQuery('#rs_count_for_pointurl').parent().parent().hide();
        } else {
            jQuery('#rs_count_for_pointurl').parent().parent().show();
        }
    });

    /*Show or hide Settings for Point URL Tab - End*/

    /*Show or hide Settings for Buying Reward Point - Start*/

    if (jQuery('#_rewardsystem_buying_reward_points').val() == 'no') {
        jQuery('.show_if_buy_reward_points_enable').parent().hide();
    } else {
        jQuery('.show_if_buy_reward_points_enable').parent().show();
    }

    jQuery('#_rewardsystem_buying_reward_points').change(function () {
        if (jQuery(this).val() == 'no') {
            jQuery('.show_if_buy_reward_points_enable').parent().hide();
        } else {
            jQuery('.show_if_buy_reward_points_enable').parent().show();
        }
    });

    /*Show or hide Settings for Buying Reward Point - End*/

    /*Show or hide Settings for Point Price in Product Page - Start*/

    if (jQuery('#_rewardsystem_enable_point_price').val() == 'no') {
        jQuery('#_rewardsystem__points').parent().hide();
        jQuery('#_rewardsystem_point_price_type').parent().hide();
        jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();
        jQuery('#_rewardsystem_enable_point_price_type').parent().hide();
        jQuery('#_rewardsystem_enable_point_price_type_booking').parent().hide();
        jQuery('#_regular_price').parent().show();
        jQuery('#_sale_price').parent().show();

    } else {
        jQuery('#_rewardsystem_enable_point_price_type_booking').parent().hide();
        jQuery('#_rewardsystem_enable_point_price_type').parent().show();
        if (jQuery('#_rewardsystem_enable_point_price_type').val() == '2') {
            jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();
            jQuery('#_rewardsystem_point_price_type').parent().hide();
            if (jQuery('#rs_point_price_visibility').val() == '1') {
                jQuery('#_regular_price').parent().hide();
                jQuery('#_sale_price').parent().hide();
            } else {
                jQuery('#_regular_price').parent().show();
                jQuery('#_sale_price').parent().show();
            }
            jQuery('#_rewardsystem__points').parent().show();
        } else {
            jQuery('#_regular_price').parent().show();
            jQuery('#_sale_price').parent().show();
            jQuery('#_rewardsystem_point_price_type').parent().show();
            if (jQuery('#_rewardsystem_point_price_type').val() == '1') {
                jQuery('#_rewardsystem__points').parent().show();

            } else {
                jQuery('#_rewardsystem__points_based_on_conversion').parent().show();
            }
        }
    }
    jQuery('#_rewardsystem_enable_point_price').change(function () {
        if (jQuery(this).val() == 'no') {
            jQuery('#_rewardsystem__points').parent().hide();
            jQuery('#_rewardsystem_point_price_type').parent().hide();
            jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();
            jQuery('#_rewardsystem_enable_point_price_type').parent().hide();
            jQuery('#_rewardsystem_enable_point_price_type_booking').parent().hide();
            jQuery('#_regular_price').parent().show();
            jQuery('#_sale_price').parent().show();

        } else {
            jQuery('#_rewardsystem_enable_point_price_type_booking').parent().hide();
            jQuery('#_rewardsystem_enable_point_price_type').parent().show();
            if (jQuery('#_rewardsystem_enable_point_price_type').val() == '2') {
                jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();
                jQuery('#_rewardsystem_point_price_type').parent().hide();
                if (jQuery('#rs_point_price_visibility').val() == '1') {
                    jQuery('#_regular_price').parent().hide();
                    jQuery('#_sale_price').parent().hide();
                } else {
                    jQuery('#_regular_price').parent().show();
                    jQuery('#_sale_price').parent().show();
                }
                jQuery('#_rewardsystem__points').parent().show();
            } else {
                jQuery('#_regular_price').parent().show();
                jQuery('#_sale_price').parent().show();
                jQuery('#_rewardsystem_point_price_type').parent().show();
                if (jQuery('#_rewardsystem_point_price_type').val() == '1') {
                    jQuery('#_rewardsystem__points').parent().show();

                } else {
                    jQuery('#_rewardsystem__points_based_on_conversion').parent().show();
                }
            }
        }
    });

    if (jQuery('._rewardsystem_enable_point_price_type').val() == '2') {
        jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();
        jQuery('#_rewardsystem_point_price_type').parent().hide();
    }
    jQuery('._rewardsystem_enable_point_price_type').change(function () {
        if (jQuery('._rewardsystem_enable_point_price_type').val() == '2') {
            jQuery('#_rewardsystem__points').parent().show();
            jQuery('#_rewardsystem_point_price_type').parent().hide();
            jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();
            jQuery('#_rewardsystem_point_price_type').parent().hide();
            if (jQuery('#rs_point_price_visibility').val() == '1') {
                jQuery('#_regular_price').parent().hide();
                jQuery('#_sale_price').parent().hide();
            } else {
                jQuery('#_regular_price').parent().show();
                jQuery('#_sale_price').parent().show();
            }
            jQuery('#_rewardsystem_enable_point_price_type_booking').parent().hide();
        } else {
            if (rewardsystem.sumo_booking) {
                jQuery('#_rewardsystem_point_price_type').val('1');
                jQuery('#_rewardsystem_point_price_type').parent().hide();
                jQuery('#_rewardsystem_enable_point_price_type_booking').parent().show();
                jQuery('#_rewardsystem__points').parent().show();
            } else {
                jQuery('#_rewardsystem_point_price_type').parent().show();
                jQuery('#_regular_price').parent().show();
                jQuery('#_sale_price').parent().show();
                if (jQuery('#_rewardsystem_point_price_type').val() == '1') {
                    jQuery('#_rewardsystem__points').parent().show();
                    jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();
                } else {
                    jQuery('#_rewardsystem__points_based_on_conversion').parent().show();
                    jQuery('#_rewardsystem__points').parent().hide();
                }
            }
        }
    });


    if (jQuery('#_rewardsystem_point_price_type').val() == '1') {

        jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();

    } else {
        jQuery('#_rewardsystem__points').parent().hide();

    }
    jQuery('#_rewardsystem_point_price_type').change(function () {
        if (jQuery(this).val() == '1') {
            jQuery('#_rewardsystem__points').parent().show();
            jQuery('#_rewardsystem__points_based_on_conversion').parent().hide();

        } else {
            jQuery('#_rewardsystem__points_based_on_conversion').parent().show();
            jQuery('#_rewardsystem__points').parent().hide();
        }
    });

    /*Show or hide Settings for Point Price in Product Page - End*/

    /*Show or hide Settings for Auto Redeeming in Checkout - Start*/

    var enable_auto_redeem_checkbox = jQuery('#rs_enable_disable_auto_redeem_points').is(':checked') ? 'yes' : 'no';
    if (enable_auto_redeem_checkbox === 'yes') {
        jQuery('#rs_percentage_cart_total_auto_redeem').parent().parent().show();
        jQuery('#rs_enable_disable_auto_redeem_checkout').parent().parent().parent().parent().show();
    } else {
        jQuery('#rs_percentage_cart_total_auto_redeem').parent().parent().hide();
        jQuery('#rs_enable_disable_auto_redeem_checkout').parent().parent().parent().parent().hide();
    }

    jQuery('#rs_enable_disable_auto_redeem_points').click(function () {
        var enable_auto_redeem_checkbox = jQuery('#rs_enable_disable_auto_redeem_points').is(':checked') ? 'yes' : 'no';
        if (enable_auto_redeem_checkbox == 'yes') {
            jQuery('#rs_percentage_cart_total_auto_redeem').parent().parent().show();
            jQuery('#rs_enable_disable_auto_redeem_checkout').parent().parent().parent().parent().show();
        } else {
            jQuery('#rs_percentage_cart_total_auto_redeem').parent().parent().hide();
            jQuery('#rs_enable_disable_auto_redeem_checkout').parent().parent().parent().parent().hide();
        }
    });
    /*Show or hide Settings for Auto Redeeming in Checkout - End*/
    if (jQuery('#rs_my_cashback_table').val() == '1') {
        jQuery('#rs_my_cashback_title').closest('tr').show();
        jQuery('#rs_my_cashback_sno_label').closest('tr').show();
        jQuery('#rs_my_cashback_userid_label').closest('tr').show();
        jQuery('#rs_my_cashback_requested_label').closest('tr').show();
        jQuery('#rs_my_cashback_status_label').closest('tr').show();
    } else {
        jQuery('#rs_my_cashback_title').closest('tr').hide();
        jQuery('#rs_my_cashback_sno_label').closest('tr').hide();
        jQuery('#rs_my_cashback_userid_label').closest('tr').hide();
        jQuery('#rs_my_cashback_requested_label').closest('tr').hide();
        jQuery('#rs_my_cashback_status_label').closest('tr').hide();
    }

    jQuery('#rs_my_cashback_table').change(function () {
        if (jQuery('#rs_my_cashback_table').val() == '1') {
            jQuery('#rs_my_cashback_title').closest('tr').show();
            jQuery('#rs_my_cashback_sno_label').closest('tr').show();
            jQuery('#rs_my_cashback_userid_label').closest('tr').show();
            jQuery('#rs_my_cashback_requested_label').closest('tr').show();
            jQuery('#rs_my_cashback_status_label').closest('tr').show();
        } else {
            jQuery('#rs_my_cashback_title').closest('tr').hide();
            jQuery('#rs_my_cashback_sno_label').closest('tr').hide();
            jQuery('#rs_my_cashback_userid_label').closest('tr').hide();
            jQuery('#rs_my_cashback_requested_label').closest('tr').hide();
            jQuery('#rs_my_cashback_status_label').closest('tr').hide();
        }
    });
    if (jQuery('#rs_my_cashback_table_shortcode').val() == '1') {
        jQuery('#rs_my_cashback_title_shortcode').closest('tr').show();
        jQuery('#rs_my_cashback_sno_label_shortcode').closest('tr').show();
        jQuery('#rs_my_cashback_userid_label_shortcode').closest('tr').show();
        jQuery('#rs_my_cashback_requested_label_shortcode').closest('tr').show();
        jQuery('#rs_my_cashback_status_label_shortcode').closest('tr').show();
    } else {
        jQuery('#rs_my_cashback_title_shortcode').closest('tr').hide();
        jQuery('#rs_my_cashback_sno_label').closest('tr').hide();
        jQuery('#rs_my_cashback_userid_label').closest('tr').hide();
        jQuery('#rs_my_cashback_requested_label').closest('tr').hide();
        jQuery('#rs_my_cashback_status_label').closest('tr').hide();
    }

    jQuery('#rs_my_cashback_table_shortcode').change(function () {
        if (jQuery('#rs_my_cashback_table_shortcode').val() == '1') {
            jQuery('#rs_my_cashback_title_shortcode').closest('tr').show();
            jQuery('#rs_my_cashback_sno_label_shortcode').closest('tr').show();
            jQuery('#rs_my_cashback_userid_label_shortcode').closest('tr').show();
            jQuery('#rs_my_cashback_requested_label_shortcode').closest('tr').show();
            jQuery('#rs_my_cashback_status_label_shortcode').closest('tr').show();
        } else {
            jQuery('#rs_my_cashback_title_shortcode').closest('tr').hide();
            jQuery('#rs_my_cashback_sno_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_cashback_userid_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_cashback_requested_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_cashback_status_label_shortcode').closest('tr').hide();
        }
    });
    /*Show or hide Settings for Cashback - End*/

    /*Show or hide for Redeeming Module - Start*/

    /*Show or Hide For Redeem Button Type - Start*/
    if (jQuery('#rs_redeem_field_type_option').val() == '1') {
        jQuery('#rs_percentage_cart_total_redeem').parent().parent().hide();
        jQuery('#rs_redeeming_button_option_message').closest('tr').hide();
    } else {
        jQuery('#rs_percentage_cart_total_redeem').parent().parent().show();
        jQuery('#rs_redeeming_button_option_message').closest('tr').show();
    }

    jQuery('#rs_redeem_field_type_option').change(function () {
        if (jQuery('#rs_redeem_field_type_option').val() == '1') {
            jQuery('#rs_percentage_cart_total_redeem').parent().parent().hide();
            jQuery('#rs_redeeming_button_option_message').closest('tr').hide();
        } else {
            jQuery('#rs_percentage_cart_total_redeem').parent().parent().show();
            jQuery('#rs_redeeming_button_option_message').closest('tr').show();
        }
    });
    /*Show or Hide For Redeem Button Type - End*/

    if (jQuery('#rs_coupon_applied_individual').is(':checked') == true) {
        jQuery('#rs_coupon_applied_individual_error_msg').closest('tr').show();
    } else {
        jQuery('#rs_coupon_applied_individual_error_msg').closest('tr').hide();
    }

    jQuery('#rs_coupon_applied_individual').change(function () {
        if (jQuery('#rs_coupon_applied_individual').is(':checked') == true) {
            jQuery('#rs_coupon_applied_individual_error_msg').closest('tr').show();
        } else {
            jQuery('#rs_coupon_applied_individual_error_msg').closest('tr').hide();
        }
    });

    /*Show or Hide for Maximum Cart Total - Start*/
    if (jQuery('#rs_show_hide_maximum_cart_total_error_message').val() == '1') {
        jQuery('#rs_max_cart_total_redeem_error').closest('tr').show();
    } else {
        jQuery('#rs_max_cart_total_redeem_error').closest('tr').hide();
    }

    jQuery('#rs_show_hide_maximum_cart_total_error_message').change(function () {
        if (jQuery('#rs_show_hide_maximum_cart_total_error_message').val() == '1') {
            jQuery('#rs_max_cart_total_redeem_error').closest('tr').show();
        } else {
            jQuery('#rs_max_cart_total_redeem_error').closest('tr').hide();
        }
    });
    /*Show or Hide for Maximum Cart Total - End*/

    /*Show or hide for Redeeming Module - End*/

    /*Show or hide for Product Purchase Module - Start*/

    /*Show or hide for Points Cane be Earned in Cart - Start*/
    if (jQuery('#rs_show_hide_total_points_cart_field').val() == '1') {
        jQuery('#rs_total_earned_point_caption').closest('tr').show();
        jQuery('#rs_show_hide_equivalent_price_for_points_cart').closest('tr').show();
    } else {
        jQuery('#rs_total_earned_point_caption').closest('tr').hide();
        jQuery('#rs_show_hide_equivalent_price_for_points_cart').closest('tr').hide();
    }

    jQuery('#rs_show_hide_total_points_cart_field').change(function () {
        if (jQuery('#rs_show_hide_total_points_cart_field').val() == '1') {
            jQuery('#rs_total_earned_point_caption').closest('tr').show();
            jQuery('#rs_show_hide_equivalent_price_for_points_cart').closest('tr').show();
        } else {
            jQuery('#rs_total_earned_point_caption').closest('tr').hide();
            jQuery('#rs_show_hide_equivalent_price_for_points_cart').closest('tr').hide();
        }
    });
    /*Show or hide for Points Cane be Earned in Cart - End*/

    /*Show or hide for Minimum Cart Total to Earn Point - Start*/
    if (jQuery('#rs_show_hide_minimum_cart_total_earn_error_message').val() == '1') {
        jQuery('#rs_min_cart_total_for_earning_error_message').closest('tr').show();
    } else {
        jQuery('#rs_min_cart_total_for_earning_error_message').closest('tr').hide();
    }

    jQuery('#rs_show_hide_minimum_cart_total_earn_error_message').change(function () {
        if (jQuery('#rs_show_hide_minimum_cart_total_earn_error_message').val() == '1') {
            jQuery('#rs_min_cart_total_for_earning_error_message').closest('tr').show();
        } else {
            jQuery('#rs_min_cart_total_for_earning_error_message').closest('tr').hide();
        }
    });
    /*Show or hide for Minimum Cart Total to Earn Point - End*/

    /*Show or hide for Maximum Cart Total to Earn Point - Start*/
    if (jQuery('#rs_show_hide_maximum_cart_total_earn_error_message').val() == '1') {
        jQuery('#rs_max_cart_total_for_earning_error_message').closest('tr').show();
    } else {
        jQuery('#rs_max_cart_total_for_earning_error_message').closest('tr').hide();
    }

    jQuery('#rs_show_hide_maximum_cart_total_earn_error_message').change(function () {
        if (jQuery('#rs_show_hide_maximum_cart_total_earn_error_message').val() == '1') {
            jQuery('#rs_max_cart_total_for_earning_error_message').closest('tr').show();
        } else {
            jQuery('#rs_max_cart_total_for_earning_error_message').closest('tr').hide();
        }
    });
    /*Show or hide for Maximum Cart Total to Earn Point - End*/

    /*Show or hide for Points can Earned in Checkout - Start*/
    if (jQuery('#rs_show_hide_total_points_checkout_field').val() == '1') {
        jQuery('#rs_total_earned_point_caption_checkout').closest('tr').show();
        jQuery('#rs_show_hide_equivalent_price_for_points').closest('tr').show();
    } else {
        jQuery('#rs_total_earned_point_caption_checkout').closest('tr').hide();
        jQuery('#rs_show_hide_equivalent_price_for_points').closest('tr').hide();
    }

    jQuery('#rs_show_hide_total_points_checkout_field').change(function () {
        if (jQuery('#rs_show_hide_total_points_checkout_field').val() == '1') {
            jQuery('#rs_total_earned_point_caption_checkout').closest('tr').show();
            jQuery('#rs_show_hide_equivalent_price_for_points').closest('tr').show();
        } else {
            jQuery('#rs_total_earned_point_caption_checkout').closest('tr').hide();
            jQuery('#rs_show_hide_equivalent_price_for_points').closest('tr').hide();
        }
    });
    /*Show or hide for Points can Earned in Checkout - End*/

    /*Show or hide for Points can Earned in Thank You Page - Start*/
    if (jQuery('#rs_show_hide_total_points_order_field').val() == '1') {
        jQuery('#rs_total_earned_point_caption_thank_you').closest('tr').show();
        jQuery('#rs_show_hide_equivalent_price_for_points_thankyou').closest('tr').show();

    } else {
        jQuery('#rs_total_earned_point_caption_thank_you').closest('tr').hide();
        jQuery('#rs_show_hide_equivalent_price_for_points_thankyou').closest('tr').hide();
    }

    jQuery('#rs_show_hide_total_points_order_field').change(function () {
        if (jQuery('#rs_show_hide_total_points_order_field').val() == '1') {
            jQuery('#rs_total_earned_point_caption_thank_you').closest('tr').show();
            jQuery('#rs_show_hide_equivalent_price_for_points_thankyou').closest('tr').show();
        } else {
            jQuery('#rs_total_earned_point_caption_thank_you').closest('tr').hide();
            jQuery('#rs_show_hide_equivalent_price_for_points_thankyou').closest('tr').hide();
        }
    });
    /*Show or hide for Points can Earned in Thank You Page - End*/

    /*Show or hide for Product Purchase Module - End*/

    /*Show or hide for Subscribe Link - Start*/
//    if (jQuery('#rs_show_hide_your_subscribe_link').val() == '1') {
//        jQuery('#rs_unsub_field_caption').closest('tr').show();
//    } else {
//        jQuery('#rs_unsub_field_caption').closest('tr').hide();
//    }
//
//    jQuery('#rs_show_hide_your_subscribe_link').change(function () {
//        if (jQuery('#rs_show_hide_your_subscribe_link').val() == '1') {
//            jQuery('#rs_unsub_field_caption').closest('tr').show();
//        } else {
//            jQuery('#rs_unsub_field_caption').closest('tr').hide();
//        }
//    });
    /*Show or hide for Subscribe Link - End*/

    /*Show or hide for My Reward Table - Start*/
//    if (jQuery('#rs_my_reward_table').val() == '1') {
//        jQuery('#rs_points_log_sorting').closest('tr').show();
//        jQuery('#rs_show_hide_search_box_in_my_rewards_table').closest('tr').show();
//        jQuery('#rs_my_reward_points_expire').closest('tr').show();
//        jQuery('#rs_my_reward_points_user_name_hide').closest('tr').show();
//        jQuery('#rs_show_hide_page_size_my_rewards').closest('tr').show();
//        jQuery('#rs_reward_table_position').closest('tr').show();
//        jQuery('#rs_reward_point_label_position').closest('tr').show();
//        jQuery('#rs_my_rewards_total').closest('tr').show();
//        jQuery('#rs_reward_currency_value').closest('tr').show();
//        jQuery('#rs_my_rewards_title').closest('tr').show();
//        jQuery('#rs_my_rewards_sno_label').closest('tr').show();
//        jQuery('#rs_my_rewards_userid_label').closest('tr').show();
//        jQuery('#rs_my_rewards_rewarder_label').closest('tr').show();
//        jQuery('#rs_my_rewards_points_earned_label').closest('tr').show();
//        jQuery('#rs_my_rewards_redeem_points_label').closest('tr').show();
//        jQuery('#rs_my_rewards_total_points_label').closest('tr').show();
//        jQuery('#rs_my_rewards_date_label').closest('tr').show();
//        jQuery('#rs_my_rewards_points_expired_label').closest('tr').show();
//    } else {
//        jQuery('#rs_points_log_sorting').closest('tr').hide();
//        jQuery('#rs_show_hide_search_box_in_my_rewards_table').closest('tr').hide();
//        jQuery('#rs_my_reward_points_expire').closest('tr').hide();
//        jQuery('#rs_my_reward_points_user_name_hide').closest('tr').hide();
//        jQuery('#rs_show_hide_page_size_my_rewards').closest('tr').hide();
//        jQuery('#rs_reward_table_position').closest('tr').hide();
//        jQuery('#rs_reward_point_label_position').closest('tr').hide();
//        jQuery('#rs_my_rewards_total').closest('tr').hide();
//        jQuery('#rs_reward_currency_value').closest('tr').hide();
//        jQuery('#rs_my_rewards_title').closest('tr').hide();
//        jQuery('#rs_my_rewards_sno_label').closest('tr').hide();
//        jQuery('#rs_my_rewards_userid_label').closest('tr').hide();
//        jQuery('#rs_my_rewards_rewarder_label').closest('tr').hide();
//        jQuery('#rs_my_rewards_points_earned_label').closest('tr').hide();
//        jQuery('#rs_my_rewards_redeem_points_label').closest('tr').hide();
//        jQuery('#rs_my_rewards_total_points_label').closest('tr').hide();
//        jQuery('#rs_my_rewards_date_label').closest('tr').hide();
//        jQuery('#rs_my_rewards_points_expired_label').closest('tr').hide();
//    }
//
//    jQuery('#rs_my_reward_table').change(function () {
//        if (jQuery('#rs_my_reward_table').val() == '1') {
//            jQuery('#rs_points_log_sorting').closest('tr').show();
//            jQuery('#rs_show_hide_search_box_in_my_rewards_table').closest('tr').show();
//            jQuery('#rs_my_reward_points_expire').closest('tr').show();
//            jQuery('#rs_my_reward_points_user_name_hide').closest('tr').show();
//            jQuery('#rs_show_hide_page_size_my_rewards').closest('tr').show();
//            jQuery('#rs_reward_table_position').closest('tr').show();
//            jQuery('#rs_reward_point_label_position').closest('tr').show();
//            jQuery('#rs_my_rewards_total').closest('tr').show();
//            jQuery('#rs_reward_currency_value').closest('tr').show();
//            jQuery('#rs_my_rewards_title').closest('tr').show();
//            jQuery('#rs_my_rewards_sno_label').closest('tr').show();
//            jQuery('#rs_my_rewards_userid_label').closest('tr').show();
//            jQuery('#rs_my_rewards_rewarder_label').closest('tr').show();
//            jQuery('#rs_my_rewards_points_earned_label').closest('tr').show();
//            jQuery('#rs_my_rewards_redeem_points_label').closest('tr').show();
//            jQuery('#rs_my_rewards_total_points_label').closest('tr').show();
//            jQuery('#rs_my_rewards_date_label').closest('tr').show();
//            jQuery('#rs_my_rewards_points_expired_label').closest('tr').show();
//        } else {
//            jQuery('#rs_points_log_sorting').closest('tr').hide();
//            jQuery('#rs_show_hide_search_box_in_my_rewards_table').closest('tr').hide();
//            jQuery('#rs_my_reward_points_expire').closest('tr').hide();
//            jQuery('#rs_my_reward_points_user_name_hide').closest('tr').hide();
//            jQuery('#rs_show_hide_page_size_my_rewards').closest('tr').hide();
//            jQuery('#rs_reward_table_position').closest('tr').hide();
//            jQuery('#rs_reward_point_label_position').closest('tr').hide();
//            jQuery('#rs_my_rewards_total').closest('tr').hide();
//            jQuery('#rs_reward_currency_value').closest('tr').hide();
//            jQuery('#rs_my_rewards_title').closest('tr').hide();
//            jQuery('#rs_my_rewards_sno_label').closest('tr').hide();
//            jQuery('#rs_my_rewards_userid_label').closest('tr').hide();
//            jQuery('#rs_my_rewards_rewarder_label').closest('tr').hide();
//            jQuery('#rs_my_rewards_points_earned_label').closest('tr').hide();
//            jQuery('#rs_my_rewards_redeem_points_label').closest('tr').hide();
//            jQuery('#rs_my_rewards_total_points_label').closest('tr').hide();
//            jQuery('#rs_my_rewards_date_label').closest('tr').hide();
//            jQuery('#rs_my_rewards_points_expired_label').closest('tr').hide();
//        }
//    });
    /*Show or hide for My Reward Table - End*/

    if (jQuery('#rs_my_reward_table_shortcode').val() == '1') {
        jQuery('#rs_points_log_sorting_shortcode').closest('tr').show();
        jQuery('#rs_show_hide_search_box_in_my_rewards_table_shortcode').closest('tr').show();
        jQuery('#rs_my_reward_points_expire_shortcode').closest('tr').show();
        jQuery('#rs_my_reward_points_s_no_shortcode').closest('tr').show();
        jQuery('#rs_my_reward_points_user_name_hide_shortcode').closest('tr').show();
        jQuery('#rs_show_hide_page_size_my_rewards_shortcode').closest('tr').show();
        jQuery('#rs_reward_table_position_shortcode').closest('tr').show();
        jQuery('#rs_reward_point_label_position_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_total_shortcode').closest('tr').show();
        jQuery('#rs_reward_currency_value_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_title_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_sno_label_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_userid_label_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_rewarder_label_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_points_earned_label_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_redeem_points_label_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_total_points_label_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_date_label_shortcode').closest('tr').show();
        jQuery('#rs_my_rewards_points_expired_label_shortcode').closest('tr').show();
    } else {
        jQuery('#rs_points_log_sorting').closest('tr').hide();
        jQuery('#rs_show_hide_search_box_in_my_rewards_table_shortcode').closest('tr').hide();
        jQuery('#rs_my_reward_points_expire_shortcode').closest('tr').hide();
        jQuery('#rs_my_reward_points_s_no_shortcode').closest('tr').hide();
        jQuery('#rs_my_reward_points_user_name_hide_shortcode').closest('tr').hide();
        jQuery('#rs_show_hide_page_size_my_rewards_shortcode').closest('tr').hide();
        jQuery('#rs_reward_table_position_shortcode').closest('tr').hide();
        jQuery('#rs_reward_point_label_position_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_total_shortcode').closest('tr').hide();
        jQuery('#rs_reward_currency_value_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_title_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_sno_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_userid_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_rewarder_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_points_earned_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_redeem_points_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_total_points_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_date_label_shortcode').closest('tr').hide();
        jQuery('#rs_my_rewards_points_expired_label_shortcode').closest('tr').hide();
    }

    jQuery('#rs_my_reward_table_shortcode').change(function () {
        if (jQuery('#rs_my_reward_table_shortcode').val() == '1') {
            jQuery('#rs_points_log_sorting_shortcode').closest('tr').show();
            jQuery('#rs_show_hide_search_box_in_my_rewards_table_shortcode').closest('tr').show();
            jQuery('#rs_my_reward_points_expire_shortcode').closest('tr').show();
            jQuery('#rs_my_reward_points_s_no_shortcode').closest('tr').show();
            jQuery('#rs_my_reward_points_user_name_hide_shortcode').closest('tr').show();
            jQuery('#rs_show_hide_page_size_my_rewards_shortcode').closest('tr').show();
            jQuery('#rs_reward_table_position_shortcode').closest('tr').show();
            jQuery('#rs_reward_point_label_position_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_total_shortcode').closest('tr').show();
            jQuery('#rs_reward_currency_value_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_title_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_sno_label_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_userid_label_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_rewarder_label_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_points_earned_label_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_redeem_points_label_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_total_points_label_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_date_label_shortcode').closest('tr').show();
            jQuery('#rs_my_rewards_points_expired_label_shortcode').closest('tr').show();
        } else {
            jQuery('#rs_points_log_sorting_shortcode').closest('tr').hide();
            jQuery('#rs_show_hide_search_box_in_my_rewards_table_shortcode').closest('tr').hide();
            jQuery('#rs_my_reward_points_expire_shortcode').closest('tr').hide();
            jQuery('#rs_my_reward_points_s_no_shortcode').closest('tr').hide();
            jQuery('#rs_my_reward_points_user_name_hide_shortcode').closest('tr').hide();
            jQuery('#rs_show_hide_page_size_my_rewards_shortcode').closest('tr').hide();
            jQuery('#rs_reward_table_position_shortcode').closest('tr').hide();
            jQuery('#rs_reward_point_label_position_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_total_shortcode').closest('tr').hide();
            jQuery('#rs_reward_currency_value_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_title_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_sno_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_userid_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_rewarder_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_points_earned_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_redeem_points_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_total_points_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_date_label_shortcode').closest('tr').hide();
            jQuery('#rs_my_rewards_points_expired_label_shortcode').closest('tr').hide();
        }
    });






    jQuery("#rs_enable_earned_level_based_reward_points").change(function () {
        if (jQuery("#rs_enable_earned_level_based_reward_points").is(':checked') == true) {
            jQuery('.rs_sample').css('border', '1px solid #ccc');
        } else {
            jQuery('.rs_sample').css('border', 'none');
        }
    });

    //Product Purchase Global Level Show or Hide
    if (jQuery('input[name=rs_enable_product_category_level_for_product_purchase]:checked').val() == 'no') {
        jQuery('#rs_product_purchase_global_level_applicable_for').closest('tr').show();
        if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '1') {
            jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
        } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '2') {
            jQuery('#rs_include_products_for_product_purchase').closest('tr').show();
            jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
        } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '3') {
            jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_product_purchase').closest('tr').show();
            jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
        } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '4') {
            jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
        } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '5') {
            jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').show();
            jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
        } else {
            jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').show();
        }

        jQuery('#rs_product_purchase_global_level_applicable_for').change(function () {
            if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '1') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '2') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').show();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '3') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').show();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '4') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '5') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').show();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').show();
            }
        });
        jQuery('.rs_hide_bulk_update_for_product_purchase_start').hide();
    } else {
        jQuery('#rs_product_purchase_global_level_applicable_for').closest('tr').hide();
        jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
        jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
        jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
        jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
        jQuery('.rs_hide_bulk_update_for_product_purchase_start').show();
    }

    jQuery('.rs_enable_product_category_level_for_product_purchase').change(function () {
        if (jQuery('input[name=rs_enable_product_category_level_for_product_purchase]:checked').val() == 'no') {
            jQuery('#rs_product_purchase_global_level_applicable_for').closest('tr').show();
            if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '1') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '2') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').show();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '3') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').show();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '4') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '5') {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').show();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            } else {
                jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').show();
            }

            jQuery('#rs_product_purchase_global_level_applicable_for').change(function () {
                if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '1') {
                    jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
                } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '2') {
                    jQuery('#rs_include_products_for_product_purchase').closest('tr').show();
                    jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
                } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '3') {
                    jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_product_purchase').closest('tr').show();
                    jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
                } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '4') {
                    jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
                } else if (jQuery('#rs_product_purchase_global_level_applicable_for').val() == '5') {
                    jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').show();
                    jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
                } else {
                    jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').show();
                }
            });
            jQuery('.rs_hide_bulk_update_for_product_purchase_start').hide();
        } else {
            jQuery('#rs_product_purchase_global_level_applicable_for').closest('tr').hide();
            jQuery('#rs_include_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_product_purchase').closest('tr').hide();
            jQuery('.rs_hide_bulk_update_for_product_purchase_start').show();
        }
    });

    show_hide_product(jQuery("#rs_buying_points_is_applicable").val());
    jQuery("#rs_buying_points_is_applicable").change(function () {
        show_hide_product(jQuery(this).val());

    });

    function show_hide_product(value) {
        if (value == '1') {
            jQuery('#rs_include_products_for_buying_points').closest('tr').hide();
            jQuery('#rs_exclude_products_for_buying_points').closest('tr').hide();
        } else if (value == '2') {
            jQuery('#rs_include_products_for_buying_points').closest('tr').show();
            jQuery('#rs_exclude_products_for_buying_points').closest('tr').hide();
        } else {
            jQuery('#rs_include_products_for_buying_points').closest('tr').hide();
            jQuery('#rs_exclude_products_for_buying_points').closest('tr').show();
        }
    }

    if (jQuery('#rs_enable_buying_points').val() == 'no') {
        jQuery('#rs_points_for_buying_points').closest('tr').hide();
    } else {
        jQuery('#rs_points_for_buying_points').closest('tr').show();
    }

    jQuery('#rs_enable_buying_points').change(function () {
        if (jQuery(this).val() == 'no') {
            jQuery('#rs_points_for_buying_points').closest('tr').hide();
        } else {
            jQuery('#rs_points_for_buying_points').closest('tr').show();
        }
    });


    //Referral Product Purchase Global Show or Hide
    if (jQuery('input[name=rs_enable_product_category_level_for_referral_product_purchase]:checked').val() == 'no') {
        jQuery('#rs_referral_product_purchase_global_level_applicable_for').closest('tr').show();
        if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '1') {
            jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
        } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '2') {
            jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').show();
            jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
        } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '3') {
            jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').show();
            jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
        } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '4') {
            jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
        } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '5') {
            jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').show();
            jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
        } else {
            jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').show();
        }

        jQuery('#rs_referral_product_purchase_global_level_applicable_for').change(function () {
            if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '1') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '2') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').show();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '3') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').show();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '4') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '5') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').show();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').show();
            }
        });
        jQuery('.rs_hide_bulk_update_for_referral_product_purchase_start').hide();
    } else {
        jQuery('#rs_referral_product_purchase_global_level_applicable_for').closest('tr').hide();
        jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
        jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
        jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
        jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
        jQuery('.rs_hide_bulk_update_for_referral_product_purchase_start').show();
    }

    jQuery('.rs_enable_product_category_level_for_referral_product_purchase').change(function () {
        if (jQuery('input[name=rs_enable_product_category_level_for_referral_product_purchase]:checked').val() == 'no') {
            jQuery('#rs_referral_product_purchase_global_level_applicable_for').closest('tr').show();
            if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '1') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '2') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').show();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '3') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').show();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '4') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '5') {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').show();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            } else {
                jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').show();
            }

            jQuery('#rs_referral_product_purchase_global_level_applicable_for').change(function () {
                if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '1') {
                    jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
                } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '2') {
                    jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').show();
                    jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
                } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '3') {
                    jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').show();
                    jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
                } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '4') {
                    jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
                } else if (jQuery('#rs_referral_product_purchase_global_level_applicable_for').val() == '5') {
                    jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').show();
                    jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
                } else {
                    jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').show();
                }
            });
            jQuery('.rs_hide_bulk_update_for_referral_product_purchase_start').hide();
        } else {
            jQuery('#rs_referral_product_purchase_global_level_applicable_for').closest('tr').hide();
            jQuery('#rs_include_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_products_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_referral_product_purchase').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_referral_product_purchase').closest('tr').hide();
            jQuery('.rs_hide_bulk_update_for_referral_product_purchase_start').show();
        }
    });

    //Social Reward Global Show or Hide
    if (jQuery('input[name=rs_enable_product_category_level_for_social_reward]:checked').val() == 'no') {
        jQuery('#rs_social_reward_global_level_applicable_for').closest('tr').show();
        if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '1') {
            jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
        } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '2') {
            jQuery('#rs_include_products_for_social_reward').closest('tr').show();
            jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
        } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '3') {
            jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_products_for_social_reward').closest('tr').show();
            jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
        } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '4') {
            jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
        } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '5') {
            jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').show();
            jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
        } else {
            jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').show();
        }

        jQuery('#rs_social_reward_global_level_applicable_for').change(function () {
            if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '1') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '2') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').show();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '3') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').show();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '4') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '5') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').show();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').show();
            }
        });
        jQuery('.rs_hide_bulk_update_for_social_reward_start').hide();
    } else {
        jQuery('#rs_social_reward_global_level_applicable_for').closest('tr').hide();
        jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
        jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
        jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
        jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
        jQuery('.rs_hide_bulk_update_for_social_reward_start').show();
    }

    jQuery('.rs_enable_product_category_level_for_social_reward').change(function () {
        if (jQuery('input[name=rs_enable_product_category_level_for_social_reward]:checked').val() == 'no') {
            jQuery('#rs_social_reward_global_level_applicable_for').closest('tr').show();
            if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '1') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '2') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').show();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '3') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').show();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '4') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '5') {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').show();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            } else {
                jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').show();
            }

            jQuery('#rs_social_reward_global_level_applicable_for').change(function () {
                if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '1') {
                    jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
                } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '2') {
                    jQuery('#rs_include_products_for_social_reward').closest('tr').show();
                    jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
                } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '3') {
                    jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_social_reward').closest('tr').show();
                    jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
                } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '4') {
                    jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
                } else if (jQuery('#rs_social_reward_global_level_applicable_for').val() == '5') {
                    jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').show();
                    jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
                } else {
                    jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').show();
                }
            });
            jQuery('.rs_hide_bulk_update_for_social_reward_start').hide();
        } else {
            jQuery('#rs_social_reward_global_level_applicable_for').closest('tr').hide();
            jQuery('#rs_include_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_products_for_social_reward').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_social_reward').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_social_reward').closest('tr').hide();
            jQuery('.rs_hide_bulk_update_for_social_reward_start').show();
        }
    });

    //Point Price Global Show or Hide
    if (jQuery('input[name=rs_enable_product_category_level_for_points_price]:checked').val() == 'no') {
        jQuery('#rs_point_pricing_global_level_applicable_for').closest('tr').show();
        if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '1') {
            jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
        } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '2') {
            jQuery('#rs_include_products_for_point_pricing').closest('tr').show();
            jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
        } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '3') {
            jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_products_for_point_pricing').closest('tr').show();
            jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
        } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '4') {
            jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
        } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '5') {
            jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').show();
            jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
        } else {
            jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').show();
        }

        jQuery('#rs_point_pricing_global_level_applicable_for').change(function () {
            if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '1') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '2') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').show();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '3') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').show();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '4') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '5') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').show();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').show();
            }
        });
        jQuery('.rs_hide_bulk_update_for_point_price_start').hide();
    } else {
        jQuery('#rs_point_pricing_global_level_applicable_for').closest('tr').hide();
        jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
        jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
        jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
        jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
        jQuery('.rs_hide_bulk_update_for_point_price_start').show();
    }

    jQuery('.rs_enable_product_category_level_for_points_price').change(function () {
        if (jQuery('input[name=rs_enable_product_category_level_for_points_price]:checked').val() == 'no') {
            jQuery('#rs_point_pricing_global_level_applicable_for').closest('tr').show();
            if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '1') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '2') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').show();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '3') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').show();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '4') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '5') {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').show();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            } else {
                jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').show();
            }

            jQuery('#rs_point_pricing_global_level_applicable_for').change(function () {
                if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '1') {
                    jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
                } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '2') {
                    jQuery('#rs_include_products_for_point_pricing').closest('tr').show();
                    jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
                } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '3') {
                    jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_point_pricing').closest('tr').show();
                    jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
                } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '4') {
                    jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
                } else if (jQuery('#rs_point_pricing_global_level_applicable_for').val() == '5') {
                    jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').show();
                    jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
                } else {
                    jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
                    jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').show();
                }
            });
            jQuery('.rs_hide_bulk_update_for_point_price_start').hide();
        } else {
            jQuery('#rs_point_pricing_global_level_applicable_for').closest('tr').hide();
            jQuery('#rs_include_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_products_for_point_pricing').closest('tr').hide();
            jQuery('#rs_include_particular_categories_for_point_pricing').closest('tr').hide();
            jQuery('#rs_exclude_particular_categories_for_point_pricing').closest('tr').hide();
            jQuery('.rs_hide_bulk_update_for_point_price_start').show();
        }
    });

    /*Show or hide Settings for Cashback - Start*/
    if (jQuery('#rs_enable_disable_encashing').val() == '1') {
        jQuery('#rs_minimum_points_encashing_request').closest('tr').show();
        jQuery('#rs_maximum_points_encashing_request').closest('tr').show();
        jQuery('#rs_allow_user_to_request_cashback').closest('tr').show();
        jQuery('#rs_total_points_for_cashback_request').closest('tr').show();
        jQuery('#rs_encashing_points_label').closest('tr').show();
        jQuery('#rs_encashing_reason_label').closest('tr').show();
        jQuery('#rs_encashing_payment_method_label').closest('tr').show();
        jQuery('#rs_encashing_submit_button_label').closest('tr').show();
        jQuery('#rs_select_payment_method').closest('tr').show();
        jQuery('#rs_select_type_to_redirect').closest('tr').show();
        jQuery('#rs_allow_admin_to_save_previous_payment_method').closest('tr').show();

        if (jQuery('#rs_select_type_to_redirect').val() == '1') {
            jQuery('#rs_custom_page_url_after_submit').closest('tr').hide();
        } else {
            jQuery('#rs_custom_page_url_after_submit').closest('tr').show();
        }

        jQuery('#rs_select_type_to_redirect').change(function () {
            if (jQuery('#rs_select_type_to_redirect').val() == '1') {
                jQuery('#rs_custom_page_url_after_submit').closest('tr').hide();
            } else {
                jQuery('#rs_custom_page_url_after_submit').closest('tr').show();
            }
        });

        /*Show or hide Settings for Payment Method Display - Start*/
        if (jQuery('#rs_select_payment_method').val() == '1') {
            jQuery('#rs_encashing_payment_paypal_label').closest('tr').show();
            jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
            jQuery('#rs_encashing_wallet_label').closest('tr').hide();
            jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
        } else if (jQuery('#rs_select_payment_method').val() == '2') {
            jQuery('#rs_encashing_payment_custom_label').closest('tr').show();
            jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
            jQuery('#rs_encashing_wallet_label').closest('tr').hide();
            jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
        } else if (jQuery('#rs_select_payment_method').val() == '4') {
            jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
            jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
            jQuery('#rs_encashing_wallet_label').closest('tr').show();
            jQuery('#rs_encashing_wallet_menu_label').closest('tr').show();
        } else {
            jQuery('#rs_encashing_payment_paypal_label').closest('tr').show();
            jQuery('#rs_encashing_payment_custom_label').closest('tr').show();
            jQuery('#rs_encashing_wallet_label').closest('tr').show();
            jQuery('#rs_encashing_wallet_menu_label').closest('tr').show();
        }

        jQuery('#rs_select_payment_method').change(function () {
            if (jQuery('#rs_select_payment_method').val() == '1') {
                jQuery('#rs_encashing_payment_paypal_label').closest('tr').show();
                jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
            } else if (jQuery('#rs_select_payment_method').val() == '2') {
                jQuery('#rs_encashing_payment_custom_label').closest('tr').show();
                jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
            } else if (jQuery('#rs_select_payment_method').val() == '4') {
                jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
                jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_label').closest('tr').show();
                jQuery('#rs_encashing_wallet_menu_label').closest('tr').show();
            } else {
                jQuery('#rs_encashing_payment_paypal_label').closest('tr').show();
                jQuery('#rs_encashing_payment_custom_label').closest('tr').show();
                jQuery('#rs_encashing_wallet_label').closest('tr').show();
                jQuery('#rs_encashing_wallet_menu_label').closest('tr').show();
            }
        });

        jQuery('#rs_user_selection_type_for_cashback').closest('tr').show();
        if (jQuery('#rs_user_selection_type_for_cashback').val() == '1') {
            jQuery('#rs_select_inc_user_search').closest('tr').hide();
            jQuery('#rs_select_exc_user_search').closest('tr').hide();
            jQuery('#rs_select_inc_userrole').closest('tr').hide();
            jQuery('#rs_select_exc_userrole').closest('tr').hide();
        } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '2') {
            jQuery('#rs_select_inc_user_search').closest('tr').show();
            jQuery('#rs_select_exc_user_search').closest('tr').hide();
            jQuery('#rs_select_inc_userrole').closest('tr').hide();
            jQuery('#rs_select_exc_userrole').closest('tr').hide();
        } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '3') {
            jQuery('#rs_select_inc_user_search').closest('tr').hide();
            jQuery('#rs_select_exc_user_search').closest('tr').show();
            jQuery('#rs_select_inc_userrole').closest('tr').hide();
            jQuery('#rs_select_exc_userrole').closest('tr').hide();
        } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '4') {
            jQuery('#rs_select_inc_user_search').closest('tr').hide();
            jQuery('#rs_select_exc_user_search').closest('tr').hide();
            jQuery('#rs_select_inc_userrole').closest('tr').hide();
            jQuery('#rs_select_exc_userrole').closest('tr').hide();
        } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '5') {
            jQuery('#rs_select_inc_user_search').closest('tr').hide();
            jQuery('#rs_select_exc_user_search').closest('tr').hide();
            jQuery('#rs_select_inc_userrole').closest('tr').show();
            jQuery('#rs_select_exc_userrole').closest('tr').hide();
        } else {
            jQuery('#rs_select_inc_user_search').closest('tr').hide();
            jQuery('#rs_select_exc_user_search').closest('tr').hide();
            jQuery('#rs_select_inc_userrole').closest('tr').hide();
            jQuery('#rs_select_exc_userrole').closest('tr').show();
        }
        jQuery('#rs_user_selection_type_for_cashback').change(function () {
            if (jQuery('#rs_user_selection_type_for_cashback').val() == '1') {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '2') {
                jQuery('#rs_select_inc_user_search').closest('tr').show();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '3') {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').show();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '4') {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '5') {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').show();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').show();
            }
        });
        /*Show or hide Settings for Payment Method Display - End*/
    } else {
        jQuery('#rs_minimum_points_encashing_request').closest('tr').hide();
        jQuery('#rs_maximum_points_encashing_request').closest('tr').hide();
        jQuery('#rs_encashing_points_label').closest('tr').hide();
        jQuery('#rs_allow_user_to_request_cashback').closest('tr').hide();
        jQuery('#rs_total_points_for_cashback_request').closest('tr').hide();
        jQuery('#rs_encashing_reason_label').closest('tr').hide();
        jQuery('#rs_encashing_payment_method_label').closest('tr').hide();
        jQuery('#rs_encashing_submit_button_label').closest('tr').hide();
        jQuery('#rs_select_payment_method').closest('tr').hide();
        jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
        jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
        jQuery('#rs_encashing_wallet_label').closest('tr').hide();
        jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
        jQuery('#rs_select_type_to_redirect').closest('tr').hide();
        jQuery('#rs_custom_page_url_after_submit').closest('tr').hide();
        jQuery('#rs_allow_admin_to_save_previous_payment_method').closest('tr').hide();
        jQuery('#rs_select_inc_user_search').closest('tr').hide();
        jQuery('#rs_select_exc_user_search').closest('tr').hide();
        jQuery('#rs_select_inc_userrole').closest('tr').hide();
        jQuery('#rs_select_exc_userrole').closest('tr').hide();
        jQuery('#rs_user_selection_type_for_cashback').closest('tr').hide();
    }

    jQuery('#rs_enable_disable_encashing').change(function () {
        if (jQuery('#rs_enable_disable_encashing').val() == '1') {
            jQuery('#rs_minimum_points_encashing_request').closest('tr').show();
            jQuery('#rs_maximum_points_encashing_request').closest('tr').show();
            jQuery('#rs_allow_user_to_request_cashback').closest('tr').show();
            jQuery('#rs_total_points_for_cashback_request').closest('tr').show();
            jQuery('#rs_encashing_points_label').closest('tr').show();
            jQuery('#rs_encashing_reason_label').closest('tr').show();
            jQuery('#rs_encashing_payment_method_label').closest('tr').show();
            jQuery('#rs_encashing_submit_button_label').closest('tr').show();
            jQuery('#rs_select_payment_method').closest('tr').show();
            jQuery('#rs_select_type_to_redirect').closest('tr').show();
            jQuery('#rs_allow_admin_to_save_previous_payment_method').closest('tr').show();

            if (jQuery('#rs_select_type_to_redirect').val() == '1') {
                jQuery('#rs_custom_page_url_after_submit').closest('tr').hide();
            } else {
                jQuery('#rs_custom_page_url_after_submit').closest('tr').show();
            }

            jQuery('#rs_select_type_to_redirect').change(function () {
                if (jQuery('#rs_select_type_to_redirect').val() == '1') {
                    jQuery('#rs_custom_page_url_after_submit').closest('tr').hide();
                } else {
                    jQuery('#rs_custom_page_url_after_submit').closest('tr').show();
                }
            });

            /*Show or hide Settings for Payment Method Display - Start*/
            if (jQuery('#rs_select_payment_method').val() == '1') {
                jQuery('#rs_encashing_payment_paypal_label').closest('tr').show();
                jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
            } else if (jQuery('#rs_select_payment_method').val() == '2') {
                jQuery('#rs_encashing_payment_custom_label').closest('tr').show();
                jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
            } else if (jQuery('#rs_select_payment_method').val() == '4') {
                jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
                jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
                jQuery('#rs_encashing_wallet_label').closest('tr').show();
                jQuery('#rs_encashing_wallet_menu_label').closest('tr').show();
            } else {
                jQuery('#rs_encashing_payment_paypal_label').closest('tr').show();
                jQuery('#rs_encashing_payment_custom_label').closest('tr').show();
                jQuery('#rs_encashing_wallet_label').closest('tr').show();
                jQuery('#rs_encashing_wallet_menu_label').closest('tr').show();
            }

            jQuery('#rs_select_payment_method').change(function () {
                if (jQuery('#rs_select_payment_method').val() == '1') {
                    jQuery('#rs_encashing_payment_paypal_label').closest('tr').show();
                    jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
                    jQuery('#rs_encashing_wallet_label').closest('tr').hide();
                    jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
                } else if (jQuery('#rs_select_payment_method').val() == '2') {
                    jQuery('#rs_encashing_payment_custom_label').closest('tr').show();
                    jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
                    jQuery('#rs_encashing_wallet_label').closest('tr').hide();
                    jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
                } else if (jQuery('#rs_select_payment_method').val() == '4') {
                    jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
                    jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
                    jQuery('#rs_encashing_wallet_label').closest('tr').show();
                    jQuery('#rs_encashing_wallet_menu_label').closest('tr').show();
                } else {
                    jQuery('#rs_encashing_payment_paypal_label').closest('tr').show();
                    jQuery('#rs_encashing_payment_custom_label').closest('tr').show();
                    jQuery('#rs_encashing_wallet_label').closest('tr').show();
                    jQuery('#rs_encashing_wallet_menu_label').closest('tr').show();
                }
            });

            jQuery('#rs_user_selection_type_for_cashback').closest('tr').show();
            if (jQuery('#rs_user_selection_type_for_cashback').val() == '1') {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '2') {
                jQuery('#rs_select_inc_user_search').closest('tr').show();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '3') {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').show();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '4') {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '5') {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').show();
                jQuery('#rs_select_exc_userrole').closest('tr').hide();
            } else {
                jQuery('#rs_select_inc_user_search').closest('tr').hide();
                jQuery('#rs_select_exc_user_search').closest('tr').hide();
                jQuery('#rs_select_inc_userrole').closest('tr').hide();
                jQuery('#rs_select_exc_userrole').closest('tr').show();
            }
            jQuery('#rs_user_selection_type_for_cashback').change(function () {
                if (jQuery('#rs_user_selection_type_for_cashback').val() == '1') {
                    jQuery('#rs_select_inc_user_search').closest('tr').hide();
                    jQuery('#rs_select_exc_user_search').closest('tr').hide();
                    jQuery('#rs_select_inc_userrole').closest('tr').hide();
                    jQuery('#rs_select_exc_userrole').closest('tr').hide();
                } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '2') {
                    jQuery('#rs_select_inc_user_search').closest('tr').show();
                    jQuery('#rs_select_exc_user_search').closest('tr').hide();
                    jQuery('#rs_select_inc_userrole').closest('tr').hide();
                    jQuery('#rs_select_exc_userrole').closest('tr').hide();
                } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '3') {
                    jQuery('#rs_select_inc_user_search').closest('tr').hide();
                    jQuery('#rs_select_exc_user_search').closest('tr').show();
                    jQuery('#rs_select_inc_userrole').closest('tr').hide();
                    jQuery('#rs_select_exc_userrole').closest('tr').hide();
                } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '4') {
                    jQuery('#rs_select_inc_user_search').closest('tr').hide();
                    jQuery('#rs_select_exc_user_search').closest('tr').hide();
                    jQuery('#rs_select_inc_userrole').closest('tr').hide();
                    jQuery('#rs_select_exc_userrole').closest('tr').hide();
                } else if (jQuery('#rs_user_selection_type_for_cashback').val() == '5') {
                    jQuery('#rs_select_inc_user_search').closest('tr').hide();
                    jQuery('#rs_select_exc_user_search').closest('tr').hide();
                    jQuery('#rs_select_inc_userrole').closest('tr').show();
                    jQuery('#rs_select_exc_userrole').closest('tr').hide();
                } else {
                    jQuery('#rs_select_inc_user_search').closest('tr').hide();
                    jQuery('#rs_select_exc_user_search').closest('tr').hide();
                    jQuery('#rs_select_inc_userrole').closest('tr').hide();
                    jQuery('#rs_select_exc_userrole').closest('tr').show();
                }
            });
            /*Show or hide Settings for Payment Method Display - End*/
        } else {
            jQuery('#rs_minimum_points_encashing_request').closest('tr').hide();
            jQuery('#rs_maximum_points_encashing_request').closest('tr').hide();
            jQuery('#rs_encashing_points_label').closest('tr').hide();
            jQuery('#rs_allow_user_to_request_cashback').closest('tr').hide();
            jQuery('#rs_total_points_for_cashback_request').closest('tr').hide();
            jQuery('#rs_encashing_reason_label').closest('tr').hide();
            jQuery('#rs_encashing_payment_method_label').closest('tr').hide();
            jQuery('#rs_encashing_submit_button_label').closest('tr').hide();
            jQuery('#rs_select_payment_method').closest('tr').hide();
            jQuery('#rs_encashing_payment_paypal_label').closest('tr').hide();
            jQuery('#rs_encashing_payment_custom_label').closest('tr').hide();
            jQuery('#rs_encashing_wallet_label').closest('tr').hide();
            jQuery('#rs_encashing_wallet_menu_label').closest('tr').hide();
            jQuery('#rs_select_type_to_redirect').closest('tr').hide();
            jQuery('#rs_custom_page_url_after_submit').closest('tr').hide();
            jQuery('#rs_allow_admin_to_save_previous_payment_method').closest('tr').hide();
            jQuery('#rs_select_inc_user_search').closest('tr').hide();
            jQuery('#rs_select_exc_user_search').closest('tr').hide();
            jQuery('#rs_select_inc_userrole').closest('tr').hide();
            jQuery('#rs_select_exc_userrole').closest('tr').hide();
            jQuery('#rs_user_selection_type_for_cashback').closest('tr').hide();
        }
    });

    /*
     * Show or hide for Short Code Settings
     */
    if (jQuery('#rs_select_pagination_for_total_earned_points').val() == '1') {
        jQuery('#rs_value_without_pagination_for_total_earned_points').closest('tr').hide();
    } else {
        jQuery('#rs_value_without_pagination_for_total_earned_points').closest('tr').show();
    }
    jQuery('#rs_select_pagination_for_total_earned_points').change(function () {
        if (jQuery('#rs_select_pagination_for_total_earned_points').val() == '1') {
            jQuery('#rs_value_without_pagination_for_total_earned_points').closest('tr').hide();
        } else {
            jQuery('#rs_value_without_pagination_for_total_earned_points').closest('tr').show();
        }
    });

    if (jQuery('#rs_select_pagination_for_available_points').val() == '1') {
        jQuery('#rs_value_without_pagination_for_available_points').closest('tr').hide();
    } else {
        jQuery('#rs_value_without_pagination_for_available_points').closest('tr').show();
    }
    jQuery('#rs_select_pagination_for_available_points').change(function () {
        if (jQuery('#rs_select_pagination_for_available_points').val() == '1') {
            jQuery('#rs_value_without_pagination_for_available_points').closest('tr').hide();
        } else {
            jQuery('#rs_value_without_pagination_for_available_points').closest('tr').show();
        }
    });

    /* Social Reward Points Setting For Post/Page - Start */
    if ((jQuery('#rs_global_social_enable_disable_reward_post').val()) == '1') {
        jQuery('#rs_global_social_facebook_share_reward_points_post').closest('tr').show();
        jQuery('#rs_global_social_twitter_reward_points_post').closest('tr').show();
        jQuery('#rs_global_social_twitter_follow_reward_points_post').closest('tr').show();
        jQuery('#rs_global_social_google_reward_points_post').closest('tr').show();
        jQuery('#rs_global_social_vk_reward_points_post').closest('tr').show();
        jQuery('#rs_global_social_instagram_reward_points_post').closest('tr').show();
        jQuery('#rs_global_social_ok_follow_reward_points_post').closest('tr').show();
        jQuery('#rs_send_mail_post').closest('tr').show();
        jQuery('#rs_send_mail_post').click(function () {
            if (jQuery(this).is(':checked') == true) {
                jQuery('#rs_email_subject_post').closest('tr').show();
                jQuery('#rs_email_message_post').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_post').closest('tr').hide();
                jQuery('#rs_email_message_post').closest('tr').hide();
            }
        });
        if (jQuery('#rs_send_mail_post').is(':checked') == true) {
            jQuery('#rs_email_subject_post').closest('tr').show();
            jQuery('#rs_email_message_post').closest('tr').show();
        } else {
            jQuery('#rs_email_subject_post').closest('tr').hide();
            jQuery('#rs_email_message_post').closest('tr').hide();
        }
    } else {
        jQuery('#rs_global_social_facebook_share_reward_points_post').closest('tr').hide();
        jQuery('#rs_global_social_facebook_reward_points_post').closest('tr').hide();
        jQuery('#rs_global_social_twitter_reward_points_post').closest('tr').hide();
        jQuery('#rs_global_social_twitter_follow_reward_points_post').closest('tr').hide();
        jQuery('#rs_global_social_google_reward_points_post').closest('tr').hide();
        jQuery('#rs_global_social_vk_reward_points_post').closest('tr').hide();
        jQuery('#rs_global_social_instagram_reward_points_post').closest('tr').hide();
        jQuery('#rs_global_social_ok_follow_reward_points_post').closest('tr').hide();
        jQuery('#rs_send_mail_post').closest('tr').hide();
        jQuery('#rs_email_subject_post').closest('tr').hide();
        jQuery('#rs_email_message_post').closest('tr').hide();
    }
    jQuery('#rs_global_social_enable_disable_reward_post').change(function () {
        if ((jQuery(this).val()) == '1') {
            jQuery('#rs_global_social_facebook_share_reward_points_post').closest('tr').show();
            jQuery('#rs_global_social_twitter_reward_points_post').closest('tr').show();
            jQuery('#rs_global_social_twitter_follow_reward_points_post').closest('tr').show();
            jQuery('#rs_global_social_google_reward_points_post').closest('tr').show();
            jQuery('#rs_global_social_vk_reward_points_post').closest('tr').show();
            jQuery('#rs_global_social_instagram_reward_points_post').closest('tr').show();
            jQuery('#rs_global_social_ok_follow_reward_points_post').closest('tr').show();
            jQuery('#rs_send_mail_post').closest('tr').show();
            jQuery('#rs_send_mail_post').click(function () {
                if (jQuery(this).is(':checked') == true) {
                    jQuery('#rs_email_subject_post').closest('tr').show();
                    jQuery('#rs_email_message_post').closest('tr').show();
                } else {
                    jQuery('#rs_email_subject_post').closest('tr').hide();
                    jQuery('#rs_email_message_post').closest('tr').hide();
                }
            });
            if (jQuery('#rs_send_mail_post').is(':checked') == true) {
                jQuery('#rs_email_subject_post').closest('tr').show();
                jQuery('#rs_email_message_post').closest('tr').show();
            } else {
                jQuery('#rs_email_subject_post').closest('tr').hide();
                jQuery('#rs_email_message_post').closest('tr').hide();
            }
        } else {
            jQuery('#rs_global_social_facebook_share_reward_points_post').closest('tr').hide();
            jQuery('#rs_global_social_facebook_reward_points_post').closest('tr').hide();
            jQuery('#rs_global_social_twitter_reward_points_post').closest('tr').hide();
            jQuery('#rs_global_social_twitter_follow_reward_points_post').closest('tr').hide();
            jQuery('#rs_global_social_google_reward_points_post').closest('tr').hide();
            jQuery('#rs_global_social_vk_reward_points_post').closest('tr').hide();
            jQuery('#rs_global_social_instagram_reward_points_post').closest('tr').hide();
            jQuery('#rs_global_social_ok_follow_reward_points_post').closest('tr').hide();
            jQuery('#rs_send_mail_post').closest('tr').hide();
            jQuery('#rs_email_subject_post').closest('tr').hide();
            jQuery('#rs_email_message_post').closest('tr').hide();
        }
    });

    /*Social Reward Points Setting For Post/Page - End */

    /* Refer a Friend Form Settings -Start */
    if (jQuery('#rs_enable_message_for_friend_form').val() == '1') {
        jQuery('#rs_my_rewards_friend_name_label').closest('tr').show();
        jQuery('#rs_my_rewards_friend_name_placeholder').closest('tr').show();
        jQuery('#rs_my_rewards_friend_email_label').closest('tr').show();
        jQuery('#rs_my_rewards_friend_email_placeholder').closest('tr').show();
        jQuery('#rs_my_rewards_friend_subject_label').closest('tr').show();
        jQuery('#rs_my_rewards_friend_email_subject_placeholder').closest('tr').show();
        jQuery('#rs_my_rewards_friend_message_label').closest('tr').show();
        jQuery('#rs_my_rewards_friend_email_message_placeholder').closest('tr').show();
        jQuery('#rs_allow_user_to_request_prefilled_message').closest('tr').show();
        jQuery('#rs_friend_referral_link').closest('tr').show();
        jQuery('#rs_show_hide_iagree_termsandcondition_field').closest('tr').show();
        if (jQuery('#rs_show_hide_iagree_termsandcondition_field').val() == '2') {
            jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').show();
            jQuery('#rs_refer_friend_termscondition_caption').closest('tr').show();
            jQuery('#rs_refer_friend_termscondition_url').closest('tr').show();
        } else {
            jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').hide();
            jQuery('#rs_refer_friend_termscondition_caption').closest('tr').hide();
            jQuery('#rs_refer_friend_termscondition_url').closest('tr').hide();
        }
    } else {
        jQuery('#rs_my_rewards_friend_name_label').closest('tr').hide();
        jQuery('#rs_my_rewards_friend_name_placeholder').closest('tr').hide();
        jQuery('#rs_my_rewards_friend_email_label').closest('tr').hide();
        jQuery('#rs_my_rewards_friend_email_placeholder').closest('tr').hide();
        jQuery('#rs_my_rewards_friend_subject_label').closest('tr').hide();
        jQuery('#rs_my_rewards_friend_email_subject_placeholder').closest('tr').hide();
        jQuery('#rs_my_rewards_friend_message_label').closest('tr').hide();
        jQuery('#rs_my_rewards_friend_email_message_placeholder').closest('tr').hide();
        jQuery('#rs_allow_user_to_request_prefilled_message').closest('tr').hide();
        jQuery('#rs_friend_referral_link').closest('tr').hide();
        jQuery('#rs_show_hide_iagree_termsandcondition_field').closest('tr').hide();
        jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').hide();
        jQuery('#rs_refer_friend_termscondition_caption').closest('tr').hide();
        jQuery('#rs_refer_friend_termscondition_url').closest('tr').hide();
    }
    jQuery('#rs_enable_message_for_friend_form').change(function () {
        if (jQuery('#rs_enable_message_for_friend_form').val() == '1') {
            jQuery('#rs_my_rewards_friend_name_label').closest('tr').show();
            jQuery('#rs_my_rewards_friend_name_placeholder').closest('tr').show();
            jQuery('#rs_my_rewards_friend_email_label').closest('tr').show();
            jQuery('#rs_my_rewards_friend_email_placeholder').closest('tr').show();
            jQuery('#rs_my_rewards_friend_subject_label').closest('tr').show();
            jQuery('#rs_my_rewards_friend_email_subject_placeholder').closest('tr').show();
            jQuery('#rs_my_rewards_friend_message_label').closest('tr').show();
            jQuery('#rs_my_rewards_friend_email_message_placeholder').closest('tr').show();
            jQuery('#rs_allow_user_to_request_prefilled_message').closest('tr').show();
            jQuery('#rs_friend_referral_link').closest('tr').show();
            jQuery('#rs_show_hide_iagree_termsandcondition_field').closest('tr').show();
            if (jQuery('#rs_show_hide_iagree_termsandcondition_field').val() == '2') {
                jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').show();
                jQuery('#rs_refer_friend_termscondition_caption').closest('tr').show();
                jQuery('#rs_refer_friend_termscondition_url').closest('tr').show();
            } else {
                jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').hide();
                jQuery('#rs_refer_friend_termscondition_caption').closest('tr').hide();
                jQuery('#rs_refer_friend_termscondition_url').closest('tr').hide();
            }
        } else {
            jQuery('#rs_my_rewards_friend_name_label').closest('tr').hide();
            jQuery('#rs_my_rewards_friend_name_placeholder').closest('tr').hide();
            jQuery('#rs_my_rewards_friend_email_label').closest('tr').hide();
            jQuery('#rs_my_rewards_friend_email_placeholder').closest('tr').hide();
            jQuery('#rs_my_rewards_friend_subject_label').closest('tr').hide();
            jQuery('#rs_my_rewards_friend_email_subject_placeholder').closest('tr').hide();
            jQuery('#rs_my_rewards_friend_message_label').closest('tr').hide();
            jQuery('#rs_my_rewards_friend_email_message_placeholder').closest('tr').hide();
            jQuery('#rs_allow_user_to_request_prefilled_message').closest('tr').hide();
            jQuery('#rs_friend_referral_link').closest('tr').hide();
            jQuery('#rs_show_hide_iagree_termsandcondition_field').closest('tr').hide();
            jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').hide();
            jQuery('#rs_refer_friend_termscondition_caption').closest('tr').hide();
            jQuery('#rs_refer_friend_termscondition_url').closest('tr').hide();
        }
    });

    /*Show or hide Settings for My Account Tab - Start*/
    jQuery('#rs_show_hide_iagree_termsandcondition_field').change(function () {
        if (jQuery('#rs_show_hide_iagree_termsandcondition_field').val() == '2') {
            jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').show();
            jQuery('#rs_refer_friend_termscondition_caption').closest('tr').show();
            jQuery('#rs_refer_friend_termscondition_url').closest('tr').show();
        } else {
            jQuery('#rs_refer_friend_iagreecaption_link').closest('tr').hide();
            jQuery('#rs_refer_friend_termscondition_caption').closest('tr').hide();
            jQuery('#rs_refer_friend_termscondition_url').closest('tr').hide();
        }
    });
    /*Show or hide Settings for My Account Tab - End*/

    /*Show or Hide Referrer Label Settings - Start*/
    if (jQuery('#rs_show_hide_generate_referral_message').val() == '1') {
        jQuery('#rs_show_hide_generate_referral_message_text').closest('tr').show();
    } else {
        jQuery('#rs_show_hide_generate_referral_message_text').closest('tr').hide();
    }

    jQuery('#rs_show_hide_generate_referral_message').change(function () {
        if (jQuery('#rs_show_hide_generate_referral_message').val() == '1') {
            jQuery('#rs_show_hide_generate_referral_message_text').closest('tr').show();
        } else {
            jQuery('#rs_show_hide_generate_referral_message_text').closest('tr').hide();
        }
    });

    if (jQuery('#rs_enable_referral_link_limit').is(':checked') == true) {
        jQuery('#rs_referral_link_limit').closest('tr').show();
    } else {
        jQuery('#rs_referral_link_limit').closest('tr').hide();
    }

    jQuery('#rs_enable_referral_link_limit').change(function () {
        if (jQuery('#rs_enable_referral_link_limit').is(':checked') == true) {
            jQuery('#rs_referral_link_limit').closest('tr').show();
        } else {
            jQuery('#rs_referral_link_limit').closest('tr').hide();
        }
    });

    /*Show or Hide Referrer Label Settings - Start*/
    /* Refer a Friend Form Settings - End */

    /*Show/Hide for Point Price in Bulk Update Settings - Start*/
    if (jQuery('#rs_local_enable_disable_point_price').val() == '1') {
        jQuery('#rs_local_point_pricing_type').closest('tr').show();

        /*Show/Hide for Currency & Point Pricing Option in Bulk Update Settings - Start*/
        if (jQuery('#rs_local_point_pricing_type').val() == '1') {
            jQuery('#rs_local_point_price_type').closest('tr').show();

            /*Show/Hide for Fixed/Conversion Option in Bulk Update Settings - Start*/
            if (jQuery('#rs_local_point_price_type').val() == '1') {
                jQuery('#rs_local_price_points').closest('tr').show();
            } else {
                jQuery('#rs_local_price_points').closest('tr').hide();
            }

            jQuery('#rs_local_point_price_type').change(function () {
                if (jQuery('#rs_local_point_price_type').val() == '1') {
                    jQuery('#rs_local_price_points').closest('tr').show();
                } else {
                    jQuery('#rs_local_price_points').closest('tr').hide();
                }
            });
            /*Show/Hide for Fixed/Conversion Option in Bulk Update Settings - End*/
        } else {
            jQuery('#rs_local_point_price_type').closest('tr').hide();
            jQuery('#rs_local_price_points').closest('tr').show();
        }

        jQuery('#rs_local_point_pricing_type').change(function () {
            if (jQuery('#rs_local_point_pricing_type').val() == '1') {
                jQuery('#rs_local_point_price_type').closest('tr').show();

                /*Show/Hide for Fixed/Conversion Option in Bulk Update Settings - Start*/
                if (jQuery('#rs_local_point_price_type').val() == '1') {
                    jQuery('#rs_local_price_points').closest('tr').show();
                } else {
                    jQuery('#rs_local_price_points').closest('tr').hide();
                }

                jQuery('#rs_local_point_price_type').change(function () {
                    if (jQuery('#rs_local_point_price_type').val() == '1') {
                        jQuery('#rs_local_price_points').closest('tr').show();
                    } else {
                        jQuery('#rs_local_price_points').closest('tr').hide();
                    }
                });
                /*Show/Hide for Fixed/Conversion Option in Bulk Update Settings - End*/
            } else {
                jQuery('#rs_local_point_price_type').closest('tr').hide();
                jQuery('#rs_local_price_points').closest('tr').show();
            }
        });
        /*Show/Hide for Currency & Point Pricing Option in Bulk Update Settings - End*/
    } else {
        jQuery('#rs_local_point_pricing_type').closest('tr').hide();
        jQuery('#rs_local_point_price_type').closest('tr').hide();
        jQuery('#rs_local_price_points').closest('tr').hide();
    }

    jQuery('#rs_local_enable_disable_point_price').change(function () {
        if (jQuery('#rs_local_enable_disable_point_price').val() == '1') {
            jQuery('#rs_local_point_pricing_type').closest('tr').show();

            /*Show/Hide for Currency & Point Pricing Option in Bulk Update Settings - Start*/
            if (jQuery('#rs_local_point_pricing_type').val() == '1') {
                jQuery('#rs_local_point_price_type').closest('tr').show();

                /*Show/Hide for Fixed/Conversion Option in Bulk Update Settings - Start*/
                if (jQuery('#rs_local_point_price_type').val() == '1') {
                    jQuery('#rs_local_price_points').closest('tr').show();
                } else {
                    jQuery('#rs_local_price_points').closest('tr').hide();
                }

                jQuery('#rs_local_point_price_type').change(function () {
                    if (jQuery('#rs_local_point_price_type').val() == '1') {
                        jQuery('#rs_local_price_points').closest('tr').show();
                    } else {
                        jQuery('#rs_local_price_points').closest('tr').hide();
                    }
                });
                /*Show/Hide for Fixed/Conversion Option in Bulk Update Settings - End*/
            } else {
                jQuery('#rs_local_point_price_type').closest('tr').hide();
                jQuery('#rs_local_price_points').closest('tr').show();
            }

            jQuery('#rs_local_point_pricing_type').change(function () {
                if (jQuery('#rs_local_point_pricing_type').val() == '1') {
                    jQuery('#rs_local_point_price_type').closest('tr').show();

                    /*Show/Hide for Fixed/Conversion Option in Bulk Update Settings - Start*/
                    if (jQuery('#rs_local_point_price_type').val() == '1') {
                        jQuery('#rs_local_price_points').closest('tr').show();
                    } else {
                        jQuery('#rs_local_price_points').closest('tr').hide();
                    }

                    jQuery('#rs_local_point_price_type').change(function () {
                        if (jQuery('#rs_local_point_price_type').val() == '1') {
                            jQuery('#rs_local_price_points').closest('tr').show();
                        } else {
                            jQuery('#rs_local_price_points').closest('tr').hide();
                        }
                    });
                    /*Show/Hide for Fixed/Conversion Option in Bulk Update Settings - End*/
                } else {
                    jQuery('#rs_local_point_price_type').closest('tr').hide();
                    jQuery('#rs_local_price_points').closest('tr').show();
                }
            });
            /*Show/Hide for Currency & Point Pricing Option in Bulk Update Settings - End*/
        } else {
            jQuery('#rs_local_point_pricing_type').closest('tr').hide();
            jQuery('#rs_local_point_price_type').closest('tr').hide();
            jQuery('#rs_local_price_points').closest('tr').hide();
        }
    });
    /*Show/Hide for Point Price in Bulk Update Settings - End*/
});